<?php

  /**
  * config.php
  *
  * @author Joe Stump <joe@joestump.net>
  * @copyright Joe Stump <joe@joestump.net> 
  * @license http://www.opensource.org/licenses/gpl-license.php
  * @package Framework
  * @filesource
  */

  /**
  * FR_BASE_PATH
  *
  * Dynamically figure out where in the filesystem we are located.
  *
  * @author Joe Stump <joe@joestump.net>
  * @global string FR_BASE_PATH Absolute path to our framework
  */
  define('FR_BASE_PATH',dirname(__FILE__));

  /**
  * FR_DSN
  *
  * This is a DSN formatted according to PEAR DB's specifications. 
  *
  * @author Joe Stump <joe@joestump.net>
  * @global string FR_DSN PEAR DB compatible DSN 
  * @link http://pear.php.net/package/DB
  */
  define('FR_DSN','mysql://root@localhost/framework');

  /**
  * FR_LOG_FILE
  * 
  * Path to centralized log file that can be accessed directly from our
  * application classes.
  *
  * @author Joe Stump <joe@joestump.net> 
  * @global string FR_LOG_FILE Path to log file
  * @link http://pear.php.net/package/Log
  */
  define('FR_LOG_FILE','/tmp/fr.log');

  /**
  * SMARTY_DIR
  *
  * @author Joe Stump <joe@joestump.net>
  * @global string SMARTY_DIR Path to Smarty install
  * @link http://smarty.php.net
  */
  define('SMARTY_DIR',FR_BASE_PATH.'/includes/Smarty/');

  /**
  * FR_TEMPLATE
  *
  * This defines our outer page template. You could, optionally, define this
  * based on cookie settings (to allow users to switch or choose layouts and
  * templates).
  *
  * @author Joe Stump <joe@joestump.net>
  * @global string FR_TEMPLATE Name of outer page template
  */
  define('FR_TEMPLATE','default');
  
  /**
   * PEAR_DIR
   * 
   * Esta constante define donde se encuentran las librerias de PEAR utilizadas en esta aplicacion
   * @author J.Emilio Navarro
   * @global string PEAR_DIR Path a la instalacion 
   * @link http://pear.php.net/
   * */
  
   define('PEAR_DIR',FR_BASE_PATH.'/includes/pear/');
   
   /**
   * MULTIMEDIA_DIR
   * 
   * Esta constante define donde se encuentra el modulo multimedia para tener acces al fichero configuracion
   * @author J.Emilio Navarro
   * @global string MULTIMEDIA_DIR Path a la instalacion 
   * 
   * */
   define('MULTIMEDIA_DIR',FR_BASE_PATH.'/includes/Multimedia/');   
   set_include_path(FR_BASE_PATH.'/includes/dao'. PATH_SEPARATOR . FR_BASE_PATH.'/includes/Model'. PATH_SEPARATOR . get_include_path());
   
   
   define('TYPE_HTTP','http://');
      
   /**
    * Directorio donde esta almacenado el projecto 
    **/
   
   define('PROJECT_DIR','/feelMusic');
   
    /**
    * Web path,    
    **/   
   define('WEB_PATH',TYPE_HTTP.$_SERVER['HTTP_HOST'].PROJECT_DIR);
   
   
   /**
   * Site charset:    
   **/   
   define('SITE_CHARSET','iso-8859-1');
   //Utilizado el funcion Fr_Miscelanea:: truncate_with_ellipsis, 
   //Si pongo utf-8, hay que poner-lo en la funcion en un parmetro especificox
   
   /* 
    * DIRECTORIO PARA MULTIMEDIA
    **/	
   define('MULTIMEDIA_UPLOADS','uploads/');

?>
