<?php
/*
 *                        GetModelObjects.php
 *                    ------------------
 * Creado            : 05-ago-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 

class FR_GetModelObjects {
 	
 	             /*Obtencion de los objetos de la base de datos  S O N G  */
      public static function getObjectSong($idSong) {
      	
      	try{
      		
      		$song = SongPeer::retrieveByPK($idSong); 
      		if($song != null ) return $song;
      		else return false;
      		
      	}
      	catch(PropelException $ex){
      		
      		return false;
      	}
      	
      }
      
      /*Obtencion de los objetos de la base de datos  A R T I S T  */
      public static function getObjectArtist($idArtist) {
      	
      	try{
      		
      		$artist = ArtistPeer::retrieveByPK($idArtist);
      		//echo "VALOR DE ARTISTA".$artist->getArtistname();
      		if($artist != null ) return $artist;
      		else return false;
      		
      	}
      	catch(PropelException $ex){
      		
      		return false;
      	}
      	
      }
      
      /* Obtencion de los objetos de la base de datos  A L B U M  */
      public static function getObjectAlbum($idAlbum) {
      	
      	try{
      		
      		$album = AlbumPeer::retrieveByPK($idAlbum,FR_Util_Const::CONST_ALBUM);
      		if($album != null ) return $album;
      		else return false;
      		
      	}
      	catch(PropelException $ex){
      		
      		return false;
      	}
      	
      }
      
      /* Obtencion de los objetos de la base de datos  G E N E R E  */
      public static function getObjectGenere($idGenere) {
      	
      	try{
      		
      		$genere = GenerePeer::retrieveByPK($idGenere); 
      		if($genere != null ) return $genere;
      		else return false;
      	}
      	catch(PropelException $ex){
      		
      		return false;
      	}
      	
      }
      
     /* Obtencion de los objetos de la base de datos  P L A Y L I S T  */
      public static function getObjectPlayList($idPlayList) {
      	
      	try{
      		
      		$playList = PlaylistPeer::retrieveByPK($idPlayList);
      		if($playList != null ) return $playList;
      		else return false; 
      		
      	}
      	catch(PropelException $ex){
      		
      		return false;
      	}
      	
      }
      
 	      
      
      /* 
       * Devuelve las canciones que no tienen la emocion idEmotion, definida
       * en la table "user_use_play"       * 
       * */
      public static function getObjectUserUsePlayNotEmotion($idEmotion,$userID) {
      	
      	try {
      		$c = new Criteria();      
			$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG);			
			$c -> addAnd(UserUsePlayPeer::USERID,$userID); /*Usuario ficticio de la aplicacion 1 */
			$c -> addAnd(UserUsePlayPeer::IDEMOTION,$idEmotion,Criteria::ALT_NOT_EQUAL);		
	
			$rs = UserUsePlayPeer::doSelect($c);
			
			if( count($rs) > 0) return $rs;
			else return false;			
			//echo "<br/>RESULTADO CRITERIA:".$result;    		
      		
      	}
      	catch(PropelException $ex) {
      		//echo "ERROR".$ex->getCause()->getMessage();
      		return false;	
      	
      	}     	
      }
      
      public static function getUserObservations($userID) {
      	
      	try{
      			$c = new Criteria();		
				$c->add(ObservationsPeer::USERID,$userID);
									
				$rs = ObservationsPeer::doSelect($c);
			
				if( $rs[0]!= null) return $rs;
				else return false;				
      	}	
      	catch(PropelException $ex) {
      		//echo "ERROR".$ex->getCause()->getMessage();
      		return false;    	
         }
      }
      
      /* Agenda Events */
      
      public static function getUserEvents($userID) {
      	
      	try{
      			$c = new Criteria();
      			$c ->addAscendingOrderByColumn(AgendaPeer::NOTICEDATE);	
      			//Cojer los que ha un no han pasado!!!
      		
      			$date = date("Y-m-d");/*Es el formato que hay guardado en la base de datos.*/      			
      			$c ->addAnd(AgendaPeer::NOTICEDATE,$date,Criteria::GREATER_EQUAL); //LESS_EQUAL,GREATER_EQUALMes gran= InitDate	
				$c->add(AgendaPeer::USERID,$userID);
									
				$rs = AgendaPeer::doSelect($c);
			
				if( $rs[0]!= null) return $rs;
				else return false;				
      	}	
      	catch(PropelException $ex) {
      		//echo "ERROR".$ex->getCause()->getMessage();
      		return false;    	
         }
      }
      
      public static function getTodayEvents($userID){
      	
      	try{
      		
      		$c = new Criteria();      		    		
			$date = date("Y-m-d");/*Es el formato que hay guardado en la base de datos.*/      			
      		$c -> add(AgendaPeer::NOTICEDATE,$date,Criteria::EQUAL); //LESS_EQUAL,GREATER_EQUALMes gran= InitDate//, 
			$c -> addAnd(AgendaPeer::USERID,$userID); /* Usuario ficticio de la aplicacion 1 */			
	    	$rs = AgendaPeer::doSelect($c);
	    	if($rs[0]!= null) return $rs;
	    	else return false;      		
      	}
      	catch(PropelException $ex){     		
           		
      		return false;      	
      	}
      }
      
      public static function getObservationEvents($observationID) {
      	
      try{
      		
      		$c = new Criteria();	 
			$c -> add(AgendaPeer::IDOBSERVATION,$observationID); 		
	    	$rs = AgendaPeer::doSelect($c);
	    	if($rs[0]!= null) return $rs;
	    	else return false;      		
      	}
      	catch(PropelException $ex){     		
           		
      		return false;      	
      	}
      }//fin getObservationEvents      
           
 }
 
?>