<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/UserUsePlayPeer.php';

/**
 * Base class that represents a row from the 'User_Use_Play' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 07/24/06 08:55:24
 *
 * @package Model.om
 */
abstract class BaseUserUsePlay extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserUsePlayPeer
	 */
	protected static $peer;


	/**
	 * The value for the iduseruseplay field.
	 * @var int
	 */
	protected $iduseruseplay;


	/**
	 * The value for the idemotion field.
	 * @var int
	 */
	protected $idemotion;


	/**
	 * The value for the idmusicelementtype field.
	 * @var int
	 */
	protected $idmusicelementtype;


	/**
	 * The value for the idobservation field.
	 * @var int
	 */
	protected $idobservation;


	/**
	 * The value for the userid field.
	 * @var int
	 */
	protected $userid;


	/**
	 * The value for the countplay field.
	 * @var int
	 */
	protected $countplay = 0;


	/**
	 * The value for the firstplaydate field.
	 * @var int
	 */
	protected $firstplaydate;


	/**
	 * The value for the lastplaydate field.
	 * @var int
	 */
	protected $lastplaydate;


	/**
	 * The value for the elempunctuation field.
	 * @var int
	 */
	protected $elempunctuation = 0;


	/**
	 * The value for the idmusicelement field.
	 * @var int
	 */
	protected $idmusicelement = 0;

	/**
	 * @var Emotions
	 */
	protected $aEmotions;

	/**
	 * @var Users
	 */
	protected $aUsers;

	/**
	 * @var Observations
	 */
	protected $aObservations;

	/**
	 * @var MusicElementType
	 */
	protected $aMusicElementType;

	/**
	 * Collection to store aggregation of collReprodHists.
	 * @var array
	 */
	protected $collReprodHists;
	
	/**
	 * The criteria used to select the current contents of collReprodHists.
	 * @var Criteria
	 */
	private $lastReprodHistCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [iduseruseplay] column value.
	 * 
	 * @return int
	 */
	public function getIduseruseplay()
	{

		return $this->iduseruseplay;
	}

	/**
	 * Get the [idemotion] column value.
	 * 
	 * @return int
	 */
	public function getIdemotion()
	{

		return $this->idemotion;
	}

	/**
	 * Get the [idmusicelementtype] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelementtype()
	{

		return $this->idmusicelementtype;
	}

	/**
	 * Get the [idobservation] column value.
	 * 
	 * @return int
	 */
	public function getIdobservation()
	{

		return $this->idobservation;
	}

	/**
	 * Get the [userid] column value.
	 * 
	 * @return int
	 */
	public function getUserid()
	{

		return $this->userid;
	}

	/**
	 * Get the [countplay] column value.
	 * 
	 * @return int
	 */
	public function getCountplay()
	{

		return $this->countplay;
	}

	/**
	 * Get the [optionally formatted] [firstplaydate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getFirstplaydate($format = '%x')
	{

		if ($this->firstplaydate === null || $this->firstplaydate === '') {
			return null;
		} elseif (!is_int($this->firstplaydate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->firstplaydate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [firstplaydate] as date/time value: " . var_export($this->firstplaydate, true));
			}
		} else {
			$ts = $this->firstplaydate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [lastplaydate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getLastplaydate($format = '%x')
	{

		if ($this->lastplaydate === null || $this->lastplaydate === '') {
			return null;
		} elseif (!is_int($this->lastplaydate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->lastplaydate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [lastplaydate] as date/time value: " . var_export($this->lastplaydate, true));
			}
		} else {
			$ts = $this->lastplaydate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [elempunctuation] column value.
	 * 
	 * @return int
	 */
	public function getElempunctuation()
	{

		return $this->elempunctuation;
	}

	/**
	 * Get the [idmusicelement] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelement()
	{

		return $this->idmusicelement;
	}

	/**
	 * Set the value of [iduseruseplay] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIduseruseplay($v)
	{

		if ($this->iduseruseplay !== $v) {
			$this->iduseruseplay = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::IDUSERUSEPLAY;
		}

	} // setIduseruseplay()

	/**
	 * Set the value of [idemotion] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdemotion($v)
	{

		if ($this->idemotion !== $v) {
			$this->idemotion = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::IDEMOTION;
		}

		if ($this->aEmotions !== null && $this->aEmotions->getIdemotion() !== $v) {
			$this->aEmotions = null;
		}		

	} // setIdemotion()

	/**
	 * Set the value of [idmusicelementtype] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelementtype($v)
	{

		if ($this->idmusicelementtype !== $v) {
			$this->idmusicelementtype = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::IDMUSICELEMENTTYPE;
		}

		if ($this->aMusicElementType !== null && $this->aMusicElementType->getIdmusicelementtype() !== $v) {
			$this->aMusicElementType = null;
		}		

	} // setIdmusicelementtype()

	/**
	 * Set the value of [idobservation] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdobservation($v)
	{

		if ($this->idobservation !== $v) {
			$this->idobservation = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::IDOBSERVATION;
		}

		if ($this->aObservations !== null && $this->aObservations->getIdobservation() !== $v) {
			$this->aObservations = null;
		}		

	} // setIdobservation()

	/**
	 * Set the value of [userid] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUserid($v)
	{

		if ($this->userid !== $v) {
			$this->userid = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::USERID;
		}

		if ($this->aUsers !== null && $this->aUsers->getUserid() !== $v) {
			$this->aUsers = null;
		}		

	} // setUserid()

	/**
	 * Set the value of [countplay] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setCountplay($v)
	{

		if ($this->countplay !== $v || $v === 0) {
			$this->countplay = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::COUNTPLAY;
		}

	} // setCountplay()

	/**
	 * Set the value of [firstplaydate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setFirstplaydate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [firstplaydate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->firstplaydate !== $ts) {
			$this->firstplaydate = $ts;
			$this->modifiedColumns[] = UserUsePlayPeer::FIRSTPLAYDATE;
		}

	} // setFirstplaydate()

	/**
	 * Set the value of [lastplaydate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setLastplaydate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [lastplaydate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->lastplaydate !== $ts) {
			$this->lastplaydate = $ts;
			$this->modifiedColumns[] = UserUsePlayPeer::LASTPLAYDATE;
		}

	} // setLastplaydate()

	/**
	 * Set the value of [elempunctuation] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setElempunctuation($v)
	{

		if ($this->elempunctuation !== $v || $v === 0) {
			$this->elempunctuation = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::ELEMPUNCTUATION;
		}

	} // setElempunctuation()

	/**
	 * Set the value of [idmusicelement] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelement($v)
	{

		if ($this->idmusicelement !== $v || $v === 0) {
			$this->idmusicelement = $v;
			$this->modifiedColumns[] = UserUsePlayPeer::IDMUSICELEMENT;
		}

	} // setIdmusicelement()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->iduseruseplay = $rs->getInt($startcol + 0);

			$this->idemotion = $rs->getInt($startcol + 1);

			$this->idmusicelementtype = $rs->getInt($startcol + 2);

			$this->idobservation = $rs->getInt($startcol + 3);

			$this->userid = $rs->getInt($startcol + 4);

			$this->countplay = $rs->getInt($startcol + 5);

			$this->firstplaydate = $rs->getDate($startcol + 6, null);

			$this->lastplaydate = $rs->getDate($startcol + 7, null);

			$this->elempunctuation = $rs->getInt($startcol + 8);

			$this->idmusicelement = $rs->getInt($startcol + 9);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 10; // 10 = UserUsePlayPeer::NUM_COLUMNS - UserUsePlayPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating UserUsePlay object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserUsePlayPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UserUsePlayPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserUsePlayPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aEmotions !== null) {
				if ($this->aEmotions->isModified()) {
					$affectedRows += $this->aEmotions->save($con);
				}
				$this->setEmotions($this->aEmotions);
			}

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aObservations !== null) {
				if ($this->aObservations->isModified()) {
					$affectedRows += $this->aObservations->save($con);
				}
				$this->setObservations($this->aObservations);
			}

			if ($this->aMusicElementType !== null) {
				if ($this->aMusicElementType->isModified()) {
					$affectedRows += $this->aMusicElementType->save($con);
				}
				$this->setMusicElementType($this->aMusicElementType);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserUsePlayPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setIduseruseplay($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += UserUsePlayPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collReprodHists !== null) {
				foreach($this->collReprodHists as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aEmotions !== null) {
				if (!$this->aEmotions->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aEmotions->getValidationFailures());
				}
			}

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aObservations !== null) {
				if (!$this->aObservations->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aObservations->getValidationFailures());
				}
			}

			if ($this->aMusicElementType !== null) {
				if (!$this->aMusicElementType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMusicElementType->getValidationFailures());
				}
			}


			if (($retval = UserUsePlayPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collReprodHists !== null) {
					foreach($this->collReprodHists as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UserUsePlayPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIduseruseplay();
				break;
			case 1:
				return $this->getIdemotion();
				break;
			case 2:
				return $this->getIdmusicelementtype();
				break;
			case 3:
				return $this->getIdobservation();
				break;
			case 4:
				return $this->getUserid();
				break;
			case 5:
				return $this->getCountplay();
				break;
			case 6:
				return $this->getFirstplaydate();
				break;
			case 7:
				return $this->getLastplaydate();
				break;
			case 8:
				return $this->getElempunctuation();
				break;
			case 9:
				return $this->getIdmusicelement();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UserUsePlayPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIduseruseplay(),
			$keys[1] => $this->getIdemotion(),
			$keys[2] => $this->getIdmusicelementtype(),
			$keys[3] => $this->getIdobservation(),
			$keys[4] => $this->getUserid(),
			$keys[5] => $this->getCountplay(),
			$keys[6] => $this->getFirstplaydate(),
			$keys[7] => $this->getLastplaydate(),
			$keys[8] => $this->getElempunctuation(),
			$keys[9] => $this->getIdmusicelement(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UserUsePlayPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIduseruseplay($value);
				break;
			case 1:
				$this->setIdemotion($value);
				break;
			case 2:
				$this->setIdmusicelementtype($value);
				break;
			case 3:
				$this->setIdobservation($value);
				break;
			case 4:
				$this->setUserid($value);
				break;
			case 5:
				$this->setCountplay($value);
				break;
			case 6:
				$this->setFirstplaydate($value);
				break;
			case 7:
				$this->setLastplaydate($value);
				break;
			case 8:
				$this->setElempunctuation($value);
				break;
			case 9:
				$this->setIdmusicelement($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UserUsePlayPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIduseruseplay($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdemotion($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setIdmusicelementtype($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setIdobservation($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setUserid($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setCountplay($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setFirstplaydate($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setLastplaydate($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setElempunctuation($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setIdmusicelement($arr[$keys[9]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(UserUsePlayPeer::DATABASE_NAME);

		if ($this->isColumnModified(UserUsePlayPeer::IDUSERUSEPLAY)) $criteria->add(UserUsePlayPeer::IDUSERUSEPLAY, $this->iduseruseplay);
		if ($this->isColumnModified(UserUsePlayPeer::IDEMOTION)) $criteria->add(UserUsePlayPeer::IDEMOTION, $this->idemotion);
		if ($this->isColumnModified(UserUsePlayPeer::IDMUSICELEMENTTYPE)) $criteria->add(UserUsePlayPeer::IDMUSICELEMENTTYPE, $this->idmusicelementtype);
		if ($this->isColumnModified(UserUsePlayPeer::IDOBSERVATION)) $criteria->add(UserUsePlayPeer::IDOBSERVATION, $this->idobservation);
		if ($this->isColumnModified(UserUsePlayPeer::USERID)) $criteria->add(UserUsePlayPeer::USERID, $this->userid);
		if ($this->isColumnModified(UserUsePlayPeer::COUNTPLAY)) $criteria->add(UserUsePlayPeer::COUNTPLAY, $this->countplay);
		if ($this->isColumnModified(UserUsePlayPeer::FIRSTPLAYDATE)) $criteria->add(UserUsePlayPeer::FIRSTPLAYDATE, $this->firstplaydate);
		if ($this->isColumnModified(UserUsePlayPeer::LASTPLAYDATE)) $criteria->add(UserUsePlayPeer::LASTPLAYDATE, $this->lastplaydate);
		if ($this->isColumnModified(UserUsePlayPeer::ELEMPUNCTUATION)) $criteria->add(UserUsePlayPeer::ELEMPUNCTUATION, $this->elempunctuation);
		if ($this->isColumnModified(UserUsePlayPeer::IDMUSICELEMENT)) $criteria->add(UserUsePlayPeer::IDMUSICELEMENT, $this->idmusicelement);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UserUsePlayPeer::DATABASE_NAME);

		$criteria->add(UserUsePlayPeer::IDUSERUSEPLAY, $this->iduseruseplay);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getIduseruseplay();
	}

	/**
	 * Generic method to set the primary key (iduseruseplay column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setIduseruseplay($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of UserUsePlay (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdemotion($this->idemotion);

		$copyObj->setIdmusicelementtype($this->idmusicelementtype);

		$copyObj->setIdobservation($this->idobservation);

		$copyObj->setUserid($this->userid);

		$copyObj->setCountplay($this->countplay);

		$copyObj->setFirstplaydate($this->firstplaydate);

		$copyObj->setLastplaydate($this->lastplaydate);

		$copyObj->setElempunctuation($this->elempunctuation);

		$copyObj->setIdmusicelement($this->idmusicelement);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getReprodHists() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addReprodHist($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setIduseruseplay(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return UserUsePlay Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return UserUsePlayPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserUsePlayPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Emotions object.
	 *
	 * @param Emotions $v
	 * @return void
	 * @throws PropelException
	 */
	public function setEmotions($v)
	{


		if ($v === null) {
			$this->setIdemotion(NULL);
		} else {
			$this->setIdemotion($v->getIdemotion());
		}


		$this->aEmotions = $v;
	}


	/**
	 * Get the associated Emotions object
	 *
	 * @param Connection Optional Connection object.
	 * @return Emotions The associated Emotions object.
	 * @throws PropelException
	 */
	public function getEmotions($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseEmotionsPeer.php';

		if ($this->aEmotions === null && ($this->idemotion !== null)) {

			$this->aEmotions = EmotionsPeer::retrieveByPK($this->idemotion, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = EmotionsPeer::retrieveByPK($this->idemotion, $con);
			   $obj->addEmotionss($this);
			 */
		}
		return $this->aEmotions;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param Users $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUsers($v)
	{


		if ($v === null) {
			$this->setUserid(NULL);
		} else {
			$this->setUserid($v->getUserid());
		}


		$this->aUsers = $v;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param Connection Optional Connection object.
	 * @return Users The associated Users object.
	 * @throws PropelException
	 */
	public function getUsers($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseUsersPeer.php';

		if ($this->aUsers === null && ($this->userid !== null)) {

			$this->aUsers = UsersPeer::retrieveByPK($this->userid, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UsersPeer::retrieveByPK($this->userid, $con);
			   $obj->addUserss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a Observations object.
	 *
	 * @param Observations $v
	 * @return void
	 * @throws PropelException
	 */
	public function setObservations($v)
	{


		if ($v === null) {
			$this->setIdobservation(NULL);
		} else {
			$this->setIdobservation($v->getIdobservation());
		}


		$this->aObservations = $v;
	}


	/**
	 * Get the associated Observations object
	 *
	 * @param Connection Optional Connection object.
	 * @return Observations The associated Observations object.
	 * @throws PropelException
	 */
	public function getObservations($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseObservationsPeer.php';

		if ($this->aObservations === null && ($this->idobservation !== null)) {

			$this->aObservations = ObservationsPeer::retrieveByPK($this->idobservation, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ObservationsPeer::retrieveByPK($this->idobservation, $con);
			   $obj->addObservationss($this);
			 */
		}
		return $this->aObservations;
	}

	/**
	 * Declares an association between this object and a MusicElementType object.
	 *
	 * @param MusicElementType $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMusicElementType($v)
	{


		if ($v === null) {
			$this->setIdmusicelementtype(NULL);
		} else {
			$this->setIdmusicelementtype($v->getIdmusicelementtype());
		}


		$this->aMusicElementType = $v;
	}


	/**
	 * Get the associated MusicElementType object
	 *
	 * @param Connection Optional Connection object.
	 * @return MusicElementType The associated MusicElementType object.
	 * @throws PropelException
	 */
	public function getMusicElementType($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseMusicElementTypePeer.php';

		if ($this->aMusicElementType === null && ($this->idmusicelementtype !== null)) {

			$this->aMusicElementType = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
			   $obj->addMusicElementTypes($this);
			 */
		}
		return $this->aMusicElementType;
	}

	/**
	 * Temporary storage of collReprodHists to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initReprodHists()
	{
		if ($this->collReprodHists === null) {
			$this->collReprodHists = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UserUsePlay has previously
	 * been saved, it will retrieve related ReprodHists from storage.
	 * If this UserUsePlay is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getReprodHists($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseReprodHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collReprodHists === null) {
			if ($this->isNew()) {
			   $this->collReprodHists = array();
			} else {

				$criteria->add(ReprodHistPeer::IDUSERUSEPLAY, $this->getIduseruseplay());

				ReprodHistPeer::addSelectColumns($criteria);
				$this->collReprodHists = ReprodHistPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ReprodHistPeer::IDUSERUSEPLAY, $this->getIduseruseplay());

				ReprodHistPeer::addSelectColumns($criteria);
				if (!isset($this->lastReprodHistCriteria) || !$this->lastReprodHistCriteria->equals($criteria)) {
					$this->collReprodHists = ReprodHistPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastReprodHistCriteria = $criteria;
		return $this->collReprodHists;
	}

	/**
	 * Returns the number of related ReprodHists.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countReprodHists($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseReprodHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ReprodHistPeer::IDUSERUSEPLAY, $this->getIduseruseplay());

		return ReprodHistPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a ReprodHist object to this object
	 * through the ReprodHist foreign key attribute
	 *
	 * @param ReprodHist $l ReprodHist
	 * @return void
	 * @throws PropelException
	 */
	public function addReprodHist(ReprodHist $l)
	{
		$this->collReprodHists[] = $l;
		$l->setUserUsePlay($this);
	}

} // BaseUserUsePlay
