<?php

require_once 'Model/om/BaseSong.php';


/**
 * Skeleton subclass for representing a row from the 'Song' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 06/10/06 14:05:31
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package Model
 */	
class Song extends BaseSong {
const LIT_NO_DISPONIBLE = "NO_DISPONIBLE";

	public function visualitzar()
	{		
		echo "<br/> Informaci T E C N I C A:";
		echo "<br/> RUTA: ".$this->getUrlfile();	
		echo "<br/> NOMBRE ARXIU: ".$this->getFilename();
		echo "<br/> Formato fichero: ".$this->getFormat();
		echo "<br/> TAMAMNYO: ".$this->getFilesize(); 
		echo "<br/> DURACIO: ".$this->getTime(); 	
		echo "<br/> BITRATE: ".$this->getBitrate(); 
        echo "<br/> MIME: ".$this->getMime(); 
        echo "<br/> CANAL: ".$this->getMode();				
		
		echo "<br/> <br/> Informaci A R T I S T I C A:";
		echo "<br/> TITLE: ".$this->getSongName();
		
		if(null != $this->getAlbum()) {
			
			echo "<br/> ALBUM: ".$this->getAlbum()->getAlbumname();
			echo "<br/> YEAR: ".$this->getAlbum()->getAlbumyear();
		}
		else {
			echo "<br/> ALBUM: ".self::LIT_NO_DISPONIBLE;
			echo "<br/> YEAR: ".self::LIT_NO_DISPONIBLE;				
		}
		
		if (null != $this->getArtist()) echo "<br/> ARTISTA: ".$this->getArtista()->getArtistname();
		else "<br/> ARTISTA: ".	self::LIT_NO_DISPONIBLE;
		
		if (null != $this->getGenere()) echo "<br/> GENERE : ".$this->getGenere()->getNomGenere();	
		else "<br/> GENERE: ".	self::LIT_NO_DISPONIBLE;			
		echo "<br/> TRACK: ".$this->getTrack();					
	}	


/*!
		@function format_song
		@discussion this takes a song object
			and formats it for display
			and returns the object cleaned up
	*/
	public function format_song() {

		// Format the filename
		preg_match("/^.*\/(.*?)$/",$this->getUrlfile(), $short);
		$this->f_file = htmlspecialchars($short[1]);
		    
		// Format the album name
		
		$this->f_album_full = $this->getAlbum()->getAlbumname();
		$this->f_album = FR_Util_Miscelanea::truncate_with_ellipse($this->f_album_full);

		// Format the artist name
		$this->f_artist_full = $this->getArtist()->getArtistname();
		$this->f_artist = FR_Util_Miscelanea::truncate_with_ellipse($this->f_artist_full);

		// Format the title
		$this->f_title = FR_Util_Miscelanea::truncate_with_ellipse($this->getSongname());

		// Create A link inclduing the title
		$this->f_link = "<a href=\"" . WEB_PATH . "/song.php?action=m3u&amp;song=" . $this->getIdsong(). "\">$this->f_title</a>";

		// Format the Bitrate
		$this->f_bitrate = intval($this->getBitrate()/1000) . "-" . strtoupper("cbr");

		// Format Genre
		$this->f_genre = $this->getGenere()->getGenerename(); 

		// Format the Time
		$min = floor($this->getTime()/60);
		$sec = sprintf("%02d", ($this->getTime()%60) );
		$this->f_time = $min . ":" . $sec;

		// Format the size
		$this->f_size = sprintf("%.2f",($this->getFilesize()/1048576));

		// Set style
		/*
		if (preg_match("/id3/", $this->flagtype)) { $this->f_style = "style=\"color: #33c;\""; }
		elseif (preg_match("/(mp3|del|sort|ren)/", $this->flagtype)) { $this->f_style = "style=\"color: #C00;\""; }
		if (!$this->enabled) { $this->f_style = "style=\"text-decoration: line-through;\""; }
		*/
		
		return true;
	}
} // Song
