<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/AgendaPeer.php';

/**
 * Base class that represents a row from the 'Agenda' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 07/16/06 10:29:13
 *
 * @package Model.om
 */
abstract class BaseAgenda extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var AgendaPeer
	 */
	protected static $peer;


	/**
	 * The value for the idagenda field.
	 * @var int
	 */
	protected $idagenda;


	/**
	 * The value for the idmusicelementtype field.
	 * @var int
	 */
	protected $idmusicelementtype;


	/**
	 * The value for the idmusicelement field.
	 * @var int
	 */
	protected $idmusicelement;


	/**
	 * The value for the idobservation field.
	 * @var int
	 */
	protected $idobservation;


	/**
	 * The value for the userid field.
	 * @var int
	 */
	protected $userid;


	/**
	 * The value for the title field.
	 * @var string
	 */
	protected $title;


	/**
	 * The value for the noticedate field.
	 * @var int
	 */
	protected $noticedate;


	/**
	 * The value for the noticetime field.
	 * @var int
	 */
	protected $noticetime;


	/**
	 * The value for the active field.
	 * @var boolean
	 */
	protected $active;

	/**
	 * @var Users
	 */
	protected $aUsers;

	/**
	 * @var Observations
	 */
	protected $aObservations;

	/**
	 * @var MusicElementType
	 */
	protected $aMusicElementType;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [idagenda] column value.
	 * 
	 * @return int
	 */
	public function getIdagenda()
	{

		return $this->idagenda;
	}

	/**
	 * Get the [idmusicelementtype] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelementtype()
	{

		return $this->idmusicelementtype;
	}

	/**
	 * Get the [idmusicelement] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelement()
	{

		return $this->idmusicelement;
	}

	/**
	 * Get the [idobservation] column value.
	 * 
	 * @return int
	 */
	public function getIdobservation()
	{

		return $this->idobservation;
	}

	/**
	 * Get the [userid] column value.
	 * 
	 * @return int
	 */
	public function getUserid()
	{

		return $this->userid;
	}

	/**
	 * Get the [title] column value.
	 * 
	 * @return string
	 */
	public function getTitle()
	{

		return $this->title;
	}

	/**
	 * Get the [optionally formatted] [noticedate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getNoticedate($format = '%x')
	{

		if ($this->noticedate === null || $this->noticedate === '') {
			return null;
		} elseif (!is_int($this->noticedate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->noticedate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [noticedate] as date/time value: " . var_export($this->noticedate, true));
			}
		} else {
			$ts = $this->noticedate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [noticetime] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getNoticetime($format = '%X')
	{

		if ($this->noticetime === null || $this->noticetime === '') {
			return null;
		} elseif (!is_int($this->noticetime)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->noticetime);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [noticetime] as date/time value: " . var_export($this->noticetime, true));
			}
		} else {
			$ts = $this->noticetime;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [active] column value.
	 * 
	 * @return boolean
	 */
	public function getActive()
	{

		return $this->active;
	}

	/**
	 * Set the value of [idagenda] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdagenda($v)
	{

		if ($this->idagenda !== $v) {
			$this->idagenda = $v;
			$this->modifiedColumns[] = AgendaPeer::IDAGENDA;
		}

	} // setIdagenda()

	/**
	 * Set the value of [idmusicelementtype] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelementtype($v)
	{

		if ($this->idmusicelementtype !== $v) {
			$this->idmusicelementtype = $v;
			$this->modifiedColumns[] = AgendaPeer::IDMUSICELEMENTTYPE;
		}

		if ($this->aMusicElementType !== null && $this->aMusicElementType->getIdmusicelementtype() !== $v) {
			$this->aMusicElementType = null;
		}		

	} // setIdmusicelementtype()

	/**
	 * Set the value of [idmusicelement] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelement($v)
	{

		if ($this->idmusicelement !== $v) {
			$this->idmusicelement = $v;
			$this->modifiedColumns[] = AgendaPeer::IDMUSICELEMENT;
		}

	} // setIdmusicelement()

	/**
	 * Set the value of [idobservation] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdobservation($v)
	{

		if ($this->idobservation !== $v) {
			$this->idobservation = $v;
			$this->modifiedColumns[] = AgendaPeer::IDOBSERVATION;
		}

		if ($this->aObservations !== null && $this->aObservations->getIdobservation() !== $v) {
			$this->aObservations = null;
		}		

	} // setIdobservation()

	/**
	 * Set the value of [userid] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUserid($v)
	{

		if ($this->userid !== $v) {
			$this->userid = $v;
			$this->modifiedColumns[] = AgendaPeer::USERID;
		}

		if ($this->aUsers !== null && $this->aUsers->getUserid() !== $v) {
			$this->aUsers = null;
		}		

	} // setUserid()

	/**
	 * Set the value of [title] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setTitle($v)
	{

		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = AgendaPeer::TITLE;
		}

	} // setTitle()

	/**
	 * Set the value of [noticedate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setNoticedate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [noticedate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->noticedate !== $ts) {
			$this->noticedate = $ts;
			$this->modifiedColumns[] = AgendaPeer::NOTICEDATE;
		}

	} // setNoticedate()

	/**
	 * Set the value of [noticetime] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setNoticetime($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [noticetime] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->noticetime !== $ts) {
			$this->noticetime = $ts;
			$this->modifiedColumns[] = AgendaPeer::NOTICETIME;
		}

	} // setNoticetime()

	/**
	 * Set the value of [active] column.
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setActive($v)
	{

		if ($this->active !== $v) {
			$this->active = $v;
			$this->modifiedColumns[] = AgendaPeer::ACTIVE;
		}

	} // setActive()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->idagenda = $rs->getInt($startcol + 0);

			$this->idmusicelementtype = $rs->getInt($startcol + 1);

			$this->idmusicelement = $rs->getInt($startcol + 2);

			$this->idobservation = $rs->getInt($startcol + 3);

			$this->userid = $rs->getInt($startcol + 4);

			$this->title = $rs->getString($startcol + 5);

			$this->noticedate = $rs->getDate($startcol + 6, null);

			$this->noticetime = $rs->getTime($startcol + 7, null);

			$this->active = $rs->getBoolean($startcol + 8);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 9; // 9 = AgendaPeer::NUM_COLUMNS - AgendaPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Agenda object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(AgendaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			AgendaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(AgendaPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aObservations !== null) {
				if ($this->aObservations->isModified()) {
					$affectedRows += $this->aObservations->save($con);
				}
				$this->setObservations($this->aObservations);
			}

			if ($this->aMusicElementType !== null) {
				if ($this->aMusicElementType->isModified()) {
					$affectedRows += $this->aMusicElementType->save($con);
				}
				$this->setMusicElementType($this->aMusicElementType);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AgendaPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setIdagenda($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += AgendaPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aObservations !== null) {
				if (!$this->aObservations->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aObservations->getValidationFailures());
				}
			}

			if ($this->aMusicElementType !== null) {
				if (!$this->aMusicElementType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMusicElementType->getValidationFailures());
				}
			}


			if (($retval = AgendaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = AgendaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdagenda();
				break;
			case 1:
				return $this->getIdmusicelementtype();
				break;
			case 2:
				return $this->getIdmusicelement();
				break;
			case 3:
				return $this->getIdobservation();
				break;
			case 4:
				return $this->getUserid();
				break;
			case 5:
				return $this->getTitle();
				break;
			case 6:
				return $this->getNoticedate();
				break;
			case 7:
				return $this->getNoticetime();
				break;
			case 8:
				return $this->getActive();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = AgendaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdagenda(),
			$keys[1] => $this->getIdmusicelementtype(),
			$keys[2] => $this->getIdmusicelement(),
			$keys[3] => $this->getIdobservation(),
			$keys[4] => $this->getUserid(),
			$keys[5] => $this->getTitle(),
			$keys[6] => $this->getNoticedate(),
			$keys[7] => $this->getNoticetime(),
			$keys[8] => $this->getActive(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = AgendaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdagenda($value);
				break;
			case 1:
				$this->setIdmusicelementtype($value);
				break;
			case 2:
				$this->setIdmusicelement($value);
				break;
			case 3:
				$this->setIdobservation($value);
				break;
			case 4:
				$this->setUserid($value);
				break;
			case 5:
				$this->setTitle($value);
				break;
			case 6:
				$this->setNoticedate($value);
				break;
			case 7:
				$this->setNoticetime($value);
				break;
			case 8:
				$this->setActive($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = AgendaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdagenda($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdmusicelementtype($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setIdmusicelement($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setIdobservation($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setUserid($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTitle($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setNoticedate($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setNoticetime($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setActive($arr[$keys[8]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(AgendaPeer::DATABASE_NAME);

		if ($this->isColumnModified(AgendaPeer::IDAGENDA)) $criteria->add(AgendaPeer::IDAGENDA, $this->idagenda);
		if ($this->isColumnModified(AgendaPeer::IDMUSICELEMENTTYPE)) $criteria->add(AgendaPeer::IDMUSICELEMENTTYPE, $this->idmusicelementtype);
		if ($this->isColumnModified(AgendaPeer::IDMUSICELEMENT)) $criteria->add(AgendaPeer::IDMUSICELEMENT, $this->idmusicelement);
		if ($this->isColumnModified(AgendaPeer::IDOBSERVATION)) $criteria->add(AgendaPeer::IDOBSERVATION, $this->idobservation);
		if ($this->isColumnModified(AgendaPeer::USERID)) $criteria->add(AgendaPeer::USERID, $this->userid);
		if ($this->isColumnModified(AgendaPeer::TITLE)) $criteria->add(AgendaPeer::TITLE, $this->title);
		if ($this->isColumnModified(AgendaPeer::NOTICEDATE)) $criteria->add(AgendaPeer::NOTICEDATE, $this->noticedate);
		if ($this->isColumnModified(AgendaPeer::NOTICETIME)) $criteria->add(AgendaPeer::NOTICETIME, $this->noticetime);
		if ($this->isColumnModified(AgendaPeer::ACTIVE)) $criteria->add(AgendaPeer::ACTIVE, $this->active);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(AgendaPeer::DATABASE_NAME);

		$criteria->add(AgendaPeer::IDAGENDA, $this->idagenda);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getIdagenda();
	}

	/**
	 * Generic method to set the primary key (idagenda column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setIdagenda($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Agenda (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdmusicelementtype($this->idmusicelementtype);

		$copyObj->setIdmusicelement($this->idmusicelement);

		$copyObj->setIdobservation($this->idobservation);

		$copyObj->setUserid($this->userid);

		$copyObj->setTitle($this->title);

		$copyObj->setNoticedate($this->noticedate);

		$copyObj->setNoticetime($this->noticetime);

		$copyObj->setActive($this->active);


		$copyObj->setNew(true);

		$copyObj->setIdagenda(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Agenda Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return AgendaPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AgendaPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param Users $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUsers($v)
	{


		if ($v === null) {
			$this->setUserid(NULL);
		} else {
			$this->setUserid($v->getUserid());
		}


		$this->aUsers = $v;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param Connection Optional Connection object.
	 * @return Users The associated Users object.
	 * @throws PropelException
	 */
	public function getUsers($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseUsersPeer.php';

		if ($this->aUsers === null && ($this->userid !== null)) {

			$this->aUsers = UsersPeer::retrieveByPK($this->userid, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UsersPeer::retrieveByPK($this->userid, $con);
			   $obj->addUserss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a Observations object.
	 *
	 * @param Observations $v
	 * @return void
	 * @throws PropelException
	 */
	public function setObservations($v)
	{


		if ($v === null) {
			$this->setIdobservation(NULL);
		} else {
			$this->setIdobservation($v->getIdobservation());
		}


		$this->aObservations = $v;
	}


	/**
	 * Get the associated Observations object
	 *
	 * @param Connection Optional Connection object.
	 * @return Observations The associated Observations object.
	 * @throws PropelException
	 */
	public function getObservations($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseObservationsPeer.php';

		if ($this->aObservations === null && ($this->idobservation !== null)) {

			$this->aObservations = ObservationsPeer::retrieveByPK($this->idobservation, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ObservationsPeer::retrieveByPK($this->idobservation, $con);
			   $obj->addObservationss($this);
			 */
		}
		return $this->aObservations;
	}

	/**
	 * Declares an association between this object and a MusicElementType object.
	 *
	 * @param MusicElementType $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMusicElementType($v)
	{


		if ($v === null) {
			$this->setIdmusicelementtype(NULL);
		} else {
			$this->setIdmusicelementtype($v->getIdmusicelementtype());
		}


		$this->aMusicElementType = $v;
	}


	/**
	 * Get the associated MusicElementType object
	 *
	 * @param Connection Optional Connection object.
	 * @return MusicElementType The associated MusicElementType object.
	 * @throws PropelException
	 */
	public function getMusicElementType($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseMusicElementTypePeer.php';

		if ($this->aMusicElementType === null && ($this->idmusicelementtype !== null)) {

			$this->aMusicElementType = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
			   $obj->addMusicElementTypes($this);
			 */
		}
		return $this->aMusicElementType;
	}

} // BaseAgenda
