<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/EmotionsPeer.php';

/**
 * Base class that represents a row from the 'Emotions' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 06/23/06 12:00:21
 *
 * @package Model.om
 */
abstract class BaseEmotions extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var EmotionsPeer
	 */
	protected static $peer;


	/**
	 * The value for the idemotion field.
	 * @var int
	 */
	protected $idemotion;


	/**
	 * The value for the userid field.
	 * @var int
	 */
	protected $userid;


	/**
	 * The value for the emotionname field.
	 * @var string
	 */
	protected $emotionname;


	/**
	 * The value for the urlicon field.
	 * @var string
	 */
	protected $urlicon;

	/**
	 * @var Users
	 */
	protected $aUsers;

	/**
	 * Collection to store aggregation of collEmotionSearchs.
	 * @var array
	 */
	protected $collEmotionSearchs;
	
	/**
	 * The criteria used to select the current contents of collEmotionSearchs.
	 * @var Criteria
	 */
	private $lastEmotionSearchCriteria = null;

	/**
	 * Collection to store aggregation of collEmotionsHasObservationss.
	 * @var array
	 */
	protected $collEmotionsHasObservationss;
	
	/**
	 * The criteria used to select the current contents of collEmotionsHasObservationss.
	 * @var Criteria
	 */
	private $lastEmotionsHasObservationsCriteria = null;

	/**
	 * Collection to store aggregation of collUserUsePlays.
	 * @var array
	 */
	protected $collUserUsePlays;
	
	/**
	 * The criteria used to select the current contents of collUserUsePlays.
	 * @var Criteria
	 */
	private $lastUserUsePlayCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [idemotion] column value.
	 * 
	 * @return int
	 */
	public function getIdemotion()
	{

		return $this->idemotion;
	}

	/**
	 * Get the [userid] column value.
	 * 
	 * @return int
	 */
	public function getUserid()
	{

		return $this->userid;
	}

	/**
	 * Get the [emotionname] column value.
	 * 
	 * @return string
	 */
	public function getEmotionname()
	{

		return $this->emotionname;
	}

	/**
	 * Get the [urlicon] column value.
	 * 
	 * @return string
	 */
	public function getUrlicon()
	{

		return $this->urlicon;
	}

	/**
	 * Set the value of [idemotion] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdemotion($v)
	{

		if ($this->idemotion !== $v) {
			$this->idemotion = $v;
			$this->modifiedColumns[] = EmotionsPeer::IDEMOTION;
		}

	} // setIdemotion()

	/**
	 * Set the value of [userid] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUserid($v)
	{

		if ($this->userid !== $v) {
			$this->userid = $v;
			$this->modifiedColumns[] = EmotionsPeer::USERID;
		}

		if ($this->aUsers !== null && $this->aUsers->getUserid() !== $v) {
			$this->aUsers = null;
		}		

	} // setUserid()

	/**
	 * Set the value of [emotionname] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setEmotionname($v)
	{

		if ($this->emotionname !== $v) {
			$this->emotionname = $v;
			$this->modifiedColumns[] = EmotionsPeer::EMOTIONNAME;
		}

	} // setEmotionname()

	/**
	 * Set the value of [urlicon] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setUrlicon($v)
	{

		if ($this->urlicon !== $v) {
			$this->urlicon = $v;
			$this->modifiedColumns[] = EmotionsPeer::URLICON;
		}

	} // setUrlicon()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->idemotion = $rs->getInt($startcol + 0);

			$this->userid = $rs->getInt($startcol + 1);

			$this->emotionname = $rs->getString($startcol + 2);

			$this->urlicon = $rs->getString($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 4; // 4 = EmotionsPeer::NUM_COLUMNS - EmotionsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Emotions object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(EmotionsPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			EmotionsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(EmotionsPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = EmotionsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setIdemotion($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += EmotionsPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collEmotionSearchs !== null) {
				foreach($this->collEmotionSearchs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collEmotionsHasObservationss !== null) {
				foreach($this->collEmotionsHasObservationss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collUserUsePlays !== null) {
				foreach($this->collUserUsePlays as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}


			if (($retval = EmotionsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collEmotionSearchs !== null) {
					foreach($this->collEmotionSearchs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collEmotionsHasObservationss !== null) {
					foreach($this->collEmotionsHasObservationss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collUserUsePlays !== null) {
					foreach($this->collUserUsePlays as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = EmotionsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdemotion();
				break;
			case 1:
				return $this->getUserid();
				break;
			case 2:
				return $this->getEmotionname();
				break;
			case 3:
				return $this->getUrlicon();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = EmotionsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdemotion(),
			$keys[1] => $this->getUserid(),
			$keys[2] => $this->getEmotionname(),
			$keys[3] => $this->getUrlicon(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = EmotionsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdemotion($value);
				break;
			case 1:
				$this->setUserid($value);
				break;
			case 2:
				$this->setEmotionname($value);
				break;
			case 3:
				$this->setUrlicon($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = EmotionsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdemotion($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUserid($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setEmotionname($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setUrlicon($arr[$keys[3]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(EmotionsPeer::DATABASE_NAME);

		if ($this->isColumnModified(EmotionsPeer::IDEMOTION)) $criteria->add(EmotionsPeer::IDEMOTION, $this->idemotion);
		if ($this->isColumnModified(EmotionsPeer::USERID)) $criteria->add(EmotionsPeer::USERID, $this->userid);
		if ($this->isColumnModified(EmotionsPeer::EMOTIONNAME)) $criteria->add(EmotionsPeer::EMOTIONNAME, $this->emotionname);
		if ($this->isColumnModified(EmotionsPeer::URLICON)) $criteria->add(EmotionsPeer::URLICON, $this->urlicon);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(EmotionsPeer::DATABASE_NAME);

		$criteria->add(EmotionsPeer::IDEMOTION, $this->idemotion);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getIdemotion();
	}

	/**
	 * Generic method to set the primary key (idemotion column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setIdemotion($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Emotions (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUserid($this->userid);

		$copyObj->setEmotionname($this->emotionname);

		$copyObj->setUrlicon($this->urlicon);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getEmotionSearchs() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addEmotionSearch($relObj->copy($deepCopy));
				}
			}

			foreach($this->getEmotionsHasObservationss() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addEmotionsHasObservations($relObj->copy($deepCopy));
				}
			}

			foreach($this->getUserUsePlays() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addUserUsePlay($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setIdemotion(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Emotions Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return EmotionsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new EmotionsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param Users $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUsers($v)
	{


		if ($v === null) {
			$this->setUserid(NULL);
		} else {
			$this->setUserid($v->getUserid());
		}


		$this->aUsers = $v;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param Connection Optional Connection object.
	 * @return Users The associated Users object.
	 * @throws PropelException
	 */
	public function getUsers($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseUsersPeer.php';

		if ($this->aUsers === null && ($this->userid !== null)) {

			$this->aUsers = UsersPeer::retrieveByPK($this->userid, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UsersPeer::retrieveByPK($this->userid, $con);
			   $obj->addUserss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Temporary storage of collEmotionSearchs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initEmotionSearchs()
	{
		if ($this->collEmotionSearchs === null) {
			$this->collEmotionSearchs = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions has previously
	 * been saved, it will retrieve related EmotionSearchs from storage.
	 * If this Emotions is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getEmotionSearchs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionSearchPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionSearchs === null) {
			if ($this->isNew()) {
			   $this->collEmotionSearchs = array();
			} else {

				$criteria->add(EmotionSearchPeer::IDEMOTION, $this->getIdemotion());

				EmotionSearchPeer::addSelectColumns($criteria);
				$this->collEmotionSearchs = EmotionSearchPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(EmotionSearchPeer::IDEMOTION, $this->getIdemotion());

				EmotionSearchPeer::addSelectColumns($criteria);
				if (!isset($this->lastEmotionSearchCriteria) || !$this->lastEmotionSearchCriteria->equals($criteria)) {
					$this->collEmotionSearchs = EmotionSearchPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastEmotionSearchCriteria = $criteria;
		return $this->collEmotionSearchs;
	}

	/**
	 * Returns the number of related EmotionSearchs.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countEmotionSearchs($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionSearchPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(EmotionSearchPeer::IDEMOTION, $this->getIdemotion());

		return EmotionSearchPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a EmotionSearch object to this object
	 * through the EmotionSearch foreign key attribute
	 *
	 * @param EmotionSearch $l EmotionSearch
	 * @return void
	 * @throws PropelException
	 */
	public function addEmotionSearch(EmotionSearch $l)
	{
		$this->collEmotionSearchs[] = $l;
		$l->setEmotions($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions is new, it will return
	 * an empty collection; or if this Emotions has previously
	 * been saved, it will retrieve related EmotionSearchs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Emotions.
	 */
	public function getEmotionSearchsJoinUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionSearchPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionSearchs === null) {
			if ($this->isNew()) {
				$this->collEmotionSearchs = array();
			} else {

				$criteria->add(EmotionSearchPeer::IDEMOTION, $this->getIdemotion());

				$this->collEmotionSearchs = EmotionSearchPeer::doSelectJoinUsers($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(EmotionSearchPeer::IDEMOTION, $this->getIdemotion());

			if (!isset($this->lastEmotionSearchCriteria) || !$this->lastEmotionSearchCriteria->equals($criteria)) {
				$this->collEmotionSearchs = EmotionSearchPeer::doSelectJoinUsers($criteria, $con);
			}
		}
		$this->lastEmotionSearchCriteria = $criteria;

		return $this->collEmotionSearchs;
	}

	/**
	 * Temporary storage of collEmotionsHasObservationss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initEmotionsHasObservationss()
	{
		if ($this->collEmotionsHasObservationss === null) {
			$this->collEmotionsHasObservationss = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions has previously
	 * been saved, it will retrieve related EmotionsHasObservationss from storage.
	 * If this Emotions is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getEmotionsHasObservationss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionsHasObservationsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionsHasObservationss === null) {
			if ($this->isNew()) {
			   $this->collEmotionsHasObservationss = array();
			} else {

				$criteria->add(EmotionsHasObservationsPeer::IDEMOTION, $this->getIdemotion());

				EmotionsHasObservationsPeer::addSelectColumns($criteria);
				$this->collEmotionsHasObservationss = EmotionsHasObservationsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(EmotionsHasObservationsPeer::IDEMOTION, $this->getIdemotion());

				EmotionsHasObservationsPeer::addSelectColumns($criteria);
				if (!isset($this->lastEmotionsHasObservationsCriteria) || !$this->lastEmotionsHasObservationsCriteria->equals($criteria)) {
					$this->collEmotionsHasObservationss = EmotionsHasObservationsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastEmotionsHasObservationsCriteria = $criteria;
		return $this->collEmotionsHasObservationss;
	}

	/**
	 * Returns the number of related EmotionsHasObservationss.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countEmotionsHasObservationss($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionsHasObservationsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(EmotionsHasObservationsPeer::IDEMOTION, $this->getIdemotion());

		return EmotionsHasObservationsPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a EmotionsHasObservations object to this object
	 * through the EmotionsHasObservations foreign key attribute
	 *
	 * @param EmotionsHasObservations $l EmotionsHasObservations
	 * @return void
	 * @throws PropelException
	 */
	public function addEmotionsHasObservations(EmotionsHasObservations $l)
	{
		$this->collEmotionsHasObservationss[] = $l;
		$l->setEmotions($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions is new, it will return
	 * an empty collection; or if this Emotions has previously
	 * been saved, it will retrieve related EmotionsHasObservationss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Emotions.
	 */
	public function getEmotionsHasObservationssJoinObservations($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionsHasObservationsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionsHasObservationss === null) {
			if ($this->isNew()) {
				$this->collEmotionsHasObservationss = array();
			} else {

				$criteria->add(EmotionsHasObservationsPeer::IDEMOTION, $this->getIdemotion());

				$this->collEmotionsHasObservationss = EmotionsHasObservationsPeer::doSelectJoinObservations($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(EmotionsHasObservationsPeer::IDEMOTION, $this->getIdemotion());

			if (!isset($this->lastEmotionsHasObservationsCriteria) || !$this->lastEmotionsHasObservationsCriteria->equals($criteria)) {
				$this->collEmotionsHasObservationss = EmotionsHasObservationsPeer::doSelectJoinObservations($criteria, $con);
			}
		}
		$this->lastEmotionsHasObservationsCriteria = $criteria;

		return $this->collEmotionsHasObservationss;
	}

	/**
	 * Temporary storage of collUserUsePlays to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserUsePlays()
	{
		if ($this->collUserUsePlays === null) {
			$this->collUserUsePlays = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 * If this Emotions is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserUsePlays($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
			   $this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

				UserUsePlayPeer::addSelectColumns($criteria);
				$this->collUserUsePlays = UserUsePlayPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

				UserUsePlayPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
					$this->collUserUsePlays = UserUsePlayPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;
		return $this->collUserUsePlays;
	}

	/**
	 * Returns the number of related UserUsePlays.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countUserUsePlays($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

		return UserUsePlayPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a UserUsePlay object to this object
	 * through the UserUsePlay foreign key attribute
	 *
	 * @param UserUsePlay $l UserUsePlay
	 * @return void
	 * @throws PropelException
	 */
	public function addUserUsePlay(UserUsePlay $l)
	{
		$this->collUserUsePlays[] = $l;
		$l->setEmotions($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions is new, it will return
	 * an empty collection; or if this Emotions has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Emotions.
	 */
	public function getUserUsePlaysJoinUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
				$this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinUsers($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

			if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinUsers($criteria, $con);
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;

		return $this->collUserUsePlays;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions is new, it will return
	 * an empty collection; or if this Emotions has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Emotions.
	 */
	public function getUserUsePlaysJoinObservations($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
				$this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinObservations($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

			if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinObservations($criteria, $con);
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;

		return $this->collUserUsePlays;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Emotions is new, it will return
	 * an empty collection; or if this Emotions has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Emotions.
	 */
	public function getUserUsePlaysJoinMusicElementType($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
				$this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserUsePlayPeer::IDEMOTION, $this->getIdemotion());

			if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;

		return $this->collUserUsePlays;
	}

} // BaseEmotions
