<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/GenerePeer.php';

/**
 * Base class that represents a row from the 'Genere' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 05/31/06 23:50:34
 *
 * @package Model.om
 */
abstract class BaseGenere extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var GenerePeer
	 */
	protected static $peer;


	/**
	 * The value for the idgenere field.
	 * @var int
	 */
	protected $idgenere;


	/**
	 * The value for the idmusicelementtype field.
	 * @var int
	 */
	protected $idmusicelementtype = 4;


	/**
	 * The value for the generename field.
	 * @var string
	 */
	protected $generename;

	/**
	 * @var MusicElementType
	 */
	protected $aMusicElementType;

	/**
	 * Collection to store aggregation of collSongs.
	 * @var array
	 */
	protected $collSongs;
	
	/**
	 * The criteria used to select the current contents of collSongs.
	 * @var Criteria
	 */
	private $lastSongCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [idgenere] column value.
	 * 
	 * @return int
	 */
	public function getIdgenere()
	{

		return $this->idgenere;
	}

	/**
	 * Get the [idmusicelementtype] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelementtype()
	{

		return $this->idmusicelementtype;
	}

	/**
	 * Get the [generename] column value.
	 * 
	 * @return string
	 */
	public function getGenerename()
	{

		return $this->generename;
	}

	/**
	 * Set the value of [idgenere] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdgenere($v)
	{

		if ($this->idgenere !== $v) {
			$this->idgenere = $v;
			$this->modifiedColumns[] = GenerePeer::IDGENERE;
		}

	} // setIdgenere()

	/**
	 * Set the value of [idmusicelementtype] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelementtype($v)
	{

		if ($this->idmusicelementtype !== $v || $v === 4) {
			$this->idmusicelementtype = $v;
			$this->modifiedColumns[] = GenerePeer::IDMUSICELEMENTTYPE;
		}

		if ($this->aMusicElementType !== null && $this->aMusicElementType->getIdmusicelementtype() !== $v) {
			$this->aMusicElementType = null;
		}		

	} // setIdmusicelementtype()

	/**
	 * Set the value of [generename] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setGenerename($v)
	{

		if ($this->generename !== $v) {
			$this->generename = $v;
			$this->modifiedColumns[] = GenerePeer::GENERENAME;
		}

	} // setGenerename()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->idgenere = $rs->getInt($startcol + 0);

			$this->idmusicelementtype = $rs->getInt($startcol + 1);

			$this->generename = $rs->getString($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 3; // 3 = GenerePeer::NUM_COLUMNS - GenerePeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Genere object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GenerePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			GenerePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GenerePeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aMusicElementType !== null) {
				if ($this->aMusicElementType->isModified()) {
					$affectedRows += $this->aMusicElementType->save($con);
				}
				$this->setMusicElementType($this->aMusicElementType);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GenerePeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setIdgenere($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += GenerePeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collSongs !== null) {
				foreach($this->collSongs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aMusicElementType !== null) {
				if (!$this->aMusicElementType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMusicElementType->getValidationFailures());
				}
			}


			if (($retval = GenerePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collSongs !== null) {
					foreach($this->collSongs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GenerePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdgenere();
				break;
			case 1:
				return $this->getIdmusicelementtype();
				break;
			case 2:
				return $this->getGenerename();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GenerePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdgenere(),
			$keys[1] => $this->getIdmusicelementtype(),
			$keys[2] => $this->getGenerename(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GenerePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdgenere($value);
				break;
			case 1:
				$this->setIdmusicelementtype($value);
				break;
			case 2:
				$this->setGenerename($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GenerePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdgenere($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdmusicelementtype($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setGenerename($arr[$keys[2]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(GenerePeer::DATABASE_NAME);

		if ($this->isColumnModified(GenerePeer::IDGENERE)) $criteria->add(GenerePeer::IDGENERE, $this->idgenere);
		if ($this->isColumnModified(GenerePeer::IDMUSICELEMENTTYPE)) $criteria->add(GenerePeer::IDMUSICELEMENTTYPE, $this->idmusicelementtype);
		if ($this->isColumnModified(GenerePeer::GENERENAME)) $criteria->add(GenerePeer::GENERENAME, $this->generename);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GenerePeer::DATABASE_NAME);

		$criteria->add(GenerePeer::IDGENERE, $this->idgenere);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getIdgenere();
	}

	/**
	 * Generic method to set the primary key (idgenere column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setIdgenere($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Genere (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdmusicelementtype($this->idmusicelementtype);

		$copyObj->setGenerename($this->generename);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getSongs() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addSong($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setIdgenere(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Genere Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return GenerePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GenerePeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a MusicElementType object.
	 *
	 * @param MusicElementType $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMusicElementType($v)
	{


		if ($v === null) {
			$this->setIdmusicelementtype('4');
		} else {
			$this->setIdmusicelementtype($v->getIdmusicelementtype());
		}


		$this->aMusicElementType = $v;
	}


	/**
	 * Get the associated MusicElementType object
	 *
	 * @param Connection Optional Connection object.
	 * @return MusicElementType The associated MusicElementType object.
	 * @throws PropelException
	 */
	public function getMusicElementType($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseMusicElementTypePeer.php';

		if ($this->aMusicElementType === null && ($this->idmusicelementtype !== null)) {

			$this->aMusicElementType = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
			   $obj->addMusicElementTypes($this);
			 */
		}
		return $this->aMusicElementType;
	}

	/**
	 * Temporary storage of collSongs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initSongs()
	{
		if ($this->collSongs === null) {
			$this->collSongs = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Genere has previously
	 * been saved, it will retrieve related Songs from storage.
	 * If this Genere is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getSongs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSongs === null) {
			if ($this->isNew()) {
			   $this->collSongs = array();
			} else {

				$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

				SongPeer::addSelectColumns($criteria);
				$this->collSongs = SongPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

				SongPeer::addSelectColumns($criteria);
				if (!isset($this->lastSongCriteria) || !$this->lastSongCriteria->equals($criteria)) {
					$this->collSongs = SongPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSongCriteria = $criteria;
		return $this->collSongs;
	}

	/**
	 * Returns the number of related Songs.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countSongs($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

		return SongPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a Song object to this object
	 * through the Song foreign key attribute
	 *
	 * @param Song $l Song
	 * @return void
	 * @throws PropelException
	 */
	public function addSong(Song $l)
	{
		$this->collSongs[] = $l;
		$l->setGenere($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Genere is new, it will return
	 * an empty collection; or if this Genere has previously
	 * been saved, it will retrieve related Songs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Genere.
	 */
	public function getSongsJoinArtist($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSongs === null) {
			if ($this->isNew()) {
				$this->collSongs = array();
			} else {

				$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

				$this->collSongs = SongPeer::doSelectJoinArtist($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

			if (!isset($this->lastSongCriteria) || !$this->lastSongCriteria->equals($criteria)) {
				$this->collSongs = SongPeer::doSelectJoinArtist($criteria, $con);
			}
		}
		$this->lastSongCriteria = $criteria;

		return $this->collSongs;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Genere is new, it will return
	 * an empty collection; or if this Genere has previously
	 * been saved, it will retrieve related Songs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Genere.
	 */
	public function getSongsJoinMusicElementType($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSongs === null) {
			if ($this->isNew()) {
				$this->collSongs = array();
			} else {

				$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

				$this->collSongs = SongPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

			if (!isset($this->lastSongCriteria) || !$this->lastSongCriteria->equals($criteria)) {
				$this->collSongs = SongPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		}
		$this->lastSongCriteria = $criteria;

		return $this->collSongs;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Genere is new, it will return
	 * an empty collection; or if this Genere has previously
	 * been saved, it will retrieve related Songs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Genere.
	 */
	public function getSongsJoinAlbum($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSongs === null) {
			if ($this->isNew()) {
				$this->collSongs = array();
			} else {

				$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

				$this->collSongs = SongPeer::doSelectJoinAlbum($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(SongPeer::IDGENERE, $this->getIdgenere());

			if (!isset($this->lastSongCriteria) || !$this->lastSongCriteria->equals($criteria)) {
				$this->collSongs = SongPeer::doSelectJoinAlbum($criteria, $con);
			}
		}
		$this->lastSongCriteria = $criteria;

		return $this->collSongs;
	}

} // BaseGenere
