<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/PlaylistPeer.php';

/**
 * Base class that represents a row from the 'PlayList' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 07/09/06 20:10:11
 *
 * @package Model.om
 */
abstract class BasePlaylist extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var PlaylistPeer
	 */
	protected static $peer;


	/**
	 * The value for the idplaylist field.
	 * @var int
	 */
	protected $idplaylist;


	/**
	 * The value for the idmusicelementtype field.
	 * @var int
	 */
	protected $idmusicelementtype = 5;


	/**
	 * The value for the userid field.
	 * @var int
	 */
	protected $userid;


	/**
	 * The value for the playlistname field.
	 * @var string
	 */
	protected $playlistname;


	/**
	 * The value for the creationdate field.
	 * @var int
	 */
	protected $creationdate;


	/**
	 * The value for the publiclist field.
	 * @var boolean
	 */
	protected $publiclist = false;


	/**
	 * The value for the playlisttime field.
	 * @var int
	 */
	protected $playlisttime;


	/**
	 * The value for the totalsongs field.
	 * @var int
	 */
	protected $totalsongs;

	/**
	 * @var Users
	 */
	protected $aUsers;

	/**
	 * @var MusicElementType
	 */
	protected $aMusicElementType;

	/**
	 * Collection to store aggregation of collPlaylistHasSongs.
	 * @var array
	 */
	protected $collPlaylistHasSongs;
	
	/**
	 * The criteria used to select the current contents of collPlaylistHasSongs.
	 * @var Criteria
	 */
	private $lastPlaylistHasSongCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [idplaylist] column value.
	 * 
	 * @return int
	 */
	public function getIdplaylist()
	{

		return $this->idplaylist;
	}

	/**
	 * Get the [idmusicelementtype] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelementtype()
	{

		return $this->idmusicelementtype;
	}

	/**
	 * Get the [userid] column value.
	 * 
	 * @return int
	 */
	public function getUserid()
	{

		return $this->userid;
	}

	/**
	 * Get the [playlistname] column value.
	 * 
	 * @return string
	 */
	public function getPlaylistname()
	{

		return $this->playlistname;
	}

	/**
	 * Get the [optionally formatted] [creationdate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreationdate($format = '%x')
	{

		if ($this->creationdate === null || $this->creationdate === '') {
			return null;
		} elseif (!is_int($this->creationdate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->creationdate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [creationdate] as date/time value: " . var_export($this->creationdate, true));
			}
		} else {
			$ts = $this->creationdate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [publiclist] column value.
	 * 
	 * @return boolean
	 */
	public function getPubliclist()
	{

		return $this->publiclist;
	}

	/**
	 * Get the [playlisttime] column value.
	 * 
	 * @return int
	 */
	public function getPlaylisttime()
	{

		return $this->playlisttime;
	}

	/**
	 * Get the [totalsongs] column value.
	 * 
	 * @return int
	 */
	public function getTotalsongs()
	{

		return $this->totalsongs;
	}

	/**
	 * Set the value of [idplaylist] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdplaylist($v)
	{

		if ($this->idplaylist !== $v) {
			$this->idplaylist = $v;
			$this->modifiedColumns[] = PlaylistPeer::IDPLAYLIST;
		}

	} // setIdplaylist()

	/**
	 * Set the value of [idmusicelementtype] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelementtype($v)
	{

		if ($this->idmusicelementtype !== $v || $v === 5) {
			$this->idmusicelementtype = $v;
			$this->modifiedColumns[] = PlaylistPeer::IDMUSICELEMENTTYPE;
		}

		if ($this->aMusicElementType !== null && $this->aMusicElementType->getIdmusicelementtype() !== $v) {
			$this->aMusicElementType = null;
		}		

	} // setIdmusicelementtype()

	/**
	 * Set the value of [userid] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUserid($v)
	{

		if ($this->userid !== $v) {
			$this->userid = $v;
			$this->modifiedColumns[] = PlaylistPeer::USERID;
		}

		if ($this->aUsers !== null && $this->aUsers->getUserid() !== $v) {
			$this->aUsers = null;
		}		

	} // setUserid()

	/**
	 * Set the value of [playlistname] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setPlaylistname($v)
	{

		if ($this->playlistname !== $v) {
			$this->playlistname = $v;
			$this->modifiedColumns[] = PlaylistPeer::PLAYLISTNAME;
		}

	} // setPlaylistname()

	/**
	 * Set the value of [creationdate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setCreationdate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [creationdate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->creationdate !== $ts) {
			$this->creationdate = $ts;
			$this->modifiedColumns[] = PlaylistPeer::CREATIONDATE;
		}

	} // setCreationdate()

	/**
	 * Set the value of [publiclist] column.
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setPubliclist($v)
	{

		if ($this->publiclist !== $v || $v === false) {
			$this->publiclist = $v;
			$this->modifiedColumns[] = PlaylistPeer::PUBLICLIST;
		}

	} // setPubliclist()

	/**
	 * Set the value of [playlisttime] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setPlaylisttime($v)
	{

		if ($this->playlisttime !== $v) {
			$this->playlisttime = $v;
			$this->modifiedColumns[] = PlaylistPeer::PLAYLISTTIME;
		}

	} // setPlaylisttime()

	/**
	 * Set the value of [totalsongs] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setTotalsongs($v)
	{

		if ($this->totalsongs !== $v) {
			$this->totalsongs = $v;
			$this->modifiedColumns[] = PlaylistPeer::TOTALSONGS;
		}

	} // setTotalsongs()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->idplaylist = $rs->getInt($startcol + 0);

			$this->idmusicelementtype = $rs->getInt($startcol + 1);

			$this->userid = $rs->getInt($startcol + 2);

			$this->playlistname = $rs->getString($startcol + 3);

			$this->creationdate = $rs->getDate($startcol + 4, null);

			$this->publiclist = $rs->getBoolean($startcol + 5);

			$this->playlisttime = $rs->getInt($startcol + 6);

			$this->totalsongs = $rs->getInt($startcol + 7);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 8; // 8 = PlaylistPeer::NUM_COLUMNS - PlaylistPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Playlist object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PlaylistPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PlaylistPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PlaylistPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aMusicElementType !== null) {
				if ($this->aMusicElementType->isModified()) {
					$affectedRows += $this->aMusicElementType->save($con);
				}
				$this->setMusicElementType($this->aMusicElementType);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PlaylistPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setIdplaylist($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += PlaylistPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collPlaylistHasSongs !== null) {
				foreach($this->collPlaylistHasSongs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aMusicElementType !== null) {
				if (!$this->aMusicElementType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMusicElementType->getValidationFailures());
				}
			}


			if (($retval = PlaylistPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collPlaylistHasSongs !== null) {
					foreach($this->collPlaylistHasSongs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PlaylistPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdplaylist();
				break;
			case 1:
				return $this->getIdmusicelementtype();
				break;
			case 2:
				return $this->getUserid();
				break;
			case 3:
				return $this->getPlaylistname();
				break;
			case 4:
				return $this->getCreationdate();
				break;
			case 5:
				return $this->getPubliclist();
				break;
			case 6:
				return $this->getPlaylisttime();
				break;
			case 7:
				return $this->getTotalsongs();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PlaylistPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdplaylist(),
			$keys[1] => $this->getIdmusicelementtype(),
			$keys[2] => $this->getUserid(),
			$keys[3] => $this->getPlaylistname(),
			$keys[4] => $this->getCreationdate(),
			$keys[5] => $this->getPubliclist(),
			$keys[6] => $this->getPlaylisttime(),
			$keys[7] => $this->getTotalsongs(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PlaylistPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdplaylist($value);
				break;
			case 1:
				$this->setIdmusicelementtype($value);
				break;
			case 2:
				$this->setUserid($value);
				break;
			case 3:
				$this->setPlaylistname($value);
				break;
			case 4:
				$this->setCreationdate($value);
				break;
			case 5:
				$this->setPubliclist($value);
				break;
			case 6:
				$this->setPlaylisttime($value);
				break;
			case 7:
				$this->setTotalsongs($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PlaylistPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdplaylist($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdmusicelementtype($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUserid($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setPlaylistname($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setCreationdate($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setPubliclist($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setPlaylisttime($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setTotalsongs($arr[$keys[7]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(PlaylistPeer::DATABASE_NAME);

		if ($this->isColumnModified(PlaylistPeer::IDPLAYLIST)) $criteria->add(PlaylistPeer::IDPLAYLIST, $this->idplaylist);
		if ($this->isColumnModified(PlaylistPeer::IDMUSICELEMENTTYPE)) $criteria->add(PlaylistPeer::IDMUSICELEMENTTYPE, $this->idmusicelementtype);
		if ($this->isColumnModified(PlaylistPeer::USERID)) $criteria->add(PlaylistPeer::USERID, $this->userid);
		if ($this->isColumnModified(PlaylistPeer::PLAYLISTNAME)) $criteria->add(PlaylistPeer::PLAYLISTNAME, $this->playlistname);
		if ($this->isColumnModified(PlaylistPeer::CREATIONDATE)) $criteria->add(PlaylistPeer::CREATIONDATE, $this->creationdate);
		if ($this->isColumnModified(PlaylistPeer::PUBLICLIST)) $criteria->add(PlaylistPeer::PUBLICLIST, $this->publiclist);
		if ($this->isColumnModified(PlaylistPeer::PLAYLISTTIME)) $criteria->add(PlaylistPeer::PLAYLISTTIME, $this->playlisttime);
		if ($this->isColumnModified(PlaylistPeer::TOTALSONGS)) $criteria->add(PlaylistPeer::TOTALSONGS, $this->totalsongs);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PlaylistPeer::DATABASE_NAME);

		$criteria->add(PlaylistPeer::IDPLAYLIST, $this->idplaylist);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getIdplaylist();
	}

	/**
	 * Generic method to set the primary key (idplaylist column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setIdplaylist($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Playlist (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdmusicelementtype($this->idmusicelementtype);

		$copyObj->setUserid($this->userid);

		$copyObj->setPlaylistname($this->playlistname);

		$copyObj->setCreationdate($this->creationdate);

		$copyObj->setPubliclist($this->publiclist);

		$copyObj->setPlaylisttime($this->playlisttime);

		$copyObj->setTotalsongs($this->totalsongs);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getPlaylistHasSongs() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addPlaylistHasSong($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setIdplaylist(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Playlist Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return PlaylistPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PlaylistPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param Users $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUsers($v)
	{


		if ($v === null) {
			$this->setUserid(NULL);
		} else {
			$this->setUserid($v->getUserid());
		}


		$this->aUsers = $v;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param Connection Optional Connection object.
	 * @return Users The associated Users object.
	 * @throws PropelException
	 */
	public function getUsers($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseUsersPeer.php';

		if ($this->aUsers === null && ($this->userid !== null)) {

			$this->aUsers = UsersPeer::retrieveByPK($this->userid, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UsersPeer::retrieveByPK($this->userid, $con);
			   $obj->addUserss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a MusicElementType object.
	 *
	 * @param MusicElementType $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMusicElementType($v)
	{


		if ($v === null) {
			$this->setIdmusicelementtype('5');
		} else {
			$this->setIdmusicelementtype($v->getIdmusicelementtype());
		}


		$this->aMusicElementType = $v;
	}


	/**
	 * Get the associated MusicElementType object
	 *
	 * @param Connection Optional Connection object.
	 * @return MusicElementType The associated MusicElementType object.
	 * @throws PropelException
	 */
	public function getMusicElementType($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseMusicElementTypePeer.php';

		if ($this->aMusicElementType === null && ($this->idmusicelementtype !== null)) {

			$this->aMusicElementType = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
			   $obj->addMusicElementTypes($this);
			 */
		}
		return $this->aMusicElementType;
	}

	/**
	 * Temporary storage of collPlaylistHasSongs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPlaylistHasSongs()
	{
		if ($this->collPlaylistHasSongs === null) {
			$this->collPlaylistHasSongs = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Playlist has previously
	 * been saved, it will retrieve related PlaylistHasSongs from storage.
	 * If this Playlist is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPlaylistHasSongs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistHasSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPlaylistHasSongs === null) {
			if ($this->isNew()) {
			   $this->collPlaylistHasSongs = array();
			} else {

				$criteria->add(PlaylistHasSongPeer::IDPLAYLIST, $this->getIdplaylist());

				PlaylistHasSongPeer::addSelectColumns($criteria);
				$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(PlaylistHasSongPeer::IDPLAYLIST, $this->getIdplaylist());

				PlaylistHasSongPeer::addSelectColumns($criteria);
				if (!isset($this->lastPlaylistHasSongCriteria) || !$this->lastPlaylistHasSongCriteria->equals($criteria)) {
					$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPlaylistHasSongCriteria = $criteria;
		return $this->collPlaylistHasSongs;
	}

	/**
	 * Returns the number of related PlaylistHasSongs.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countPlaylistHasSongs($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistHasSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PlaylistHasSongPeer::IDPLAYLIST, $this->getIdplaylist());

		return PlaylistHasSongPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a PlaylistHasSong object to this object
	 * through the PlaylistHasSong foreign key attribute
	 *
	 * @param PlaylistHasSong $l PlaylistHasSong
	 * @return void
	 * @throws PropelException
	 */
	public function addPlaylistHasSong(PlaylistHasSong $l)
	{
		$this->collPlaylistHasSongs[] = $l;
		$l->setPlaylist($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Playlist is new, it will return
	 * an empty collection; or if this Playlist has previously
	 * been saved, it will retrieve related PlaylistHasSongs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Playlist.
	 */
	public function getPlaylistHasSongsJoinSong($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistHasSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPlaylistHasSongs === null) {
			if ($this->isNew()) {
				$this->collPlaylistHasSongs = array();
			} else {

				$criteria->add(PlaylistHasSongPeer::IDPLAYLIST, $this->getIdplaylist());

				$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelectJoinSong($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PlaylistHasSongPeer::IDPLAYLIST, $this->getIdplaylist());

			if (!isset($this->lastPlaylistHasSongCriteria) || !$this->lastPlaylistHasSongCriteria->equals($criteria)) {
				$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelectJoinSong($criteria, $con);
			}
		}
		$this->lastPlaylistHasSongCriteria = $criteria;

		return $this->collPlaylistHasSongs;
	}

} // BasePlaylist
