<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/SongPeer.php';

/**
 * Base class that represents a row from the 'Song' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 05/31/06 23:51:01
 *
 * @package Model.om
 */
abstract class BaseSong extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var SongPeer
	 */
	protected static $peer;


	/**
	 * The value for the idsong field.
	 * @var int
	 */
	protected $idsong;


	/**
	 * The value for the idalbum field.
	 * @var int
	 */
	protected $idalbum;


	/**
	 * The value for the idmusicelementtype field.
	 * @var int
	 */
	protected $idmusicelementtype = 1;


	/**
	 * The value for the idgenere field.
	 * @var int
	 */
	protected $idgenere;


	/**
	 * The value for the idartist field.
	 * @var int
	 */
	protected $idartist;


	/**
	 * The value for the urlfile field.
	 * @var string
	 */
	protected $urlfile;


	/**
	 * The value for the enterdate field.
	 * @var int
	 */
	protected $enterdate;


	/**
	 * The value for the songname field.
	 * @var string
	 */
	protected $songname;


	/**
	 * The value for the track field.
	 * @var int
	 */
	protected $track;


	/**
	 * The value for the time field.
	 * @var int
	 */
	protected $time;


	/**
	 * The value for the filesize field.
	 * @var int
	 */
	protected $filesize;


	/**
	 * The value for the bitrate field.
	 * @var int
	 */
	protected $bitrate;


	/**
	 * The value for the filename field.
	 * @var string
	 */
	protected $filename;


	/**
	 * The value for the format field.
	 * @var string
	 */
	protected $format;


	/**
	 * The value for the rate field.
	 * @var int
	 */
	protected $rate;


	/**
	 * The value for the mode field.
	 * @var string
	 */
	protected $mode;


	/**
	 * The value for the mime field.
	 * @var string
	 */
	protected $mime;


	/**
	 * The value for the image field.
	 * @var boolean
	 */
	protected $image = false;


	/**
	 * The value for the complete field.
	 * @var boolean
	 */
	protected $complete = false;

	/**
	 * @var Artist
	 */
	protected $aArtist;

	/**
	 * @var Genere
	 */
	protected $aGenere;

	/**
	 * @var MusicElementType
	 */
	protected $aMusicElementType;

	/**
	 * @var Album
	 */
	protected $aAlbum;

	/**
	 * Collection to store aggregation of collUploadUserHists.
	 * @var array
	 */
	protected $collUploadUserHists;
	
	/**
	 * The criteria used to select the current contents of collUploadUserHists.
	 * @var Criteria
	 */
	private $lastUploadUserHistCriteria = null;

	/**
	 * Collection to store aggregation of collPlaylistHasSongs.
	 * @var array
	 */
	protected $collPlaylistHasSongs;
	
	/**
	 * The criteria used to select the current contents of collPlaylistHasSongs.
	 * @var Criteria
	 */
	private $lastPlaylistHasSongCriteria = null;

	/**
	 * Collection to store aggregation of collDownloadUserHists.
	 * @var array
	 */
	protected $collDownloadUserHists;
	
	/**
	 * The criteria used to select the current contents of collDownloadUserHists.
	 * @var Criteria
	 */
	private $lastDownloadUserHistCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [idsong] column value.
	 * 
	 * @return int
	 */
	public function getIdsong()
	{

		return $this->idsong;
	}

	/**
	 * Get the [idalbum] column value.
	 * 
	 * @return int
	 */
	public function getIdalbum()
	{

		return $this->idalbum;
	}

	/**
	 * Get the [idmusicelementtype] column value.
	 * 
	 * @return int
	 */
	public function getIdmusicelementtype()
	{

		return $this->idmusicelementtype;
	}

	/**
	 * Get the [idgenere] column value.
	 * 
	 * @return int
	 */
	public function getIdgenere()
	{

		return $this->idgenere;
	}

	/**
	 * Get the [idartist] column value.
	 * 
	 * @return int
	 */
	public function getIdartist()
	{

		return $this->idartist;
	}

	/**
	 * Get the [urlfile] column value.
	 * 
	 * @return string
	 */
	public function getUrlfile()
	{

		return $this->urlfile;
	}

	/**
	 * Get the [optionally formatted] [enterdate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getEnterdate($format = '%x')
	{

		if ($this->enterdate === null || $this->enterdate === '') {
			return null;
		} elseif (!is_int($this->enterdate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->enterdate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [enterdate] as date/time value: " . var_export($this->enterdate, true));
			}
		} else {
			$ts = $this->enterdate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [songname] column value.
	 * 
	 * @return string
	 */
	public function getSongname()
	{

		return $this->songname;
	}

	/**
	 * Get the [track] column value.
	 * 
	 * @return int
	 */
	public function getTrack()
	{

		return $this->track;
	}

	/**
	 * Get the [time] column value.
	 * 
	 * @return int
	 */
	public function getTime()
	{

		return $this->time;
	}

	/**
	 * Get the [filesize] column value.
	 * 
	 * @return int
	 */
	public function getFilesize()
	{

		return $this->filesize;
	}

	/**
	 * Get the [bitrate] column value.
	 * 
	 * @return int
	 */
	public function getBitrate()
	{

		return $this->bitrate;
	}

	/**
	 * Get the [filename] column value.
	 * 
	 * @return string
	 */
	public function getFilename()
	{

		return $this->filename;
	}

	/**
	 * Get the [format] column value.
	 * 
	 * @return string
	 */
	public function getFormat()
	{

		return $this->format;
	}

	/**
	 * Get the [rate] column value.
	 * 
	 * @return int
	 */
	public function getRate()
	{

		return $this->rate;
	}

	/**
	 * Get the [mode] column value.
	 * 
	 * @return string
	 */
	public function getMode()
	{

		return $this->mode;
	}

	/**
	 * Get the [mime] column value.
	 * 
	 * @return string
	 */
	public function getMime()
	{

		return $this->mime;
	}

	/**
	 * Get the [image] column value.
	 * 
	 * @return boolean
	 */
	public function getImage()
	{

		return $this->image;
	}

	/**
	 * Get the [complete] column value.
	 * 
	 * @return boolean
	 */
	public function getComplete()
	{

		return $this->complete;
	}

	/**
	 * Set the value of [idsong] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdsong($v)
	{

		if ($this->idsong !== $v) {
			$this->idsong = $v;
			$this->modifiedColumns[] = SongPeer::IDSONG;
		}

	} // setIdsong()

	/**
	 * Set the value of [idalbum] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdalbum($v)
	{

		if ($this->idalbum !== $v) {
			$this->idalbum = $v;
			$this->modifiedColumns[] = SongPeer::IDALBUM;
		}

		if ($this->aAlbum !== null && $this->aAlbum->getIdalbum() !== $v) {
			$this->aAlbum = null;
		}		

	} // setIdalbum()

	/**
	 * Set the value of [idmusicelementtype] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdmusicelementtype($v)
	{

		if ($this->idmusicelementtype !== $v || $v === 1) {
			$this->idmusicelementtype = $v;
			$this->modifiedColumns[] = SongPeer::IDMUSICELEMENTTYPE;
		}

		if ($this->aMusicElementType !== null && $this->aMusicElementType->getIdmusicelementtype() !== $v) {
			$this->aMusicElementType = null;
		}		

	} // setIdmusicelementtype()

	/**
	 * Set the value of [idgenere] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdgenere($v)
	{

		if ($this->idgenere !== $v) {
			$this->idgenere = $v;
			$this->modifiedColumns[] = SongPeer::IDGENERE;
		}

		if ($this->aGenere !== null && $this->aGenere->getIdgenere() !== $v) {
			$this->aGenere = null;
		}		

	} // setIdgenere()

	/**
	 * Set the value of [idartist] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdartist($v)
	{

		if ($this->idartist !== $v) {
			$this->idartist = $v;
			$this->modifiedColumns[] = SongPeer::IDARTIST;
		}

		if ($this->aArtist !== null && $this->aArtist->getIdartist() !== $v) {
			$this->aArtist = null;
		}		

	} // setIdartist()

	/**
	 * Set the value of [urlfile] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setUrlfile($v)
	{

		if ($this->urlfile !== $v) {
			$this->urlfile = $v;
			$this->modifiedColumns[] = SongPeer::URLFILE;
		}

	} // setUrlfile()

	/**
	 * Set the value of [enterdate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setEnterdate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [enterdate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->enterdate !== $ts) {
			$this->enterdate = $ts;
			$this->modifiedColumns[] = SongPeer::ENTERDATE;
		}

	} // setEnterdate()

	/**
	 * Set the value of [songname] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setSongname($v)
	{

		if ($this->songname !== $v) {
			$this->songname = $v;
			$this->modifiedColumns[] = SongPeer::SONGNAME;
		}

	} // setSongname()

	/**
	 * Set the value of [track] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setTrack($v)
	{

		if ($this->track !== $v) {
			$this->track = $v;
			$this->modifiedColumns[] = SongPeer::TRACK;
		}

	} // setTrack()

	/**
	 * Set the value of [time] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setTime($v)
	{

		if ($this->time !== $v) {
			$this->time = $v;
			$this->modifiedColumns[] = SongPeer::TIME;
		}

	} // setTime()

	/**
	 * Set the value of [filesize] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setFilesize($v)
	{

		if ($this->filesize !== $v) {
			$this->filesize = $v;
			$this->modifiedColumns[] = SongPeer::FILESIZE;
		}

	} // setFilesize()

	/**
	 * Set the value of [bitrate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setBitrate($v)
	{

		if ($this->bitrate !== $v) {
			$this->bitrate = $v;
			$this->modifiedColumns[] = SongPeer::BITRATE;
		}

	} // setBitrate()

	/**
	 * Set the value of [filename] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setFilename($v)
	{

		if ($this->filename !== $v) {
			$this->filename = $v;
			$this->modifiedColumns[] = SongPeer::FILENAME;
		}

	} // setFilename()

	/**
	 * Set the value of [format] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setFormat($v)
	{

		if ($this->format !== $v) {
			$this->format = $v;
			$this->modifiedColumns[] = SongPeer::FORMAT;
		}

	} // setFormat()

	/**
	 * Set the value of [rate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setRate($v)
	{

		if ($this->rate !== $v) {
			$this->rate = $v;
			$this->modifiedColumns[] = SongPeer::RATE;
		}

	} // setRate()

	/**
	 * Set the value of [mode] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setMode($v)
	{

		if ($this->mode !== $v) {
			$this->mode = $v;
			$this->modifiedColumns[] = SongPeer::MODE;
		}

	} // setMode()

	/**
	 * Set the value of [mime] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setMime($v)
	{

		if ($this->mime !== $v) {
			$this->mime = $v;
			$this->modifiedColumns[] = SongPeer::MIME;
		}

	} // setMime()

	/**
	 * Set the value of [image] column.
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setImage($v)
	{

		if ($this->image !== $v || $v === false) {
			$this->image = $v;
			$this->modifiedColumns[] = SongPeer::IMAGE;
		}

	} // setImage()

	/**
	 * Set the value of [complete] column.
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setComplete($v)
	{

		if ($this->complete !== $v || $v === false) {
			$this->complete = $v;
			$this->modifiedColumns[] = SongPeer::COMPLETE;
		}

	} // setComplete()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->idsong = $rs->getInt($startcol + 0);

			$this->idalbum = $rs->getInt($startcol + 1);

			$this->idmusicelementtype = $rs->getInt($startcol + 2);

			$this->idgenere = $rs->getInt($startcol + 3);

			$this->idartist = $rs->getInt($startcol + 4);

			$this->urlfile = $rs->getString($startcol + 5);

			$this->enterdate = $rs->getDate($startcol + 6, null);

			$this->songname = $rs->getString($startcol + 7);

			$this->track = $rs->getInt($startcol + 8);

			$this->time = $rs->getInt($startcol + 9);

			$this->filesize = $rs->getInt($startcol + 10);

			$this->bitrate = $rs->getInt($startcol + 11);

			$this->filename = $rs->getString($startcol + 12);

			$this->format = $rs->getString($startcol + 13);

			$this->rate = $rs->getInt($startcol + 14);

			$this->mode = $rs->getString($startcol + 15);

			$this->mime = $rs->getString($startcol + 16);

			$this->image = $rs->getBoolean($startcol + 17);

			$this->complete = $rs->getBoolean($startcol + 18);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 19; // 19 = SongPeer::NUM_COLUMNS - SongPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Song object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SongPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SongPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SongPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aArtist !== null) {
				if ($this->aArtist->isModified()) {
					$affectedRows += $this->aArtist->save($con);
				}
				$this->setArtist($this->aArtist);
			}

			if ($this->aGenere !== null) {
				if ($this->aGenere->isModified()) {
					$affectedRows += $this->aGenere->save($con);
				}
				$this->setGenere($this->aGenere);
			}

			if ($this->aMusicElementType !== null) {
				if ($this->aMusicElementType->isModified()) {
					$affectedRows += $this->aMusicElementType->save($con);
				}
				$this->setMusicElementType($this->aMusicElementType);
			}

			if ($this->aAlbum !== null) {
				if ($this->aAlbum->isModified()) {
					$affectedRows += $this->aAlbum->save($con);
				}
				$this->setAlbum($this->aAlbum);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SongPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setIdsong($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += SongPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collUploadUserHists !== null) {
				foreach($this->collUploadUserHists as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collPlaylistHasSongs !== null) {
				foreach($this->collPlaylistHasSongs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collDownloadUserHists !== null) {
				foreach($this->collDownloadUserHists as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aArtist !== null) {
				if (!$this->aArtist->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aArtist->getValidationFailures());
				}
			}

			if ($this->aGenere !== null) {
				if (!$this->aGenere->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGenere->getValidationFailures());
				}
			}

			if ($this->aMusicElementType !== null) {
				if (!$this->aMusicElementType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMusicElementType->getValidationFailures());
				}
			}

			if ($this->aAlbum !== null) {
				if (!$this->aAlbum->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aAlbum->getValidationFailures());
				}
			}


			if (($retval = SongPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collUploadUserHists !== null) {
					foreach($this->collUploadUserHists as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collPlaylistHasSongs !== null) {
					foreach($this->collPlaylistHasSongs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collDownloadUserHists !== null) {
					foreach($this->collDownloadUserHists as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SongPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdsong();
				break;
			case 1:
				return $this->getIdalbum();
				break;
			case 2:
				return $this->getIdmusicelementtype();
				break;
			case 3:
				return $this->getIdgenere();
				break;
			case 4:
				return $this->getIdartist();
				break;
			case 5:
				return $this->getUrlfile();
				break;
			case 6:
				return $this->getEnterdate();
				break;
			case 7:
				return $this->getSongname();
				break;
			case 8:
				return $this->getTrack();
				break;
			case 9:
				return $this->getTime();
				break;
			case 10:
				return $this->getFilesize();
				break;
			case 11:
				return $this->getBitrate();
				break;
			case 12:
				return $this->getFilename();
				break;
			case 13:
				return $this->getFormat();
				break;
			case 14:
				return $this->getRate();
				break;
			case 15:
				return $this->getMode();
				break;
			case 16:
				return $this->getMime();
				break;
			case 17:
				return $this->getImage();
				break;
			case 18:
				return $this->getComplete();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SongPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdsong(),
			$keys[1] => $this->getIdalbum(),
			$keys[2] => $this->getIdmusicelementtype(),
			$keys[3] => $this->getIdgenere(),
			$keys[4] => $this->getIdartist(),
			$keys[5] => $this->getUrlfile(),
			$keys[6] => $this->getEnterdate(),
			$keys[7] => $this->getSongname(),
			$keys[8] => $this->getTrack(),
			$keys[9] => $this->getTime(),
			$keys[10] => $this->getFilesize(),
			$keys[11] => $this->getBitrate(),
			$keys[12] => $this->getFilename(),
			$keys[13] => $this->getFormat(),
			$keys[14] => $this->getRate(),
			$keys[15] => $this->getMode(),
			$keys[16] => $this->getMime(),
			$keys[17] => $this->getImage(),
			$keys[18] => $this->getComplete(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SongPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdsong($value);
				break;
			case 1:
				$this->setIdalbum($value);
				break;
			case 2:
				$this->setIdmusicelementtype($value);
				break;
			case 3:
				$this->setIdgenere($value);
				break;
			case 4:
				$this->setIdartist($value);
				break;
			case 5:
				$this->setUrlfile($value);
				break;
			case 6:
				$this->setEnterdate($value);
				break;
			case 7:
				$this->setSongname($value);
				break;
			case 8:
				$this->setTrack($value);
				break;
			case 9:
				$this->setTime($value);
				break;
			case 10:
				$this->setFilesize($value);
				break;
			case 11:
				$this->setBitrate($value);
				break;
			case 12:
				$this->setFilename($value);
				break;
			case 13:
				$this->setFormat($value);
				break;
			case 14:
				$this->setRate($value);
				break;
			case 15:
				$this->setMode($value);
				break;
			case 16:
				$this->setMime($value);
				break;
			case 17:
				$this->setImage($value);
				break;
			case 18:
				$this->setComplete($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SongPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdsong($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdalbum($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setIdmusicelementtype($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setIdgenere($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setIdartist($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setUrlfile($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setEnterdate($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setSongname($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setTrack($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setTime($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setFilesize($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setBitrate($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setFilename($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setFormat($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setRate($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setMode($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setMime($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setImage($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setComplete($arr[$keys[18]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(SongPeer::DATABASE_NAME);

		if ($this->isColumnModified(SongPeer::IDSONG)) $criteria->add(SongPeer::IDSONG, $this->idsong);
		if ($this->isColumnModified(SongPeer::IDALBUM)) $criteria->add(SongPeer::IDALBUM, $this->idalbum);
		if ($this->isColumnModified(SongPeer::IDMUSICELEMENTTYPE)) $criteria->add(SongPeer::IDMUSICELEMENTTYPE, $this->idmusicelementtype);
		if ($this->isColumnModified(SongPeer::IDGENERE)) $criteria->add(SongPeer::IDGENERE, $this->idgenere);
		if ($this->isColumnModified(SongPeer::IDARTIST)) $criteria->add(SongPeer::IDARTIST, $this->idartist);
		if ($this->isColumnModified(SongPeer::URLFILE)) $criteria->add(SongPeer::URLFILE, $this->urlfile);
		if ($this->isColumnModified(SongPeer::ENTERDATE)) $criteria->add(SongPeer::ENTERDATE, $this->enterdate);
		if ($this->isColumnModified(SongPeer::SONGNAME)) $criteria->add(SongPeer::SONGNAME, $this->songname);
		if ($this->isColumnModified(SongPeer::TRACK)) $criteria->add(SongPeer::TRACK, $this->track);
		if ($this->isColumnModified(SongPeer::TIME)) $criteria->add(SongPeer::TIME, $this->time);
		if ($this->isColumnModified(SongPeer::FILESIZE)) $criteria->add(SongPeer::FILESIZE, $this->filesize);
		if ($this->isColumnModified(SongPeer::BITRATE)) $criteria->add(SongPeer::BITRATE, $this->bitrate);
		if ($this->isColumnModified(SongPeer::FILENAME)) $criteria->add(SongPeer::FILENAME, $this->filename);
		if ($this->isColumnModified(SongPeer::FORMAT)) $criteria->add(SongPeer::FORMAT, $this->format);
		if ($this->isColumnModified(SongPeer::RATE)) $criteria->add(SongPeer::RATE, $this->rate);
		if ($this->isColumnModified(SongPeer::MODE)) $criteria->add(SongPeer::MODE, $this->mode);
		if ($this->isColumnModified(SongPeer::MIME)) $criteria->add(SongPeer::MIME, $this->mime);
		if ($this->isColumnModified(SongPeer::IMAGE)) $criteria->add(SongPeer::IMAGE, $this->image);
		if ($this->isColumnModified(SongPeer::COMPLETE)) $criteria->add(SongPeer::COMPLETE, $this->complete);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SongPeer::DATABASE_NAME);

		$criteria->add(SongPeer::IDSONG, $this->idsong);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getIdsong();
	}

	/**
	 * Generic method to set the primary key (idsong column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setIdsong($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Song (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdalbum($this->idalbum);

		$copyObj->setIdmusicelementtype($this->idmusicelementtype);

		$copyObj->setIdgenere($this->idgenere);

		$copyObj->setIdartist($this->idartist);

		$copyObj->setUrlfile($this->urlfile);

		$copyObj->setEnterdate($this->enterdate);

		$copyObj->setSongname($this->songname);

		$copyObj->setTrack($this->track);

		$copyObj->setTime($this->time);

		$copyObj->setFilesize($this->filesize);

		$copyObj->setBitrate($this->bitrate);

		$copyObj->setFilename($this->filename);

		$copyObj->setFormat($this->format);

		$copyObj->setRate($this->rate);

		$copyObj->setMode($this->mode);

		$copyObj->setMime($this->mime);

		$copyObj->setImage($this->image);

		$copyObj->setComplete($this->complete);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getUploadUserHists() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addUploadUserHist($relObj->copy($deepCopy));
				}
			}

			foreach($this->getPlaylistHasSongs() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addPlaylistHasSong($relObj->copy($deepCopy));
				}
			}

			foreach($this->getDownloadUserHists() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDownloadUserHist($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setIdsong(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Song Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return SongPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SongPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Artist object.
	 *
	 * @param Artist $v
	 * @return void
	 * @throws PropelException
	 */
	public function setArtist($v)
	{


		if ($v === null) {
			$this->setIdartist(NULL);
		} else {
			$this->setIdartist($v->getIdartist());
		}


		$this->aArtist = $v;
	}


	/**
	 * Get the associated Artist object
	 *
	 * @param Connection Optional Connection object.
	 * @return Artist The associated Artist object.
	 * @throws PropelException
	 */
	public function getArtist($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseArtistPeer.php';

		if ($this->aArtist === null && ($this->idartist !== null)) {

					
			$this->aArtist = ArtistPeer::retrieveByPK($this->idartist, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ArtistPeer::retrieveByPK($this->idartist, $con);
			   $obj->addArtists($this);
			 */
		}
		return $this->aArtist;
	}

	/**
	 * Declares an association between this object and a Genere object.
	 *
	 * @param Genere $v
	 * @return void
	 * @throws PropelException
	 */
	public function setGenere($v)
	{


		if ($v === null) {
			$this->setIdgenere(NULL);
		} else {
			$this->setIdgenere($v->getIdgenere());
		}


		$this->aGenere = $v;
	}


	/**
	 * Get the associated Genere object
	 *
	 * @param Connection Optional Connection object.
	 * @return Genere The associated Genere object.
	 * @throws PropelException
	 */
	public function getGenere($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseGenerePeer.php';

		if ($this->aGenere === null && ($this->idgenere !== null)) {

			$this->aGenere = GenerePeer::retrieveByPK($this->idgenere, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = GenerePeer::retrieveByPK($this->idgenere, $con);
			   $obj->addGeneres($this);
			 */
		}
		return $this->aGenere;
	}

	/**
	 * Declares an association between this object and a MusicElementType object.
	 *
	 * @param MusicElementType $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMusicElementType($v)
	{


		if ($v === null) {
			$this->setIdmusicelementtype('1');
		} else {
			$this->setIdmusicelementtype($v->getIdmusicelementtype());
		}


		$this->aMusicElementType = $v;
	}


	/**
	 * Get the associated MusicElementType object
	 *
	 * @param Connection Optional Connection object.
	 * @return MusicElementType The associated MusicElementType object.
	 * @throws PropelException
	 */
	public function getMusicElementType($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseMusicElementTypePeer.php';

		if ($this->aMusicElementType === null && ($this->idmusicelementtype !== null)) {

			$this->aMusicElementType = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MusicElementTypePeer::retrieveByPK($this->idmusicelementtype, $con);
			   $obj->addMusicElementTypes($this);
			 */
		}
		return $this->aMusicElementType;
	}

	/**
	 * Declares an association between this object and a Album object.
	 *
	 * @param Album $v
	 * @return void
	 * @throws PropelException
	 */
	public function setAlbum($v)
	{


		if ($v === null) {
			$this->setIdalbum(NULL);
		} else {
			$this->setIdalbum($v->getIdalbum());
		}


		$this->aAlbum = $v;
	}


	/**
	 * Get the associated Album object
	 *
	 * @param Connection Optional Connection object.
	 * @return Album The associated Album object.
	 * @throws PropelException
	 */
	public function getAlbum($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseAlbumPeer.php';

		if ($this->aAlbum === null && ($this->idalbum !== null)) {

			$this->aAlbum = AlbumPeer::retrieveByPK($this->idalbum,FR_Util_Const::CONST_ALBUM);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = AlbumPeer::retrieveByPK($this->idalbum, $con);
			   $obj->addAlbums($this);
			 */
		}
		return $this->aAlbum;
	}

	/**
	 * Temporary storage of collUploadUserHists to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUploadUserHists()
	{
		if ($this->collUploadUserHists === null) {
			$this->collUploadUserHists = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Song has previously
	 * been saved, it will retrieve related UploadUserHists from storage.
	 * If this Song is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUploadUserHists($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUploadUserHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUploadUserHists === null) {
			if ($this->isNew()) {
			   $this->collUploadUserHists = array();
			} else {

				$criteria->add(UploadUserHistPeer::IDSONG, $this->getIdsong());

				UploadUserHistPeer::addSelectColumns($criteria);
				$this->collUploadUserHists = UploadUserHistPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UploadUserHistPeer::IDSONG, $this->getIdsong());

				UploadUserHistPeer::addSelectColumns($criteria);
				if (!isset($this->lastUploadUserHistCriteria) || !$this->lastUploadUserHistCriteria->equals($criteria)) {
					$this->collUploadUserHists = UploadUserHistPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUploadUserHistCriteria = $criteria;
		return $this->collUploadUserHists;
	}

	/**
	 * Returns the number of related UploadUserHists.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countUploadUserHists($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUploadUserHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UploadUserHistPeer::IDSONG, $this->getIdsong());

		return UploadUserHistPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a UploadUserHist object to this object
	 * through the UploadUserHist foreign key attribute
	 *
	 * @param UploadUserHist $l UploadUserHist
	 * @return void
	 * @throws PropelException
	 */
	public function addUploadUserHist(UploadUserHist $l)
	{
		$this->collUploadUserHists[] = $l;
		$l->setSong($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Song is new, it will return
	 * an empty collection; or if this Song has previously
	 * been saved, it will retrieve related UploadUserHists from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Song.
	 */
	public function getUploadUserHistsJoinUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUploadUserHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUploadUserHists === null) {
			if ($this->isNew()) {
				$this->collUploadUserHists = array();
			} else {

				$criteria->add(UploadUserHistPeer::IDSONG, $this->getIdsong());

				$this->collUploadUserHists = UploadUserHistPeer::doSelectJoinUsers($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UploadUserHistPeer::IDSONG, $this->getIdsong());

			if (!isset($this->lastUploadUserHistCriteria) || !$this->lastUploadUserHistCriteria->equals($criteria)) {
				$this->collUploadUserHists = UploadUserHistPeer::doSelectJoinUsers($criteria, $con);
			}
		}
		$this->lastUploadUserHistCriteria = $criteria;

		return $this->collUploadUserHists;
	}

	/**
	 * Temporary storage of collPlaylistHasSongs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPlaylistHasSongs()
	{
		if ($this->collPlaylistHasSongs === null) {
			$this->collPlaylistHasSongs = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Song has previously
	 * been saved, it will retrieve related PlaylistHasSongs from storage.
	 * If this Song is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPlaylistHasSongs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistHasSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPlaylistHasSongs === null) {
			if ($this->isNew()) {
			   $this->collPlaylistHasSongs = array();
			} else {

				$criteria->add(PlaylistHasSongPeer::IDSONG, $this->getIdsong());

				PlaylistHasSongPeer::addSelectColumns($criteria);
				$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(PlaylistHasSongPeer::IDSONG, $this->getIdsong());

				PlaylistHasSongPeer::addSelectColumns($criteria);
				if (!isset($this->lastPlaylistHasSongCriteria) || !$this->lastPlaylistHasSongCriteria->equals($criteria)) {
					$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPlaylistHasSongCriteria = $criteria;
		return $this->collPlaylistHasSongs;
	}

	/**
	 * Returns the number of related PlaylistHasSongs.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countPlaylistHasSongs($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistHasSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PlaylistHasSongPeer::IDSONG, $this->getIdsong());

		return PlaylistHasSongPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a PlaylistHasSong object to this object
	 * through the PlaylistHasSong foreign key attribute
	 *
	 * @param PlaylistHasSong $l PlaylistHasSong
	 * @return void
	 * @throws PropelException
	 */
	public function addPlaylistHasSong(PlaylistHasSong $l)
	{
		$this->collPlaylistHasSongs[] = $l;
		$l->setSong($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Song is new, it will return
	 * an empty collection; or if this Song has previously
	 * been saved, it will retrieve related PlaylistHasSongs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Song.
	 */
	public function getPlaylistHasSongsJoinPlaylist($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistHasSongPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPlaylistHasSongs === null) {
			if ($this->isNew()) {
				$this->collPlaylistHasSongs = array();
			} else {

				$criteria->add(PlaylistHasSongPeer::IDSONG, $this->getIdsong());

				$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelectJoinPlaylist($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PlaylistHasSongPeer::IDSONG, $this->getIdsong());

			if (!isset($this->lastPlaylistHasSongCriteria) || !$this->lastPlaylistHasSongCriteria->equals($criteria)) {
				$this->collPlaylistHasSongs = PlaylistHasSongPeer::doSelectJoinPlaylist($criteria, $con);
			}
		}
		$this->lastPlaylistHasSongCriteria = $criteria;

		return $this->collPlaylistHasSongs;
	}

	/**
	 * Temporary storage of collDownloadUserHists to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDownloadUserHists()
	{
		if ($this->collDownloadUserHists === null) {
			$this->collDownloadUserHists = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Song has previously
	 * been saved, it will retrieve related DownloadUserHists from storage.
	 * If this Song is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDownloadUserHists($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseDownloadUserHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDownloadUserHists === null) {
			if ($this->isNew()) {
			   $this->collDownloadUserHists = array();
			} else {

				$criteria->add(DownloadUserHistPeer::IDSONG, $this->getIdsong());

				DownloadUserHistPeer::addSelectColumns($criteria);
				$this->collDownloadUserHists = DownloadUserHistPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DownloadUserHistPeer::IDSONG, $this->getIdsong());

				DownloadUserHistPeer::addSelectColumns($criteria);
				if (!isset($this->lastDownloadUserHistCriteria) || !$this->lastDownloadUserHistCriteria->equals($criteria)) {
					$this->collDownloadUserHists = DownloadUserHistPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDownloadUserHistCriteria = $criteria;
		return $this->collDownloadUserHists;
	}

	/**
	 * Returns the number of related DownloadUserHists.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countDownloadUserHists($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseDownloadUserHistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(DownloadUserHistPeer::IDSONG, $this->getIdsong());

		return DownloadUserHistPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a DownloadUserHist object to this object
	 * through the DownloadUserHist foreign key attribute
	 *
	 * @param DownloadUserHist $l DownloadUserHist
	 * @return void
	 * @throws PropelException
	 */
	public function addDownloadUserHist(DownloadUserHist $l)
	{
		$this->collDownloadUserHists[] = $l;
		$l->setSong($this);
	}

} // BaseSong
