<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'Model/UsersPeer.php';

/**
 * Base class that represents a row from the 'Users' table.
 *
 * 
 *
 * This class was autogenerated by Propel on:
 *
 * 06/23/06 12:00:09
 *
 * @package Model.om
 */
abstract class BaseUsers extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UsersPeer
	 */
	protected static $peer;


	/**
	 * The value for the userid field.
	 * @var int
	 */
	protected $userid;


	/**
	 * The value for the idusertype field.
	 * @var int
	 */
	protected $idusertype;


	/**
	 * The value for the userlogin field.
	 * @var string
	 */
	protected $userlogin;


	/**
	 * The value for the pass field.
	 * @var string
	 */
	protected $pass;


	/**
	 * The value for the name field.
	 * @var string
	 */
	protected $name;


	/**
	 * The value for the firstname field.
	 * @var string
	 */
	protected $firstname;


	/**
	 * The value for the lastname field.
	 * @var string
	 */
	protected $lastname;


	/**
	 * The value for the email field.
	 * @var string
	 */
	protected $email;


	/**
	 * The value for the birthdate field.
	 * @var int
	 */
	protected $birthdate;


	/**
	 * The value for the createdate field.
	 * @var int
	 */
	protected $createdate;


	/**
	 * The value for the active field.
	 * @var boolean
	 */
	protected $active;


	/**
	 * The value for the maxmegas field.
	 * @var int
	 */
	protected $maxmegas = 250;


	/**
	 * The value for the usedmegas field.
	 * @var int
	 */
	protected $usedmegas = 0;


	/**
	 * The value for the emotionsmaxpoint field.
	 * @var int
	 */
	protected $emotionsmaxpoint = 5;


	/**
	 * The value for the emotionstypeselection field.
	 * @var int
	 */
	protected $emotionstypeselection = 1;


	/**
	 * The value for the preferenttop10 field.
	 * @var string
	 */
	protected $preferenttop10 = '\\a2,4,6,8,10\\a';


	/**
	 * The value for the viewlinks field.
	 * @var boolean
	 */
	protected $viewlinks = true;


	/**
	 * The value for the preflanguages field.
	 * @var int
	 */
	protected $preflanguages;


	/**
	 * The value for the offsetpagination field.
	 * @var int
	 */
	protected $offsetpagination;

	/**
	 * @var UserTypes
	 */
	protected $aUserTypes;

	/**
	 * Collection to store aggregation of collSessions.
	 * @var array
	 */
	protected $collSessions;
	
	/**
	 * The criteria used to select the current contents of collSessions.
	 * @var Criteria
	 */
	private $lastSessionCriteria = null;

	/**
	 * Collection to store aggregation of collObservationss.
	 * @var array
	 */
	protected $collObservationss;
	
	/**
	 * The criteria used to select the current contents of collObservationss.
	 * @var Criteria
	 */
	private $lastObservationsCriteria = null;

	/**
	 * Collection to store aggregation of collPlaylists.
	 * @var array
	 */
	protected $collPlaylists;
	
	/**
	 * The criteria used to select the current contents of collPlaylists.
	 * @var Criteria
	 */
	private $lastPlaylistCriteria = null;

	/**
	 * Collection to store aggregation of collEmotionss.
	 * @var array
	 */
	protected $collEmotionss;
	
	/**
	 * The criteria used to select the current contents of collEmotionss.
	 * @var Criteria
	 */
	private $lastEmotionsCriteria = null;

	/**
	 * Collection to store aggregation of collEmotionSearchs.
	 * @var array
	 */
	protected $collEmotionSearchs;
	
	/**
	 * The criteria used to select the current contents of collEmotionSearchs.
	 * @var Criteria
	 */
	private $lastEmotionSearchCriteria = null;

	/**
	 * Collection to store aggregation of collNowPlayings.
	 * @var array
	 */
	protected $collNowPlayings;
	
	/**
	 * The criteria used to select the current contents of collNowPlayings.
	 * @var Criteria
	 */
	private $lastNowPlayingCriteria = null;

	/**
	 * Collection to store aggregation of collUserUsePlays.
	 * @var array
	 */
	protected $collUserUsePlays;
	
	/**
	 * The criteria used to select the current contents of collUserUsePlays.
	 * @var Criteria
	 */
	private $lastUserUsePlayCriteria = null;

	/**
	 * Collection to store aggregation of collAgendas.
	 * @var array
	 */
	protected $collAgendas;
	
	/**
	 * The criteria used to select the current contents of collAgendas.
	 * @var Criteria
	 */
	private $lastAgendaCriteria = null;

	/**
	 * Collection to store aggregation of collUserLinkss.
	 * @var array
	 */
	protected $collUserLinkss;
	
	/**
	 * The criteria used to select the current contents of collUserLinkss.
	 * @var Criteria
	 */
	private $lastUserLinksCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [userid] column value.
	 * 
	 * @return int
	 */
	public function getUserid()
	{

		return $this->userid;
	}

	/**
	 * Get the [idusertype] column value.
	 * 
	 * @return int
	 */
	public function getIdusertype()
	{

		return $this->idusertype;
	}

	/**
	 * Get the [userlogin] column value.
	 * 
	 * @return string
	 */
	public function getUserlogin()
	{

		return $this->userlogin;
	}

	/**
	 * Get the [pass] column value.
	 * 
	 * @return string
	 */
	public function getPass()
	{

		return $this->pass;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return string
	 */
	public function getName()
	{

		return $this->name;
	}

	/**
	 * Get the [firstname] column value.
	 * 
	 * @return string
	 */
	public function getFirstname()
	{

		return $this->firstname;
	}

	/**
	 * Get the [lastname] column value.
	 * 
	 * @return string
	 */
	public function getLastname()
	{

		return $this->lastname;
	}

	/**
	 * Get the [email] column value.
	 * 
	 * @return string
	 */
	public function getEmail()
	{

		return $this->email;
	}

	/**
	 * Get the [optionally formatted] [birthdate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getBirthdate($format = '%x')
	{

		if ($this->birthdate === null || $this->birthdate === '') {
			return null;
		} elseif (!is_int($this->birthdate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->birthdate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [birthdate] as date/time value: " . var_export($this->birthdate, true));
			}
		} else {
			$ts = $this->birthdate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [createdate] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreatedate($format = '%x')
	{

		if ($this->createdate === null || $this->createdate === '') {
			return null;
		} elseif (!is_int($this->createdate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->createdate);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [createdate] as date/time value: " . var_export($this->createdate, true));
			}
		} else {
			$ts = $this->createdate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [active] column value.
	 * 
	 * @return boolean
	 */
	public function getActive()
	{

		return $this->active;
	}

	/**
	 * Get the [maxmegas] column value.
	 * 
	 * @return int
	 */
	public function getMaxmegas()
	{

		return $this->maxmegas;
	}

	/**
	 * Get the [usedmegas] column value.
	 * 
	 * @return int
	 */
	public function getUsedmegas()
	{

		return $this->usedmegas;
	}

	/**
	 * Get the [emotionsmaxpoint] column value.
	 * 
	 * @return int
	 */
	public function getEmotionsmaxpoint()
	{

		return $this->emotionsmaxpoint;
	}

	/**
	 * Get the [emotionstypeselection] column value.
	 * 
	 * @return int
	 */
	public function getEmotionstypeselection()
	{

		return $this->emotionstypeselection;
	}

	/**
	 * Get the [preferenttop10] column value.
	 * 
	 * @return string
	 */
	public function getPreferenttop10()
	{

		return $this->preferenttop10;
	}

	/**
	 * Get the [viewlinks] column value.
	 * 
	 * @return boolean
	 */
	public function getViewlinks()
	{

		return $this->viewlinks;
	}

	/**
	 * Get the [preflanguages] column value.
	 * 
	 * @return int
	 */
	public function getPreflanguages()
	{

		return $this->preflanguages;
	}

	/**
	 * Get the [offsetpagination] column value.
	 * 
	 * @return int
	 */
	public function getOffsetpagination()
	{

		return $this->offsetpagination;
	}

	/**
	 * Set the value of [userid] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUserid($v)
	{

		if ($this->userid !== $v) {
			$this->userid = $v;
			$this->modifiedColumns[] = UsersPeer::USERID;
		}

	} // setUserid()

	/**
	 * Set the value of [idusertype] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setIdusertype($v)
	{

		if ($this->idusertype !== $v) {
			$this->idusertype = $v;
			$this->modifiedColumns[] = UsersPeer::IDUSERTYPE;
		}

		if ($this->aUserTypes !== null && $this->aUserTypes->getIdusertype() !== $v) {
			$this->aUserTypes = null;
		}		

	} // setIdusertype()

	/**
	 * Set the value of [userlogin] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setUserlogin($v)
	{

		if ($this->userlogin !== $v) {
			$this->userlogin = $v;
			$this->modifiedColumns[] = UsersPeer::USERLOGIN;
		}

	} // setUserlogin()

	/**
	 * Set the value of [pass] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setPass($v)
	{

		if ($this->pass !== $v) {
			$this->pass = $v;
			$this->modifiedColumns[] = UsersPeer::PASS;
		}

	} // setPass()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setName($v)
	{

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = UsersPeer::NAME;
		}

	} // setName()

	/**
	 * Set the value of [firstname] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setFirstname($v)
	{

		if ($this->firstname !== $v) {
			$this->firstname = $v;
			$this->modifiedColumns[] = UsersPeer::FIRSTNAME;
		}

	} // setFirstname()

	/**
	 * Set the value of [lastname] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setLastname($v)
	{

		if ($this->lastname !== $v) {
			$this->lastname = $v;
			$this->modifiedColumns[] = UsersPeer::LASTNAME;
		}

	} // setLastname()

	/**
	 * Set the value of [email] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setEmail($v)
	{

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = UsersPeer::EMAIL;
		}

	} // setEmail()

	/**
	 * Set the value of [birthdate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setBirthdate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [birthdate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->birthdate !== $ts) {
			$this->birthdate = $ts;
			$this->modifiedColumns[] = UsersPeer::BIRTHDATE;
		}

	} // setBirthdate()

	/**
	 * Set the value of [createdate] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setCreatedate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [createdate] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->createdate !== $ts) {
			$this->createdate = $ts;
			$this->modifiedColumns[] = UsersPeer::CREATEDATE;
		}

	} // setCreatedate()

	/**
	 * Set the value of [active] column.
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setActive($v)
	{

		if ($this->active !== $v) {
			$this->active = $v;
			$this->modifiedColumns[] = UsersPeer::ACTIVE;
		}

	} // setActive()

	/**
	 * Set the value of [maxmegas] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setMaxmegas($v)
	{

		if ($this->maxmegas !== $v || $v === 250) {
			$this->maxmegas = $v;
			$this->modifiedColumns[] = UsersPeer::MAXMEGAS;
		}

	} // setMaxmegas()

	/**
	 * Set the value of [usedmegas] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUsedmegas($v)
	{

		if ($this->usedmegas !== $v || $v === 0) {
			$this->usedmegas = $v;
			$this->modifiedColumns[] = UsersPeer::USEDMEGAS;
		}

	} // setUsedmegas()

	/**
	 * Set the value of [emotionsmaxpoint] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setEmotionsmaxpoint($v)
	{

		if ($this->emotionsmaxpoint !== $v || $v === 5) {
			$this->emotionsmaxpoint = $v;
			$this->modifiedColumns[] = UsersPeer::EMOTIONSMAXPOINT;
		}

	} // setEmotionsmaxpoint()

	/**
	 * Set the value of [emotionstypeselection] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setEmotionstypeselection($v)
	{

		if ($this->emotionstypeselection !== $v || $v === 1) {
			$this->emotionstypeselection = $v;
			$this->modifiedColumns[] = UsersPeer::EMOTIONSTYPESELECTION;
		}

	} // setEmotionstypeselection()

	/**
	 * Set the value of [preferenttop10] column.
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setPreferenttop10($v)
	{

		if ($this->preferenttop10 !== $v || $v === '\\a2,4,6,8,10\\a') {
			$this->preferenttop10 = $v;
			$this->modifiedColumns[] = UsersPeer::PREFERENTTOP10;
		}

	} // setPreferenttop10()

	/**
	 * Set the value of [viewlinks] column.
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setViewlinks($v)
	{

		if ($this->viewlinks !== $v || $v === true) {
			$this->viewlinks = $v;
			$this->modifiedColumns[] = UsersPeer::VIEWLINKS;
		}

	} // setViewlinks()

	/**
	 * Set the value of [preflanguages] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setPreflanguages($v)
	{

		if ($this->preflanguages !== $v) {
			$this->preflanguages = $v;
			$this->modifiedColumns[] = UsersPeer::PREFLANGUAGES;
		}

	} // setPreflanguages()

	/**
	 * Set the value of [offsetpagination] column.
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setOffsetpagination($v)
	{

		if ($this->offsetpagination !== $v) {
			$this->offsetpagination = $v;
			$this->modifiedColumns[] = UsersPeer::OFFSETPAGINATION;
		}

	} // setOffsetpagination()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->userid = $rs->getInt($startcol + 0);

			$this->idusertype = $rs->getInt($startcol + 1);

			$this->userlogin = $rs->getString($startcol + 2);

			$this->pass = $rs->getString($startcol + 3);

			$this->name = $rs->getString($startcol + 4);

			$this->firstname = $rs->getString($startcol + 5);

			$this->lastname = $rs->getString($startcol + 6);

			$this->email = $rs->getString($startcol + 7);

			$this->birthdate = $rs->getDate($startcol + 8, null);

			$this->createdate = $rs->getDate($startcol + 9, null);

			$this->active = $rs->getBoolean($startcol + 10);

			$this->maxmegas = $rs->getInt($startcol + 11);

			$this->usedmegas = $rs->getInt($startcol + 12);

			$this->emotionsmaxpoint = $rs->getInt($startcol + 13);

			$this->emotionstypeselection = $rs->getInt($startcol + 14);

			$this->preferenttop10 = $rs->getString($startcol + 15);

			$this->viewlinks = $rs->getBoolean($startcol + 16);

			$this->preflanguages = $rs->getInt($startcol + 17);

			$this->offsetpagination = $rs->getInt($startcol + 18);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 19; // 19 = UsersPeer::NUM_COLUMNS - UsersPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Users object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsersPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UsersPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsersPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUserTypes !== null) {
				if ($this->aUserTypes->isModified()) {
					$affectedRows += $this->aUserTypes->save($con);
				}
				$this->setUserTypes($this->aUserTypes);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UsersPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setUserid($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += UsersPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collSessions !== null) {
				foreach($this->collSessions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collObservationss !== null) {
				foreach($this->collObservationss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collPlaylists !== null) {
				foreach($this->collPlaylists as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collEmotionss !== null) {
				foreach($this->collEmotionss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collEmotionSearchs !== null) {
				foreach($this->collEmotionSearchs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collNowPlayings !== null) {
				foreach($this->collNowPlayings as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collUserUsePlays !== null) {
				foreach($this->collUserUsePlays as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collAgendas !== null) {
				foreach($this->collAgendas as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collUserLinkss !== null) {
				foreach($this->collUserLinkss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return array ValidationFailed[]
	 * @see validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 * @return boolean Whether all columns pass validation.
	 * @see doValidate()
	 * @see getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param array $columns Array of column names to validate.
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUserTypes !== null) {
				if (!$this->aUserTypes->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUserTypes->getValidationFailures());
				}
			}


			if (($retval = UsersPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collSessions !== null) {
					foreach($this->collSessions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collObservationss !== null) {
					foreach($this->collObservationss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collPlaylists !== null) {
					foreach($this->collPlaylists as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collEmotionss !== null) {
					foreach($this->collEmotionss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collEmotionSearchs !== null) {
					foreach($this->collEmotionSearchs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collNowPlayings !== null) {
					foreach($this->collNowPlayings as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collUserUsePlays !== null) {
					foreach($this->collUserUsePlays as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collAgendas !== null) {
					foreach($this->collAgendas as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collUserLinkss !== null) {
					foreach($this->collUserLinkss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UsersPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getUserid();
				break;
			case 1:
				return $this->getIdusertype();
				break;
			case 2:
				return $this->getUserlogin();
				break;
			case 3:
				return $this->getPass();
				break;
			case 4:
				return $this->getName();
				break;
			case 5:
				return $this->getFirstname();
				break;
			case 6:
				return $this->getLastname();
				break;
			case 7:
				return $this->getEmail();
				break;
			case 8:
				return $this->getBirthdate();
				break;
			case 9:
				return $this->getCreatedate();
				break;
			case 10:
				return $this->getActive();
				break;
			case 11:
				return $this->getMaxmegas();
				break;
			case 12:
				return $this->getUsedmegas();
				break;
			case 13:
				return $this->getEmotionsmaxpoint();
				break;
			case 14:
				return $this->getEmotionstypeselection();
				break;
			case 15:
				return $this->getPreferenttop10();
				break;
			case 16:
				return $this->getViewlinks();
				break;
			case 17:
				return $this->getPreflanguages();
				break;
			case 18:
				return $this->getOffsetpagination();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UsersPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getUserid(),
			$keys[1] => $this->getIdusertype(),
			$keys[2] => $this->getUserlogin(),
			$keys[3] => $this->getPass(),
			$keys[4] => $this->getName(),
			$keys[5] => $this->getFirstname(),
			$keys[6] => $this->getLastname(),
			$keys[7] => $this->getEmail(),
			$keys[8] => $this->getBirthdate(),
			$keys[9] => $this->getCreatedate(),
			$keys[10] => $this->getActive(),
			$keys[11] => $this->getMaxmegas(),
			$keys[12] => $this->getUsedmegas(),
			$keys[13] => $this->getEmotionsmaxpoint(),
			$keys[14] => $this->getEmotionstypeselection(),
			$keys[15] => $this->getPreferenttop10(),
			$keys[16] => $this->getViewlinks(),
			$keys[17] => $this->getPreflanguages(),
			$keys[18] => $this->getOffsetpagination(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UsersPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setUserid($value);
				break;
			case 1:
				$this->setIdusertype($value);
				break;
			case 2:
				$this->setUserlogin($value);
				break;
			case 3:
				$this->setPass($value);
				break;
			case 4:
				$this->setName($value);
				break;
			case 5:
				$this->setFirstname($value);
				break;
			case 6:
				$this->setLastname($value);
				break;
			case 7:
				$this->setEmail($value);
				break;
			case 8:
				$this->setBirthdate($value);
				break;
			case 9:
				$this->setCreatedate($value);
				break;
			case 10:
				$this->setActive($value);
				break;
			case 11:
				$this->setMaxmegas($value);
				break;
			case 12:
				$this->setUsedmegas($value);
				break;
			case 13:
				$this->setEmotionsmaxpoint($value);
				break;
			case 14:
				$this->setEmotionstypeselection($value);
				break;
			case 15:
				$this->setPreferenttop10($value);
				break;
			case 16:
				$this->setViewlinks($value);
				break;
			case 17:
				$this->setPreflanguages($value);
				break;
			case 18:
				$this->setOffsetpagination($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UsersPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setUserid($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdusertype($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUserlogin($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setPass($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setName($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setFirstname($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setLastname($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setEmail($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setBirthdate($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setCreatedate($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setActive($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setMaxmegas($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setUsedmegas($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setEmotionsmaxpoint($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setEmotionstypeselection($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setPreferenttop10($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setViewlinks($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setPreflanguages($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setOffsetpagination($arr[$keys[18]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(UsersPeer::DATABASE_NAME);

		if ($this->isColumnModified(UsersPeer::USERID)) $criteria->add(UsersPeer::USERID, $this->userid);
		if ($this->isColumnModified(UsersPeer::IDUSERTYPE)) $criteria->add(UsersPeer::IDUSERTYPE, $this->idusertype);
		if ($this->isColumnModified(UsersPeer::USERLOGIN)) $criteria->add(UsersPeer::USERLOGIN, $this->userlogin);
		if ($this->isColumnModified(UsersPeer::PASS)) $criteria->add(UsersPeer::PASS, $this->pass);
		if ($this->isColumnModified(UsersPeer::NAME)) $criteria->add(UsersPeer::NAME, $this->name);
		if ($this->isColumnModified(UsersPeer::FIRSTNAME)) $criteria->add(UsersPeer::FIRSTNAME, $this->firstname);
		if ($this->isColumnModified(UsersPeer::LASTNAME)) $criteria->add(UsersPeer::LASTNAME, $this->lastname);
		if ($this->isColumnModified(UsersPeer::EMAIL)) $criteria->add(UsersPeer::EMAIL, $this->email);
		if ($this->isColumnModified(UsersPeer::BIRTHDATE)) $criteria->add(UsersPeer::BIRTHDATE, $this->birthdate);
		if ($this->isColumnModified(UsersPeer::CREATEDATE)) $criteria->add(UsersPeer::CREATEDATE, $this->createdate);
		if ($this->isColumnModified(UsersPeer::ACTIVE)) $criteria->add(UsersPeer::ACTIVE, $this->active);
		if ($this->isColumnModified(UsersPeer::MAXMEGAS)) $criteria->add(UsersPeer::MAXMEGAS, $this->maxmegas);
		if ($this->isColumnModified(UsersPeer::USEDMEGAS)) $criteria->add(UsersPeer::USEDMEGAS, $this->usedmegas);
		if ($this->isColumnModified(UsersPeer::EMOTIONSMAXPOINT)) $criteria->add(UsersPeer::EMOTIONSMAXPOINT, $this->emotionsmaxpoint);
		if ($this->isColumnModified(UsersPeer::EMOTIONSTYPESELECTION)) $criteria->add(UsersPeer::EMOTIONSTYPESELECTION, $this->emotionstypeselection);
		if ($this->isColumnModified(UsersPeer::PREFERENTTOP10)) $criteria->add(UsersPeer::PREFERENTTOP10, $this->preferenttop10);
		if ($this->isColumnModified(UsersPeer::VIEWLINKS)) $criteria->add(UsersPeer::VIEWLINKS, $this->viewlinks);
		if ($this->isColumnModified(UsersPeer::PREFLANGUAGES)) $criteria->add(UsersPeer::PREFLANGUAGES, $this->preflanguages);
		if ($this->isColumnModified(UsersPeer::OFFSETPAGINATION)) $criteria->add(UsersPeer::OFFSETPAGINATION, $this->offsetpagination);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UsersPeer::DATABASE_NAME);

		$criteria->add(UsersPeer::USERID, $this->userid);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int
	 */
	public function getPrimaryKey()
	{
		return $this->getUserid();
	}

	/**
	 * Generic method to set the primary key (userid column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setUserid($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Users (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdusertype($this->idusertype);

		$copyObj->setUserlogin($this->userlogin);

		$copyObj->setPass($this->pass);

		$copyObj->setName($this->name);

		$copyObj->setFirstname($this->firstname);

		$copyObj->setLastname($this->lastname);

		$copyObj->setEmail($this->email);

		$copyObj->setBirthdate($this->birthdate);

		$copyObj->setCreatedate($this->createdate);

		$copyObj->setActive($this->active);

		$copyObj->setMaxmegas($this->maxmegas);

		$copyObj->setUsedmegas($this->usedmegas);

		$copyObj->setEmotionsmaxpoint($this->emotionsmaxpoint);

		$copyObj->setEmotionstypeselection($this->emotionstypeselection);

		$copyObj->setPreferenttop10($this->preferenttop10);

		$copyObj->setViewlinks($this->viewlinks);

		$copyObj->setPreflanguages($this->preflanguages);

		$copyObj->setOffsetpagination($this->offsetpagination);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getSessions() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addSession($relObj->copy($deepCopy));
				}
			}

			foreach($this->getObservationss() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addObservations($relObj->copy($deepCopy));
				}
			}

			foreach($this->getPlaylists() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addPlaylist($relObj->copy($deepCopy));
				}
			}

			foreach($this->getEmotionss() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addEmotions($relObj->copy($deepCopy));
				}
			}

			foreach($this->getEmotionSearchs() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addEmotionSearch($relObj->copy($deepCopy));
				}
			}

			foreach($this->getNowPlayings() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addNowPlaying($relObj->copy($deepCopy));
				}
			}

			foreach($this->getUserUsePlays() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addUserUsePlay($relObj->copy($deepCopy));
				}
			}

			foreach($this->getAgendas() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addAgenda($relObj->copy($deepCopy));
				}
			}

			foreach($this->getUserLinkss() as $relObj) {
				if($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addUserLinks($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setUserid(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Users Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return UsersPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UsersPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a UserTypes object.
	 *
	 * @param UserTypes $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUserTypes($v)
	{


		if ($v === null) {
			$this->setIdusertype(NULL);
		} else {
			$this->setIdusertype($v->getIdusertype());
		}


		$this->aUserTypes = $v;
	}


	/**
	 * Get the associated UserTypes object
	 *
	 * @param Connection Optional Connection object.
	 * @return UserTypes The associated UserTypes object.
	 * @throws PropelException
	 */
	public function getUserTypes($con = null)
	{
		// include the related Peer class
		include_once 'Model/om/BaseUserTypesPeer.php';

		if ($this->aUserTypes === null && ($this->idusertype !== null)) {

			$this->aUserTypes = UserTypesPeer::retrieveByPK($this->idusertype, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserTypesPeer::retrieveByPK($this->idusertype, $con);
			   $obj->addUserTypess($this);
			 */
		}
		return $this->aUserTypes;
	}

	/**
	 * Temporary storage of collSessions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initSessions()
	{
		if ($this->collSessions === null) {
			$this->collSessions = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related Sessions from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getSessions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSessionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessions === null) {
			if ($this->isNew()) {
			   $this->collSessions = array();
			} else {

				$criteria->add(SessionPeer::USERID, $this->getUserid());

				SessionPeer::addSelectColumns($criteria);
				$this->collSessions = SessionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(SessionPeer::USERID, $this->getUserid());

				SessionPeer::addSelectColumns($criteria);
				if (!isset($this->lastSessionCriteria) || !$this->lastSessionCriteria->equals($criteria)) {
					$this->collSessions = SessionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSessionCriteria = $criteria;
		return $this->collSessions;
	}

	/**
	 * Returns the number of related Sessions.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countSessions($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseSessionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SessionPeer::USERID, $this->getUserid());

		return SessionPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a Session object to this object
	 * through the Session foreign key attribute
	 *
	 * @param Session $l Session
	 * @return void
	 * @throws PropelException
	 */
	public function addSession(Session $l)
	{
		$this->collSessions[] = $l;
		$l->setUsers($this);
	}

	/**
	 * Temporary storage of collObservationss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initObservationss()
	{
		if ($this->collObservationss === null) {
			$this->collObservationss = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related Observationss from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getObservationss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseObservationsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collObservationss === null) {
			if ($this->isNew()) {
			   $this->collObservationss = array();
			} else {

				$criteria->add(ObservationsPeer::USERID, $this->getUserid());

				ObservationsPeer::addSelectColumns($criteria);
				$this->collObservationss = ObservationsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ObservationsPeer::USERID, $this->getUserid());

				ObservationsPeer::addSelectColumns($criteria);
				if (!isset($this->lastObservationsCriteria) || !$this->lastObservationsCriteria->equals($criteria)) {
					$this->collObservationss = ObservationsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastObservationsCriteria = $criteria;
		return $this->collObservationss;
	}

	/**
	 * Returns the number of related Observationss.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countObservationss($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseObservationsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ObservationsPeer::USERID, $this->getUserid());

		return ObservationsPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a Observations object to this object
	 * through the Observations foreign key attribute
	 *
	 * @param Observations $l Observations
	 * @return void
	 * @throws PropelException
	 */
	public function addObservations(Observations $l)
	{
		$this->collObservationss[] = $l;
		$l->setUsers($this);
	}

	/**
	 * Temporary storage of collPlaylists to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPlaylists()
	{
		if ($this->collPlaylists === null) {
			$this->collPlaylists = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related Playlists from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPlaylists($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPlaylists === null) {
			if ($this->isNew()) {
			   $this->collPlaylists = array();
			} else {

				$criteria->add(PlaylistPeer::USERID, $this->getUserid());

				PlaylistPeer::addSelectColumns($criteria);
				$this->collPlaylists = PlaylistPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(PlaylistPeer::USERID, $this->getUserid());

				PlaylistPeer::addSelectColumns($criteria);
				if (!isset($this->lastPlaylistCriteria) || !$this->lastPlaylistCriteria->equals($criteria)) {
					$this->collPlaylists = PlaylistPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPlaylistCriteria = $criteria;
		return $this->collPlaylists;
	}

	/**
	 * Returns the number of related Playlists.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countPlaylists($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PlaylistPeer::USERID, $this->getUserid());

		return PlaylistPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a Playlist object to this object
	 * through the Playlist foreign key attribute
	 *
	 * @param Playlist $l Playlist
	 * @return void
	 * @throws PropelException
	 */
	public function addPlaylist(Playlist $l)
	{
		$this->collPlaylists[] = $l;
		$l->setUsers($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Playlists from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getPlaylistsJoinMusicElementType($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BasePlaylistPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPlaylists === null) {
			if ($this->isNew()) {
				$this->collPlaylists = array();
			} else {

				$criteria->add(PlaylistPeer::USERID, $this->getUserid());

				$this->collPlaylists = PlaylistPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PlaylistPeer::USERID, $this->getUserid());

			if (!isset($this->lastPlaylistCriteria) || !$this->lastPlaylistCriteria->equals($criteria)) {
				$this->collPlaylists = PlaylistPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		}
		$this->lastPlaylistCriteria = $criteria;

		return $this->collPlaylists;
	}

	/**
	 * Temporary storage of collEmotionss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initEmotionss()
	{
		if ($this->collEmotionss === null) {
			$this->collEmotionss = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related Emotionss from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getEmotionss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionss === null) {
			if ($this->isNew()) {
			   $this->collEmotionss = array();
			} else {

				$criteria->add(EmotionsPeer::USERID, $this->getUserid());

				EmotionsPeer::addSelectColumns($criteria);
				$this->collEmotionss = EmotionsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(EmotionsPeer::USERID, $this->getUserid());

				EmotionsPeer::addSelectColumns($criteria);
				if (!isset($this->lastEmotionsCriteria) || !$this->lastEmotionsCriteria->equals($criteria)) {
					$this->collEmotionss = EmotionsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastEmotionsCriteria = $criteria;
		return $this->collEmotionss;
	}

	/**
	 * Returns the number of related Emotionss.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countEmotionss($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(EmotionsPeer::USERID, $this->getUserid());

		return EmotionsPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a Emotions object to this object
	 * through the Emotions foreign key attribute
	 *
	 * @param Emotions $l Emotions
	 * @return void
	 * @throws PropelException
	 */
	public function addEmotions(Emotions $l)
	{
		$this->collEmotionss[] = $l;
		$l->setUsers($this);
	}

	/**
	 * Temporary storage of collEmotionSearchs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initEmotionSearchs()
	{
		if ($this->collEmotionSearchs === null) {
			$this->collEmotionSearchs = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related EmotionSearchs from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getEmotionSearchs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionSearchPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionSearchs === null) {
			if ($this->isNew()) {
			   $this->collEmotionSearchs = array();
			} else {

				$criteria->add(EmotionSearchPeer::USERID, $this->getUserid());

				EmotionSearchPeer::addSelectColumns($criteria);
				$this->collEmotionSearchs = EmotionSearchPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(EmotionSearchPeer::USERID, $this->getUserid());

				EmotionSearchPeer::addSelectColumns($criteria);
				if (!isset($this->lastEmotionSearchCriteria) || !$this->lastEmotionSearchCriteria->equals($criteria)) {
					$this->collEmotionSearchs = EmotionSearchPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastEmotionSearchCriteria = $criteria;
		return $this->collEmotionSearchs;
	}

	/**
	 * Returns the number of related EmotionSearchs.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countEmotionSearchs($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionSearchPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(EmotionSearchPeer::USERID, $this->getUserid());

		return EmotionSearchPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a EmotionSearch object to this object
	 * through the EmotionSearch foreign key attribute
	 *
	 * @param EmotionSearch $l EmotionSearch
	 * @return void
	 * @throws PropelException
	 */
	public function addEmotionSearch(EmotionSearch $l)
	{
		$this->collEmotionSearchs[] = $l;
		$l->setUsers($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related EmotionSearchs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getEmotionSearchsJoinEmotions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseEmotionSearchPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEmotionSearchs === null) {
			if ($this->isNew()) {
				$this->collEmotionSearchs = array();
			} else {

				$criteria->add(EmotionSearchPeer::USERID, $this->getUserid());

				$this->collEmotionSearchs = EmotionSearchPeer::doSelectJoinEmotions($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(EmotionSearchPeer::USERID, $this->getUserid());

			if (!isset($this->lastEmotionSearchCriteria) || !$this->lastEmotionSearchCriteria->equals($criteria)) {
				$this->collEmotionSearchs = EmotionSearchPeer::doSelectJoinEmotions($criteria, $con);
			}
		}
		$this->lastEmotionSearchCriteria = $criteria;

		return $this->collEmotionSearchs;
	}

	/**
	 * Temporary storage of collNowPlayings to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initNowPlayings()
	{
		if ($this->collNowPlayings === null) {
			$this->collNowPlayings = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related NowPlayings from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getNowPlayings($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseNowPlayingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNowPlayings === null) {
			if ($this->isNew()) {
			   $this->collNowPlayings = array();
			} else {

				$criteria->add(NowPlayingPeer::USERID, $this->getUserid());

				NowPlayingPeer::addSelectColumns($criteria);
				$this->collNowPlayings = NowPlayingPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(NowPlayingPeer::USERID, $this->getUserid());

				NowPlayingPeer::addSelectColumns($criteria);
				if (!isset($this->lastNowPlayingCriteria) || !$this->lastNowPlayingCriteria->equals($criteria)) {
					$this->collNowPlayings = NowPlayingPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNowPlayingCriteria = $criteria;
		return $this->collNowPlayings;
	}

	/**
	 * Returns the number of related NowPlayings.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countNowPlayings($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseNowPlayingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(NowPlayingPeer::USERID, $this->getUserid());

		return NowPlayingPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a NowPlaying object to this object
	 * through the NowPlaying foreign key attribute
	 *
	 * @param NowPlaying $l NowPlaying
	 * @return void
	 * @throws PropelException
	 */
	public function addNowPlaying(NowPlaying $l)
	{
		$this->collNowPlayings[] = $l;
		$l->setUsers($this);
	}

	/**
	 * Temporary storage of collUserUsePlays to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserUsePlays()
	{
		if ($this->collUserUsePlays === null) {
			$this->collUserUsePlays = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserUsePlays($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
			   $this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

				UserUsePlayPeer::addSelectColumns($criteria);
				$this->collUserUsePlays = UserUsePlayPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

				UserUsePlayPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
					$this->collUserUsePlays = UserUsePlayPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;
		return $this->collUserUsePlays;
	}

	/**
	 * Returns the number of related UserUsePlays.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countUserUsePlays($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

		return UserUsePlayPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a UserUsePlay object to this object
	 * through the UserUsePlay foreign key attribute
	 *
	 * @param UserUsePlay $l UserUsePlay
	 * @return void
	 * @throws PropelException
	 */
	public function addUserUsePlay(UserUsePlay $l)
	{
		$this->collUserUsePlays[] = $l;
		$l->setUsers($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getUserUsePlaysJoinEmotions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
				$this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinEmotions($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

			if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinEmotions($criteria, $con);
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;

		return $this->collUserUsePlays;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getUserUsePlaysJoinObservations($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
				$this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinObservations($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

			if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinObservations($criteria, $con);
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;

		return $this->collUserUsePlays;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related UserUsePlays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getUserUsePlaysJoinMusicElementType($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserUsePlayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserUsePlays === null) {
			if ($this->isNew()) {
				$this->collUserUsePlays = array();
			} else {

				$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserUsePlayPeer::USERID, $this->getUserid());

			if (!isset($this->lastUserUsePlayCriteria) || !$this->lastUserUsePlayCriteria->equals($criteria)) {
				$this->collUserUsePlays = UserUsePlayPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		}
		$this->lastUserUsePlayCriteria = $criteria;

		return $this->collUserUsePlays;
	}

	/**
	 * Temporary storage of collAgendas to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initAgendas()
	{
		if ($this->collAgendas === null) {
			$this->collAgendas = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related Agendas from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getAgendas($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseAgendaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAgendas === null) {
			if ($this->isNew()) {
			   $this->collAgendas = array();
			} else {

				$criteria->add(AgendaPeer::USERID, $this->getUserid());

				AgendaPeer::addSelectColumns($criteria);
				$this->collAgendas = AgendaPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(AgendaPeer::USERID, $this->getUserid());

				AgendaPeer::addSelectColumns($criteria);
				if (!isset($this->lastAgendaCriteria) || !$this->lastAgendaCriteria->equals($criteria)) {
					$this->collAgendas = AgendaPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastAgendaCriteria = $criteria;
		return $this->collAgendas;
	}

	/**
	 * Returns the number of related Agendas.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countAgendas($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseAgendaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(AgendaPeer::USERID, $this->getUserid());

		return AgendaPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a Agenda object to this object
	 * through the Agenda foreign key attribute
	 *
	 * @param Agenda $l Agenda
	 * @return void
	 * @throws PropelException
	 */
	public function addAgenda(Agenda $l)
	{
		$this->collAgendas[] = $l;
		$l->setUsers($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Agendas from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getAgendasJoinObservations($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseAgendaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAgendas === null) {
			if ($this->isNew()) {
				$this->collAgendas = array();
			} else {

				$criteria->add(AgendaPeer::USERID, $this->getUserid());

				$this->collAgendas = AgendaPeer::doSelectJoinObservations($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(AgendaPeer::USERID, $this->getUserid());

			if (!isset($this->lastAgendaCriteria) || !$this->lastAgendaCriteria->equals($criteria)) {
				$this->collAgendas = AgendaPeer::doSelectJoinObservations($criteria, $con);
			}
		}
		$this->lastAgendaCriteria = $criteria;

		return $this->collAgendas;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Agendas from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getAgendasJoinMusicElementType($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseAgendaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collAgendas === null) {
			if ($this->isNew()) {
				$this->collAgendas = array();
			} else {

				$criteria->add(AgendaPeer::USERID, $this->getUserid());

				$this->collAgendas = AgendaPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(AgendaPeer::USERID, $this->getUserid());

			if (!isset($this->lastAgendaCriteria) || !$this->lastAgendaCriteria->equals($criteria)) {
				$this->collAgendas = AgendaPeer::doSelectJoinMusicElementType($criteria, $con);
			}
		}
		$this->lastAgendaCriteria = $criteria;

		return $this->collAgendas;
	}

	/**
	 * Temporary storage of collUserLinkss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserLinkss()
	{
		if ($this->collUserLinkss === null) {
			$this->collUserLinkss = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users has previously
	 * been saved, it will retrieve related UserLinkss from storage.
	 * If this Users is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserLinkss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserLinksPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserLinkss === null) {
			if ($this->isNew()) {
			   $this->collUserLinkss = array();
			} else {

				$criteria->add(UserLinksPeer::USERID, $this->getUserid());

				UserLinksPeer::addSelectColumns($criteria);
				$this->collUserLinkss = UserLinksPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UserLinksPeer::USERID, $this->getUserid());

				UserLinksPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserLinksCriteria) || !$this->lastUserLinksCriteria->equals($criteria)) {
					$this->collUserLinkss = UserLinksPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserLinksCriteria = $criteria;
		return $this->collUserLinkss;
	}

	/**
	 * Returns the number of related UserLinkss.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countUserLinkss($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserLinksPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UserLinksPeer::USERID, $this->getUserid());

		return UserLinksPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a UserLinks object to this object
	 * through the UserLinks foreign key attribute
	 *
	 * @param UserLinks $l UserLinks
	 * @return void
	 * @throws PropelException
	 */
	public function addUserLinks(UserLinks $l)
	{
		$this->collUserLinkss[] = $l;
		$l->setUsers($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related UserLinkss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getUserLinkssJoinLinks($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserLinksPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserLinkss === null) {
			if ($this->isNew()) {
				$this->collUserLinkss = array();
			} else {

				$criteria->add(UserLinksPeer::USERID, $this->getUserid());

				$this->collUserLinkss = UserLinksPeer::doSelectJoinLinks($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserLinksPeer::USERID, $this->getUserid());

			if (!isset($this->lastUserLinksCriteria) || !$this->lastUserLinksCriteria->equals($criteria)) {
				$this->collUserLinkss = UserLinksPeer::doSelectJoinLinks($criteria, $con);
			}
		}
		$this->lastUserLinksCriteria = $criteria;

		return $this->collUserLinkss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related UserLinkss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getUserLinkssJoinArtist($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'Model/om/BaseUserLinksPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserLinkss === null) {
			if ($this->isNew()) {
				$this->collUserLinkss = array();
			} else {

				$criteria->add(UserLinksPeer::USERID, $this->getUserid());

				$this->collUserLinkss = UserLinksPeer::doSelectJoinArtist($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserLinksPeer::USERID, $this->getUserid());

			if (!isset($this->lastUserLinksCriteria) || !$this->lastUserLinksCriteria->equals($criteria)) {
				$this->collUserLinkss = UserLinksPeer::doSelectJoinArtist($criteria, $con);
			}
		}
		$this->lastUserLinksCriteria = $criteria;

		return $this->collUserLinkss;
	}

} // BaseUsers
