<?php

class FR_Multimedia_Tag extends FR_Multimedia_InfoFile
{

private $tag;

/**
 * 
 *   @param array $info_file Informacin obtenida del fichero multimedia
 *   @param string $type_tag Ens diu quin tipus de tags san de llegir, escolli pel factory
 * */

function __construct($info_file,$type_tag) 	{
	
	parent::__construct($info_file);
	$this->tag=$type_tag;
} 
										
public function getAlbum() {
	
	if(isset($this->ID3['tags_html'][$this->tag]['album']['0']))
			return $this->ID3['tags_html'][$this->tag]['album']['0'];	
	else 
	 return false;	
}

public function getArtist() {

	 if(isset($this->ID3['tags_html'][$this->tag]['artist']['0']))
	 		return $this->ID3['tags_html'][$this->tag]['artist']['0'];
	 else 
		return false;
}

public function getComment(){
	
	if(isset($this->ID3['tags_html'][$this->tag]['comment']['0']))
		return $this->ID3['tags_html'][$this->tag]['comment']['0'];
	else return false;
}

public function getGenere() {

	if(isset($this->ID3['tags_html'][$this->tag]['genre']['0']))	
		return $this->ID3['tags_html'][$this->tag]['genre']['0'];
	else return false;
}

public function getGenereId(){

	//return $this->ID3['tags_html'][$this->tag]['comment']['0'];
}

public function getTitle() {

	if(isset($this->ID3['tags_html'][$this->tag]['title']['0']))
		return $this->ID3['tags_html'][$this->tag]['title']['0'];
	else return false;

}

public function getTrack() {

	if(isset($this->ID3['tags_html'][$this->tag]['track']['0']))
		return $this->ID3['tags_html'][$this->tag]['track']['0'];
	else return false;
}

public function getTotalTracks() {

	if(isset($this->ID3['tags_html'][$this->tag]['totaltracks']['0']))
		return $this->ID3['tags_html'][$this->tag]['totaltracks']['0'];
	else return false;

}

public function getYear(){

	if(isset($this->ID3['tags_html'][$this->tag]['year']['0']))
		return $this->ID3['tags_html'][$this->tag]['year']['0'];
	else return false;

}

public function getMode() {

	if(isset($this->ID3['audio']['bitrate_mode']))
		return $this->ID3['audio']['bitrate_mode'];
	else return false;
}

/**
 * Freqencia de la canco
 * */
public function getRate() {

	if(isset($this->ID3['audio']['sample_rate']))
		return $this->ID3['audio']['sample_rate'];
	else return false;
}


/*** Mitjana del bitrate de tot el fitxer. 
*  @return String
*/

public function getBitRate() {

	if(isset($this->ID3['bitrate']))	return $this->ID3['bitrate'];
	else return false;
}

/*
* Torna la duraci de la cano,
* mm:ss
* @return String
**/
public function getPlayTime() {

	if(isset($this->ID3['playtime_seconds']))	return $this->ID3['playtime_seconds'];
	else return false;
}

public function getDataFormat() {

	if(isset($this->ID3['dataformat']))	return $this->ID3['dataformat'];
	else return false;
}

/** 
 * 
 * Nos informa si la cancion lleva incrustada la imagen en el tag
 * Slo los tags ID3v2 llevan incrustada la imagen.
 * @return boolean Si la cancion lleva incrustada la imagen en el tag 
 * 
 * */
 
public function isImage()
{
	
	/*  Solamente los tags id3v2 contiene la imagen */
	if('id3v2' == $this->tag)
	{
		if(isset($this->info['id3v2']['APIC'])) return true;
		else return false;
	}
		
}

/**
 * Devuelve los datos de la imagen en caso de tenerlos.
 * @return string Codigo binario de la imagen a representar*/
public function getImage()
{

	if($this->isImage()) return $this->info['id3v2']['APIC'][0]['data'];
	else return false;	
	
}




}

?>
