<?php

  /**
  * FR_Presenter_playlist
  *
  * @author J.Emilio Navarro Rodriguez <jemilionr@yahoo.es>
  * @copyright J.Emilio Navarro Rodriguez <jemilionr@yahoo.es>
  * @license http://www.opensource.org/licenses/gpl-license.php
  * @package Framework
  * @filesource
  */


  /**
  * FR_Presenter_playlist
  *
  * Want to display your module's data in valid XML rather than HTML? This
  * presenter will automatically take your data and output it in valid XML.
  *
  * @author Joe Stump <joe@joestump.net>
  * @package Framework
  */
  class FR_Presenter_playlist extends FR_Presenter_common
  {
      // {{{ __construct(FR_Module $module)
      /**
      * __construct
      *
      * @author Joe Stump <joe@joestump.net>
      * @access public
      * @param mixed $module Instance of FR_Module
      * @return void
      */
      public function __construct(FR_Module $module)
      {
          parent::__construct($module);
      }
      // }}}
      // {{{ display()
      /**
      *
      * @author Joe Stump <joe@joestump.net>
      * @return void
      *
      */
      public function display()
      {
      	$data = $this->module->getData();
      	$filename = str_replace(" ","_",$data['name']);
      	$filename.=".m3u";     
        header('Cache-control: public');
		header('Content-Disposition: filename='.$filename);
		header('Content-Type: audio/x-mpegurl;');				
        print $data['music_list'];   

      }
      // }}}
      // {{{ __destruct()
      public function __destruct()
      {
          parent::__destruct();
      }
      // }}}
  }

?>
