<?php

  /**
  * FR_User
  *
  * @author Joe Stump <joe@joestump.net>
  * @copyright Joe Stump <joe@joestump.net>
  * @license http://www.opensource.org/licenses/gpl-license.php
  * @package Framework
  * @filesource
  */

  /**
  * FR_User
  *
  * Base user object.
  *
  * @author Joe Stump <joe@joestump.net>
  * @package Framework
  */
  
  class FR_User extends FR_Object_DB
  {
      public $userID;
      public $login;
      public $name;
      public $fname;
      public $lname;
      public $email;
      public $password;
      public $idioma; /* Por defecto 1, cuando arranca la aplicacion */
      public $posted;
      public $level;/*Nivel de acceso al sistema para el usuario*/
   

      public function __construct($userID=null)
      {
          parent::__construct();

			//$a === $b (identidad). Cierto si $a es igual a $b y si son del mismo tipo 
			
          if ($userID === null) {
              $session = FR_Session::singleton();           
               
              if (!is_numeric($session->userID)) {
                  $userID = 0; 
              } else {
                  $userID = $session->userID;
              }
          }
          
         	    
			$n_user = UsersPeer::retrieveByPK($userID); 		
			
			
			/*
			 * Si es la primera llamada no tenemos usuario assignado, 
			 * vamos al LOGIN 
			 * */	  
          	if (isset($n_user)) $this->loadUserData($n_user);
      }

	  private function loadUserData(&$user) {
      	                        
      	  $this->userID = $user->getUserid();
      	  $this->login = $user->getUserlogin();
      	  $this->name =  $user->getName();      	 
      	  $this->fname = $user->getFirstname();
      	  $this->lname = $user->getLastname();
      	  $this->email = $user->getEmail();
      	  $this->password = $user->getPass();
      	  $this->idioma = $user->getPreflanguages();   /*Dar de alta en la BD*/   	
      	  $this->level = $user->getIdusertype();        	    	
      }

      public function __destruct()
      {
          parent::__destruct();
      }
  }

?>
