<?php
/*
 *                      UserActions.php
 *                    ------------------
 * Creat            : 08-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */
 
class FR_UserActions extends FR_Object_Web {
 
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
         
      }      
      /**
       * Informa si el usuario esta reproduiendo una cancion.
       * Si esta reproduciendo una cancion devuelve la cancion que esta reproduciendo.
       * @return $mixed Boolean si no reproduce nada.
       * @return $mixed Song si esta reproduciendo una cancin.
       */
 	public static function isStreamingUser($id_user,$id_session)
 	{
 	 try{	
 	     	$c = new Criteria(); 
     		$c -> add(NowPlayingPeer::USERID,$id_user);
			$c -> addAnd(NowPlayingPeer::SESSION,$id_session);
			$rs = NowPlayingPeer::doSelect($c);
	        
	        $result = count($rs);			
			if( 1 == $result ) return $rs[0];
			else return false;			
      }
     catch(PropelException $ex) {
     	 return false;
     }	
 		
 	}
 	
     
     /**
      * Actualiza la cancion que esta reproduciendo el usuario si
      * existe sino crea un nuevo registro de reproduccion actual.   *
      * @param int $id_user Identificador del usuario que esta reproduciendo $song_update. 
      * @param string $id_session. Identificador de session del usuario actual.
      * @param int	$song_update. Identificador de la cancion que esta reproduciendo el 
      * */     
      
    
    
    
 public static function nowPlayingUpdate($id_user,$id_session,$song_update) {
     	
     	   // If they are using Windows media player
     	 $user_agent = $_SERVER['HTTP_USER_AGENT'];
     	 $browser = split("/",$user_agent,2);	 
       
       	
       	//FR_Util_Logs::streamLogs("USER AGENT:".$user_agent);
       	//FR_Util_Logs::streamLogs($browser[0]);		
		
        /* Windows Media Player is evil and it makes multiple requests per song */
        if (stristr($browser[0],"Windows-Media-Player")) { 
      	
          return false; 
        }      
       
		if (stristr($browser[0],"NSPlayer")) { 
        //WMP does keep the session open so we need to cheat a little here
        	FR_Util_Logs::streamLogs("NSPlayer1111");		  
		   $id_session = mysql_real_escape_string($id_session);
        }
     	
     	
     	$playing = self::isStreamingUser($id_user,$id_session);
     	
     	//* Set expire time for worst case clean up */    	
     	     
     
     try {	
	     	/*Comprovavamos que si que teniamos un elemento reproduciendose.*/
	     	if ($playing instanceof NowPlaying) {
	     		$playing->setIdsong($song_update);	     		
	     	}
	     	else /*hay que crear una nueva entrada */ {
	     		$playing = new NowPlaying();
	     		$playing->setUserid($id_user);
	     		$playing->setSession($id_session);
	     		$playing->setIdsong($song_update);    		
	     	}     	
     	$playing->save();
      }
     	 catch(PropelException $ex) {
     	 	
     	 	FR_Util_Logs::streamLogs("PROPEL".$ex->getCause());		
     	 
     	 return false;
     }
   }
   
   public static function deleteNowPlaying($id_user,$id_session)
   {
   		 $user_agent = $_SERVER['HTTP_USER_AGENT'];
     	 $browser = split("/",$user_agent,2);	
   		 if (stristr($browser[0],"Windows-Media-Player")) {
   		 	return false;
   		 }
   		  
   		 if (stristr($browser[0],"NSPlayer")) { 
        //WMP does keep the session open so we need to cheat a little here
        	FR_Util_Logs::streamLogs("NSPlayer1111");		  
		   $id_session = mysql_real_escape_string($id_session);
        }
   		 
   		$playing = self::isStreamingUser($id_user,$id_session);
   		$playing ->delete();
   }
     
     
     	 
        /**
       * 
       * Augmentar el contador de elementos de reproduccin del usuario.
       * @param int $elem_type Tipo de elemento que se esta reproduciendo.(Ejemplo:1 = cancion)
       * @param int $id_element  Identificador del elemento reproducido.
       *          
       * */ 
       
      public static function addCountElementPlay($elem_type,$id_element,$userID)     
      {
      		/* Contador de la aplicacio */
      		self::addCountPlay($elem_type,$id_element,FR_Util_Const::ID_APPLICATION); 
      		
      		/* Contador para el usuario */
      		$idUserUsePlay = self::addCountPlay($elem_type,$id_element,$userID);
      		
      		/* Historial de reproduccion */
      		self::setReproductionHistory($idUserUsePlay,$userID);
      }
      
      
      /*
       * Funcion para definir las puntuaciones genericas de la aplicacion 
       * Los gustos musicales
       * 1 o 2 -> Puntuacion -1
       * 3 -> Puntuacion 0
       * 4 o 5 -> Puntuacion +1        * 
       * */
         
   	  public static function setPunctuationApplication($MusicElementType,$idElement,$points) {
   	  	
	   	  try{  
	   	    
		   	    $c = new Criteria();	   	    
		   	    $c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,$MusicElementType);//, 
				$c -> addAnd(UserUsePlayPeer::USERID,FR_Util_Const::ID_APPLICATION); 
				$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$idElement); 
			    $rs = UserUsePlayPeer::doSelect($c);		       
        
	    		if ($rs[0] != null ) { /* Si existe actualizamos*/
	    	
	    			$userPlay = $rs[0];
	    			$actualPoints=$userPlay->getElempunctuation();	    			
	    			echo "Elemento Aplicacion que existia";
	    		}
	 		   else { /* Creas uno de nuevo, y realizamos la votacion inicial!! del contador global de la aplicacion */
	    	
		    	/*Votacion usuario*/		    	
		    	$userPlay =  new UserUsePlay();
		    	$userPlay->setUserid(FR_Util_Const::ID_APPLICATION);
		    	$userPlay->setIdmusicelementtype($MusicElementType);
		    	$userPlay->setIdmusicelement($idElement);		    	
		    	$actualPoints = 0;		    	
	    	}  
     		
     		/* Calculo de puntuacion */
     		$punctuation = 0; /* Puntuacion que se va augmentar al contador generico de la apliacion */     		
     		if($points == 1 || $points == 2) $actualPoints = $actualPoints - 1;
     		elseif($points == 4 || $points == 5) $actualPoints = $actualPoints + 1;     		
     		
     		$userPlay->setElempunctuation($actualPoints); 
     		$userPlay->save();
     		 		    
	   	  }
	   	  catch (PropelException $ex) {
	   	  	echo "<br>ERROR:".$ex->getCause()->getMessage();
			return false;	
	   	  }	  	
   	  	
   	  }
      
      /*Augmentar el contador de usuario pasado como parametro  */
      private static function addCountPlay($elem_type,$id_element,$userID) {
      	
      try{
      		$c = new Criteria();      
			$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,$elem_type);
			$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$id_element);
			$c -> addAnd(UserUsePlayPeer::USERID,$userID); /*Usuario ficticio de la aplicacion 1 */
	
			$rs = UserUsePlayPeer::doSelect($c);
			
			$result = count($rs);
			
			if( 1 == $result ) {  /* Solo puede haber un elemento no puede estar duplicada la entrada en la bd. */ 
						
				$play_use = $rs[0];
				$play_use ->setCountplay($play_use -> getCountplay() + 1);	
			    $play_use->setLastplaydate(date("y-m-d"));			 
										
			}
			elseif (0 == $result) { /*NO HAY ELEMENTO HAY QUE CREARLO */			
			
			
				$play_use = new UserUsePlay();
				$play_use->setIdmusicelementtype($elem_type);
				$play_use->setIdmusicelement($id_element);
				$play_use->setUserID($userID);
				$play_use->setFirstplaydate(date("y-m-d"));	
				$play_use->setLastplaydate(date("y-m-d"));	
				$play_use->setCountplay(1);				
			}
			else {
								
				return false; /*ELEMENTO REPETIDO!!!!!!!!!!!*/
				
			}
			
			$play_use->save(); /* Siempre hay que salvar tanto si es nuevo o existia el objeto*/
			$idPlayUse = $play_use->getIduseruseplay();
			unset($play_use);
			return $idPlayUse;
			
      }
      catch (PropelException $ex) {
		return false;	
      }
      	
      	
   }
   
   /*Alamacena en la base de datos cada vez que es reproducida una cancion. */
      
   private static function setReproductionHistory($idUserUsePlay,$userID) {
      	
    	try{
    		
    		$repro_hist = new ReprodHist();
    		$repro_hist->setIduseruseplay($userID);
    		$repro_hist->setPlaydate(date("y-m-d"));
    		$repro_hist->setPlaytime(time());   
    		//FR_Util_Logs::streamLogs("PLAYTIME:" + $repro_hist->setPlaytime(time()));	
    		$repro_hist->save();
    		//strtotime(); 		
    	}
   	catch (PropelException $ex) {
		return false;	
     }
    	
   }

      
      
      
      public function __destruct()
      {
          parent::__destruct();
      }
      
 
 	
 	
}
 
 
 
?>
