<?php

require_once(FR_BASE_PATH.'/includes/Id3/getid3/getid3.php');

/**
* Se encarga de analizar el contendio de un fichero.
*
*/

class FR_Util_ScanFile
{

private $info;

	public function __construct()
	{		
		$this->info = array();
	}

/**
 * Escanea la estructura de qualquier archivo.
 * @param string $file Ruta completa del archivo a analizar.
 * @return $mixed Si no hay error, array infomracion completa del archivo.  
 * 
 * */
 
public function scanfile($file)
{	
	$getID3 = new getID3;
	$getID3->encoding = 'UTF-8';
	$this->info = $getID3->analyze($file);	
		
	getid3_lib::CopyTagsToComments($this->info);
	
	if($this->isError()) return false;
	else return $this->info;
}

public function getInfofile()
{
	return $this->info;
}
/**
 * Informa del tipo de tags que dispone el archivo en caso de tener-los.
 * */
public function getMetaInfoTags()
{
   $metaInfo = array();
   
   foreach($this->info['tags'] as $key => $value) {
   
   		$metaInfo[$key] = $key;   
   }   
	return $metaInfo;	
}

/**
 *Informa el tipus d'arxiu multimedia que estem tractan: 
 *Exemple: MP3, ogg, ...
 *@author J.Emilio Navarro 
 *@return String Informa del tipo de fichero: Audio o Video
 * 
 * */

public function getFormatoMultimedia()
{

$formato="";

	if(isset($this->info)) 
	{
		if(array_key_exists('audio',$this->info)) $formato = $this->info['audio']['dataformat'];
		elseif (array_key_exists('video',$this->info)) 	$formato = $this->info['video']['dataformat'];
		else $formato = false; /* no tenim format */
	}		
	return $formato;

}

public function getFileName()
{
	if(isset($this->info)) return $this->info['filename'];
	else return false;
}


/**
*Si hi ha algun error torna true
*
*/
public function isError()
{
	if(array_key_exists('error',$this->info)) {
		if(array_count_values($this->info['error']) > 0)  return true; else return false;	
			
	}
	else return false;
}
/**
 * Ens retorina una llista d'errors en cas d'averse produit al llegir el vector.'
 * @return array Lista d'errores en caso de producirse al leer el fichero   
 */

public function getInfoError()
{
	if(isset($this->info)) {
		return $this->info['error'][0];
	}
	return false;
}

/**
 *Ens diu si existeix un frame al tag id3v2
 *  @param string $frame. Frame que es vol buscar al id3v2. Ex: APIC(image a la foto), MCDI (disc ID)
 * */

public function isFrame($frame)
{
	if(isset($this->info['id3v2'][$frame])) {
		return $this->info['id3v2'][$frame][0]['data'];
	}
	return false;
	
}


public function visualitzar() {

if(isset($this->info)) {

	foreach($this->info as $key => $value ) {

		echo "<br/>".$key." --> ".$value;
	
		if ('array' == gettype($value)) {
			foreach($value as $key2 => $value2 ){	
				echo "<br/> ----------> ".$key2." --> ".$value2;						
					if ('array' == gettype($value2)) {
						foreach($value2 as $key3 => $value3 ){	
						echo "<br/> ------------------------------------> ".$key3." :: ".$value3;		
							if ('array' == gettype($value3)) {
								foreach($value3 as $key4 => $value4 ){	
								echo "<br/> --------------------------------------------------> ".$key4." :: ".$value4;		
								}
							}
						}
					}			
				}
			}		
		}
	}
}
}





?>