<?php
/*
 *                        miscelanea.php
 *                    ------------------
 * Creado            : 13-may-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 
 class FR_Util_Miscelanea {
 
 
 /**
  * Devuelve la hora actual  * 
  * */
 public static 	function getmicrotime() {
		list($usec, $sec) = explode(' ', microtime());
		return ((float) $usec + (float) $sec);
	} 	
 
 /**
  * Validar que el formato de las canciones sea el definifo para la aplicacion.
  * @param array $array_songs Array con las canciones a validar
  * @return array $array_songs Canciones con el formato correcto
  */
 public static function checkSongs($array_songs)
 {
 	
 	return $array_songs;
 }
 
 /**
  * Funcin utilizada para quitar los dos puntos de la duracion
  * de las canciones antes de entrar en la base de datos
  * */
 public static function strTimetoInteger($str) {
 	
 	$str = str_replace(":","",$str);
	settype($str,"int");
	return $str;
 }
 
 /**
  * Para solucionar problemas con el path Windows.
  * 
  * */
 public static function SafeStripSlashes($text) {

	if (get_magic_quotes_gpc()) {
			return stripslashes($text);
	}
	return $text;
}
/**
 * Invierte las barras de windows al sistema de fichero de Unix.
 * Si no se utilizan estas barras el servidor apache no reconoce los directorios.
 * 
 * */

public static function convertToUnixSlash($path)
{
	$path = self::SafeStripSlashes($path);	
	$path = realpath($path);	
	$path = str_replace('\\', '/', $path.'/');
	//echo "<br/> PATH FINAL".$path;
	return $path;
}


public static function viewServerVariables()
{
	 echo "<br/> PHP SELF ".$_SERVER['PHP_SELF']; 
	 echo "<br/> HTTP_HOST".$_SERVER['HTTP_HOST'];	
	 echo "<br/> DOCUMENT_ROOT".$_SERVER['DOCUMENT_ROOT']; 
	 echo "<br/> HTTP_CONNECTION".$_SERVER['HTTP_CONNECTION'];
	 echo "<br/> HTTP_RANGE ".$_SERVER['HTTP_RANGE'];
	 echo "<br/> WEB_PATH:".WEB_PATH;

}

/**
 *  truncate_with_ellipse
 * truncates a text file to specified length by adding
 *	thre dots (ellipse) to the end
 *	(Thx Nedko Arnaudov)
 * @todo Fix Spelling!
 * @depreciated
 */
public static function truncate_with_ellipse($text, $max=27) {

	/* Run the function with the correct spelling */
	return self::truncate_with_ellipsis($text,$max);

} // truncate_with_ellipse

/**
 * truncate_with_ellipsis
 * Correct Spelling function that truncates text to a specific lenght
 * and appends three dots, or an ellipsis to the end
 * @package Web Interface
 * @catagory General
 * @author Nedko Arnaudov
 */
private static function truncate_with_ellipsis($text, $max=27) {

	/* If we want it to be shorter than three, just throw it back */
	if ($max > 3) {

		/* Make sure the functions exist before doing the iconv mojo */
		if (function_exists('iconv') && function_exists('iconv_substr') && function_exists('iconv_strlen')) {
			if (iconv_strlen($text, SITE_CHARSET) > $max) {
				$text = iconv_substr($text, 0, $max-3, SITE_CHARSET);
				$text .= iconv("ISO-8859-1", SITE_CHARSET, "...");
			}
		}

		/* Do normal substr if we don't have iconv */
		else {
			if (strlen($text) > $max) {
				$text = substr($text,0,$max-3)."...";
			}
		} // else no iconv
	} // else greater than 3

	return $text;

} // truncate_with_ellipsis

/**
 * scrub_out
 * This function is used to escape user data that is getting redisplayed
 * onto the page, it htmlentities the mojo
 */
public static function scrub_out($str) {

	if (get_magic_quotes_gpc()) { 
		$str = stripslashes($str);
	}

        $str = htmlentities($str);

        return $str;

} // scrub_out

/**
 * 
 * Funcion encargada de validar el formato de fecha ESPAOLA, CATALAN.LATIN LANGUAGES
 * DD/MM/YYYY
 *  
 * */
public static function checkLatinDate($date_) {

	$date = split('/',$date_);			
	
	if(checkdate($date['1'],$date['0'],$date['2'])) return true;
	else return false;		
}


/**
 * 
 * Funcion encargada de validar el formato de fecha INGLESA
 * MM/DD/YYYY
 * 
 * */
public static function checkEnglishDate($date_) {

	$date = split('/',$date_);			
				
	if(checkdate($date['0'],$date['1'],$date['2'])) return true;
	else return false;	
	
}

/**
 * Transforma un formato Latino a formato Ingles que es como se almacena en la
 * base de datos.
 * 
 * */
public static function transformLatinDateToDataBaseFormat($date_) {
	
	$date = split('/',$date_);
	return $date['1']."/".$date['0']."/".$date['2'];
	
}

/*Da el formato correcto para recoger las fechas de la base de datos segun el idioma que hay seleccionado*/
public static function getFormaDate($idioma) {
	
	if($idioma == 1 || $idioma == 2) return "d/m/Y";/* 1, Catalan, 2 Spanish*/
	else return "m/d/Y";/*3 English*/	
}

public static function getFormaDatePlayList($idioma) {
	
	if($idioma == 1 || $idioma == 2) return "d-m-Y";/* 1, Catalan, 2 Spanish*/
	else return "m-d-Y";/*3 English*/	
}


/*
 * Valida si el archivo que se va a subir es un tipo de archivo 
 * valido para ser almacenado en el servidor. 
 * 
 * Tipo de archivos validos:
 * 							- imagen:gif,png,jpg
 * 							-  
 *  
 * */
public static function isValidFormatFile($type,$format) {
	
	if($type == 'image'){
		if('gif' == $format) return true;
		if('jpeg' == $format) return true;
		if('png' == $format) return true;	
	}
}

public static function getGoogleIdiom($idioma){
$strIdioma="";
switch ($idioma) {
	case 1:							/*CATALAN*/
			$strIdioma="lang_es";		
		break;
	case 2:							/*CASTELLA*/
			$strIdioma="lang_es";	
		break;		
	case 3:							/*INGLES*/
			$strIdioma="lang_en";
		break;
	default:
		break;	
}
return $strIdioma;
	
}




 }

?>