<?php
/*
 *                        AdminAgenda.php
 *                    ------------------
 * Creado            : 16-jul-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 require_once('ConstAgenda.php');
 
class AdminAgenda extends FR_Auth_No {
	
	  const ELEMENT_CLASS = 'Agenda'; 
	  const ELEMENT = 'agenda';
  
      public function __construct()
      {
          parent::__construct();          
      }
      
      public function __default()
      {
      	
      	$this->screenNew();
      	$this->getPagination();      	
      	$this->tplFile = 'admin_agenda.tpl'; 
      }
      
      /*
       * Devuleve todos los eventos programados por el usuario
       * */
      public function getPagination() {
      	     
     	try{	

     		//$result = FR_GetModelObjects::getUserEvents($this->session->userID);
     	   $pagination = new FR_Pagination_AgendaEvents(self::ELEMENT_CLASS,self::ELEMENT,$this->me->getName(),$this->session->userID);
     	   $pagination->createPagination(self::ELEMENT_CLASS);
	   	   	
		   	if($pagination->getObjects()) {
		   	
			   	$this->set('events',$pagination->getObjects());
				$this->set('offsets',$pagination->getOffsets());
				$this->set('prev',$pagination->getPrev());
				$this->set('next',$pagination->getNext());
				
				/* Literales para visualizar la paginacion */			
				$this->set('lit_action',$this->getLiteral(FR_Util_Literals::LIT_ACTION));	 	 
	    		$this->set('lit_prev',$this->getLiteral(FR_Util_Literals::LIT_PREV));
	    		$this->set('lit_next',$this->getLiteral(FR_Util_Literals::LIT_NEXT));  
				
		   	}else $this->set('lit_not_events',"no hay eventos definidos LIT");
     			
     		$this->set("lit_eliminar",$this->getLiteral(FR_Util_Literals::LIT_ELIMINAR));  
     		$this->set("alter_22",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));   	
     		$this->set("lit_date",$this->getLiteral(FR_Util_Literals::LIT_DATE));
     		$this->set("today",date(FR_Util_Miscelanea::getFormaDate($this->session->idioma))) ;   
     		$this->set('formatDate',FR_Util_Miscelanea::getFormaDate($this->session->idioma));
     		$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
     		$this->set("lit_select_observ",$this->getLiteral(FR_Util_Literals::LIT_SELECT_OBSERV));
     		$this->set("lit_my_agenda",$this->getLiteral(FR_Util_Literals::LIT_MY_AGENDA));
     		$this->set("lit_description",$this->getLiteral(ConstAgenda::LIT_DESCRIPTION));
     		$this->set("lit_events",$this->getLiteral(ConstAgenda::LIT_EVENTS));
     		
     	/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
     		
     		/* Inicial del principio */
     		$this->screenNew();
     		$this->tplFile = 'admin_agenda.tpl'; 
     		 
     	}
     	catch(PropelException $ex){
     	
     		echo "Excepcion:".$ex->getMessage();
	    	$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());   
      		return false;
      }
      	
      }
      
     
      
      public function screenNew() {
      	
      	
      	$result = FR_GetModelObjects::getUserObservations($this->session->userID);
      	
      	if($result){
      		$this->set('observations',$result);
      		unset($result);
      	} 
      	else $this->set('not_observ',"No hay observaciones lit");      	
      	
        $this->set('lit_title',"title_lit");
      	$this->set("lit_observations",$this->getLiteral(FR_Util_Literals::LIT_OBSERVATIONS));
      	$this->set("lit_new",$this->getLiteral(FR_Util_Literals::LIT_NEW));     	
      }
      
      public function newEvent() {
      	
      	try{
      		
      		$agenda = new Agenda();      		
      		$date = FR_Util_Miscelanea::transformLatinDateToDataBaseFormat($_POST['date']);
      		$agenda->setUserid($this->session->userID);
      		$agenda->setNoticedate($date);
      		$agenda->setTitle($_POST['agenda_title']);
      		$agenda->setIdobservation($_POST['idObservation']);
      		$agenda->save();    
      		$this->__default();     				
      	}
     	catch(PropelException $ex) {
      	
      		$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());      		
      		return false;
        }
      }     
      public function screenAlterEvent() {
      
      	try{	
      	   	
      	   	$agenda = AgendaPeer::retrieveByPK($_GET['idAgenda']);      	   	
      	   	if($agenda instanceof Agenda) {
      	   		
      	   		$result = FR_GetModelObjects::getUserObservations($this->session->userID);      	
      			if($result){
      				$this->set('observations',$result);
      				unset($result);
      			} 
      			else $this->set('not_observ',"No hay observaciones lit");      	   		
      	   		
      	   		/* Siempre 1 porque el calendario de pantalla es latino */
      	   		$this->set('event_date',$agenda->getNoticedate(FR_Util_Miscelanea::getFormaDate(1)));
      	   		$this->set('event_title',$agenda->getTitle());
      	   		$this->set('event_observation',$agenda->getIdobservation());
      	   		$this->set('event_idAgenda',$agenda->getIdagenda());      	   		
      	   	}
      	   	else set('$not_event','Evento de la agenda no encontrado_LIT');
      	   	
      	   	$this->set("lit_new",$this->getLiteral(FR_Util_Literals::LIT_NEW));
      	   	$this->set("action_modificar",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR)); 
      	   	$this->getPagination();
      	   	$this->tplFile = 'admin_agenda.tpl';
      	}
      	catch(PropelException $ex) {
      	
      		$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());      		
      		return false;
        }
      	 
      }
      
      public function alterEvent() {
      	
	      try{
	      	
	        $agenda = AgendaPeer::retrieveByPK($_POST['idAgenda']);     	   	
      	   	if($agenda instanceof Agenda) {     	
	      	
	      		$date = FR_Util_Miscelanea::transformLatinDateToDataBaseFormat($_POST['date']);
	      		$agenda->setUserid($this->session->userID);	      		
	      		$agenda->setNoticedate($date);
	      		$agenda->setTitle($_POST['agenda_title']);
	      		$agenda->setIdobservation($_POST['idObservation']);	      		
	      		$agenda->save();      	   	
      	   	}
      	   	
      	   	$this->__default();
      	   	
	      }
	      catch(PropelException $ex) {
	      	
	      	echo "<br>MESSAGE ERROR:".$ex->getMessage();
	      		//$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());      		
	      		return false;
	      }    	
      }
      
      public function deleteAgenda() {
      	
      	try{
      		
      		$agenda = AgendaPeer::retrieveByPK($_GET['idFvSong']);
      		
      		if($agenda instanceof Agenda){
      			$agenda->delete();
      		}
      			$this->__default();
      		
      		
      	}
      	catch(PropelException $ex){
      		
      		$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());      		
      		return false;
      		
      	}
      }  

	 /* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
      
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>