<?php

/*
 *                      SaveSongs.php
 *                    ------------------
 * Creat            : 12-may-2006
 * Modificat        :
 * Versi           : 1.2
 * Autor            : J.Emilio Navarro
 *
 * Descripci       :   
 */
 
class SaveSongs extends FR_Object_DB  {
  
private $num_albums;
private $num_artist;
private $num_generes;

private $num_songs;
private $num_rep_songs;

private $time;

private $error_result; /* Guarda la url de los ficheros con error. */
  
function __construct() {
	  
	    
	 	$this->num_albums = 0;
		$this->num_artist = 0;
		$this->num_generes = 0;
		
		$this->num_songs = 0;
		$this->num_rep_songs = 0;
		
		$this->size = 0;
		$this->time = 0;
  
	  	$this->error_result = array();
	  
  }
  
  /**
   * Iniciar el proceso de guardar en la BD las canciones que tiene toda la informacion
   * El array contiene canciones temporales
   * 
   * @param array $array_songs Contiene tmp_songs
   * */
public function completeSongs($array_Songs) {
  	
	
  	foreach($array_Songs as $tmp_song ) {
  	    
  	    //Si hi ha algun problema al guardar la song ho emmagatzemem a resultat. 
  		if(!$this->saveCompleteSong($tmp_song)) { 
  			$this->error_result[] = $tmp_song->getUrlArxiu();
  		}
  	}  

  	return $this->parseVariablesToArray();
  	
}

  /**
   * Iniciar el proceso de guardar en la BD las canciones que NO tiene toda la informacion
   * El array contiene canciones temporales
   * 
   * @param array $array_songs Contiene tmp_songs
   * */
public function inCompleteSongs($array_Songs) {
  	 	
  	foreach($array_Songs as $tmp_song ) {  	    
  	    //Si hi ha algun problema al guardar la song ho emmagatzemem a resultat. 
  		if(!$this->saveInCompleteSong($tmp_song)) $this->error_result[] = $tmp_song->getUrlArxiu();
  		
  	}     	 	
  	return $this->parseVariablesToArray();
}



/**
 * Retorna el nombre de fitxers amb error
 * @return int Nmero de ficheros con error
 * */
 
public function getNumErrors()
{
	return count($this->error_result);	
}

/**
 * Si hay ficheros con error de almacenamiento de bd, devuelve un array
 * @return $array Devuelve url de archivos con error.
 * @return $boolean. Si hay  noo hay ningun fichero erroneo
 * */
public function getErrorResult()
{
	if(isset($this->error_result[0])) return $this->error_result;
	else return false; 	
		
}

/**
 * Emmagatzema les variables contadores en un array.
 * 
 * */

public function parseVariablesToArray() {
	
$result = array();
	
	 $result['num_albums'] = $this->num_albums;	
	 $result['num_artist'] = $this->num_artist;
	 $result['num_generes'] = $this->num_generes;
		
	 $result['num_songs'] = $this->num_songs;
	 $result['num_rep_songs'] = $this->num_rep_songs;
		
	 $result['size'] = $this->size;
	 $result['time'] = $this->time;
	 
	

return $result;	
	
}
  
public function saveCompleteSong(&$tmp_song) {

try {
	
$song = new song();
	
	$this->getArtist($song,$tmp_song->getArtista());
	
	$this->getAlbum($song,$tmp_song->getAlbum(),$tmp_song->getAnyAlbum());
	

	$this->getGenere($song,$tmp_song->getGenere());

	$song->setSongname($tmp_song->getNomCanco());	
	$song->setTrack($tmp_song->getTrack());
		
	//Camps standard que segur que tenim
	$this->putStandardField($song,$tmp_song);	
	 
	
	/* DEFINE THE COMPLETE SONG */
		
	$song->setComplete(true);
	
	 	
	if(!$this->existSongInDB($song)) { 
		$song->save();
		$this->num_songs++;
		$this->size += $song->getFilesize();
		$this->time += $song->getTime();
	}
	else {	
		$this->num_rep_songs++;;		
	}
	
return true;

}
catch (Exception $ex)
{
	return false;	
}

}


public function saveInCompleteSong(&$tmp_song){
	
try {
	
$song = new Song();
    
    $this->getInArtista($song,$tmp_song->getArtista());	
    //echo "<br/>1111111111";
	$this->getInAlbum($song,$tmp_song->getAlbum(),$tmp_song->getAnyAlbum());	
	//echo "<br/>222222222";
	$this->getInGenere($song,$tmp_song->getGenere());
	//echo "<br/>3333333333333333333";	
	
	
	if($tmp_song->getNomCanco()) $song->setSongname($tmp_song->getNomCanco());
	else $song->setSongname($tmp_song->getNomArxiu()); /* Nombre del fichero por defecto */

	//echo "<br/>4444444444";			
		
	if($tmp_song->getTrack()) $song->setTrack($tmp_song->getTrack());
	else  $song->setTrack(0);
	
	//echo "<br/>555555555";		
	
	/* Define the INCOMPLETE SONG */
	
	$song->setComplete(false); 
	
	//Camps standard que segur que tenim
	$this->putStandardField($song,$tmp_song);
	
	 //echo "<br/>666666666666";	
	if(!$this->existSongInDB($song)) { 
		//echo "<br/>77777";	
		$song->save();
		$this->num_songs++;
		$this->size += $song->getFilesize();
		$this->time += $song->getTime();
	}
	else {	
		//echo "<br/>88888";	
		$this->num_rep_songs++;		
	}
	
return true;
}	

catch (Exception $ex) {	

$ex->getMessage();
	return false;	
}

}


/**
 *Recoje la informacion que todo fichero multimedia sempre tiene.
 *@param song $song Cancion que se esta creando para ser guardada en la BD
 **/
private function putStandardField(&$song,&$tmp_song){

	/* Aquesta informaci ser sempre certa si no s'ha produit cap error en la lectura del fitxer*/
	
		
	$song->setUrlfile($tmp_song->getUrlArxiu());
	$song->setTime(intval(($tmp_song->getDuracio())));				
	$song->setFilename($tmp_song->getNomArxiu());	
	$song->setFilesize($tmp_song->getTamanyArxiu());	
	$song->setBitrate(intval($tmp_song->getBitrate()));	
	$song->setFormat($tmp_song->getFormat());	
	$song->setMime($tmp_song->getMime());
	
	$song->setRate($tmp_song->getRate());
	$song->setMode($tmp_song->getMode());
	
	$song->setImage($tmp_song->isImage());	
	$song->setEnterdate(date("y-m-d")); //year/mes/dia. Si no se pone asi hay probemas en BDD
	
	/*
	 * Definir tipo de elemento cancion 
	 * */
	 
	$song->setIdmusicelementtype(FR_Util_Const::CONST_SONG);
}
 
 /**
  * Busca una cancin en la BD, para saver si ja ha sido inserida
  * @param song $song Cancin a buscar en la BD
  * */
public function existSongInDB(&$song) {

$existeix = false;	

try { 
	
	$c = new Criteria();  
    
    //echo "<br/> song IN DB";    
    //$song -> visualitzar();
    //echo "<br/>-------------------------------------------------------<br/><br/>";    
    
	$c -> add(SongPeer::IDALBUM,$song -> getIdalbum());
	$c -> addAnd(SongPeer::SONGNAME,$song -> getSongname());
	
	$rs = SongPeer::doSelect($c);
		
	if( count($rs) > 0 ) { 
				
				//echo "<br/> ----->song existent a la BDD!!!".$song -> getNomsong();	
				$existeix = true;
	}
return $existeix;	
}
catch (PropelException $ex) {

return false;	
}
}

 
  
  
/**
 * Recoje informacion del ARTISTA para las informacin INCOMPLETA
 * Si no esta defenido cojer el defecto de la BD (ANONIME)
 * @param song &$song song que se esta almacenando en la BD
 * @param string $str_artista Nombre del artista a buscar.  
 * */ 
  
private function getInArtista(&$song,$str_artista) {
	
	if(isset($str_artista)) return $this->getArtist($song,$str_artista);
	else { /* ANONIME ARTISTA */
			try{				
										
				$artista = ArtistPeer::retrieveByPK(1);			
				$song -> setArtist($artista);
			}				
			catch (PropelException $ex) {
				return false;
			}
	} 
}

/**
 * Recoje informacion del ALBUM para las informacin INCOMPLETA
 * Si no esta defenido cojer el defecto de la BD (O R P H A N E D)
 * @param song &$song song que se esta almacenando en la BD
 * @param string $str_album Nombre del album 
 * @param int $int_any_album Ao de publicacin del lbum  
 * */
private function getInAlbum(&$song,$str_album,$int_any_album) {	
	
	if(isset($str_album)) {
		
		if(!isset($int_any_album)) $int_any_album = 1900; /* defecto del album orphaned*/
		
		return $this->getAlbum($song,$str_album,$int_any_album);
	}
	else { /* O R P H A N E D    A L B U M */
	
		try {
			$album = AlbumPeer::retrieveByPK(1,FR_Util_Const::CONST_ALBUM);
			$song -> setAlbum($album);
			return true;
		}				
		catch (PropelException $ex) {
			return false;
		}			
	} 
}

/**
 * Recoje informacion del GENERE para las informacin INCOMPLETA
 * Si no esta defenido cojer el defecto de la BD (UNKNOWN)
 * @param song &$song song que se esta almacenando en la BD
 * @param string $str_genere Nombre del genere a buscar 
 *
 * */ 
  
private function getInGenere(&$song,$str_genere) {
	
	if(isset($str_genere)) return $this->getGenere($song,$str_genere);
	else { /* U N K N O W N   G E N E R E */
		try{
			$genere = GenerePeer::retrieveByPK(1);
			$song -> setGenere($genere);
			return true;
		}		
		catch (PropelException $ex) {
			return false;
		}	
	}
} 
 

/**
 * Recoje informacion del ARTISTA para las informacin COMPLETA
 * Si no esta en la BD crea uno nuevo.
 * @param song &$song song que se esta almacenando en la BD
 * @param string $str_artista Nombre del artista 
 * 
 * */
private function getArtist(&$song,$str_artist) {
 
 try {
 		/* Realizacion de la condicion de busqueda */				
		$c = new Criteria();
		$c ->add(ArtistPeer::ARTISTNAME,$str_artist);
		
		/* rs = un array */
		$rs = ArtistPeer::doSelect($c);		
			
		if(count($rs) > 0 ) { /* Nomes podem tenim un artista amb el mateix nom. */			
			
				//Recuperem l'album obtingut.				
				$song->setArtist($rs[0]);								
		}
		else { /* artista no existeix, creem un de nou */						
			$artist = new Artist();
			$artist->setArtistname($str_artist);
			$song->setArtist($artist);
			$this->num_artist++;
					
		} 
		
return false;		
}
	catch (PropelException $ex)
	{
		echo "<br/> Propel exception: Class: Save Songs Metodo:getArtista " .$ex.getCause();		
		return false;
	}
	return true;
}	

/**
 * Recoje informacion del ALBUM para la informacin COMPLETA
 * Si no esta en la BD crea uno nuevo.
 * @param song &$song song que se esta almacenando en la BD
 * @param string $str_album Nombre del album 
 * @param int $int_any_album Ao de publicacin del lbum  
 * */
private function getAlbum(&$song,$str_album ,$str_year) {

		/* Realizacion de la condicion de busqueda */
try {	
		$c = new Criteria();
			
		$c->add(AlbumPeer::ALBUMNAME,$str_album);		
		
		/* rs = array */
		$rs = AlbumPeer::doSelect($c);
	
		/* Atencio controlar quan es recull mes d'un album'*/
			
		if(count($rs) > 0 ) { /* Nomes tenim un album amb el mateix nom */						
				//Recuperem l'album obtingut.				
				$song->setAlbum($rs[0]);					
		}
		else { /*album no existeix, creem un de nou*/
						
			$album = new Album();
			$album ->setAlbumname($str_album);			
			$album->setAlbumyear($str_year);		
			$song->setAlbum($album);
			
			$this->num_albums++;	
		}
return true;
 }
catch (PropelException $ex)
{

echo "<br/> Propel exception: Class: Save Songs Metodo:getAlbum " .$ex.getCause();
return false;
}

}
/**
 * Recoje informacion del GENERE para la informacin COMPLETA, 
 * Si no esta en la BD crea uno nuevo.
 * @param song &$song song que se esta almacenando en la BD
 * @param string $str_genere Nombre del genero a buscar 
 * @param int $int_any_album Ao de publicacin del lbum  
 * */
private function getGenere(&$song,$str_genere = null) {
	
try {		
	$c = new Criteria();
	$c ->add(GenerePeer::GENERENAME,$str_genere);
		
	/* rs = array */
	$rs = GenerePeer::doSelect($c);		
			
	if( count($rs) > 0 ) { /* Nomes tenim un genere amb el mateix nom */			
		//Recuperem l'album obtingut.				
		$song->setGenere($rs[0]);						
	}
	else { /* Genere no existeix, creem un de nou */
											
		$genere = new Genere();
		$genere->setGenerename($str_genere);			
		$song->setGenere($genere);		
		$this->num_generes++;
	}
return true;
}
catch (PropelException $ex)
{
	echo "<br/> Propel exception: Class: Save Songs Metodo:getGenere " .$ex.getCause();
	return false;
}
return true;
}

}//Final de la clasee

?>
