<?php
/*
 *                        albumDetails.php
 *                    ------------------
 * Creado            : 09-jul-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */

include_once('modules/browse/ElemMusicMatchUserInfo.php');
require_once('propel/util/Criteria.php');
require_once('modules/emotions/AdminEmotion.php');
require_once('modules/playlist/AdminPlayList.php');

class albumDetails extends FR_Auth_No {

const ELEMENT_CLASS = 'Song';
const ELEMENT = 'song';	

	   public function __construct()
      {
          parent::__construct();
      }
      
      public function __default() {
      	
      	
      }
      
      public function getSongs() {
      	
      	$album = FR_GetModelObjects::getObjectAlbum($_GET['idAlbum']);
		if($album instanceof Album) 
		{
		   $c = new Criteria();
		   $c->addAscendingOrderByColumn(SongPeer::TRACK);
		   $songs = $album->getSongs($c);
		   		
		  $matchElemMusic = new ElemMusicMatchUserInfo(self::ELEMENT,FR_Util_Const::CONST_SONG,$this->session->idioma);     	
      	  $screenSongs = $matchElemMusic->getUserInformation($songs,$this->session->userID); 		   		
		  $this->set("screen_songs",$screenSongs);   		
		   		
		   	/* USER EMOTIONS */	
			$adminEmotion = new AdminEmotion();
			$rs = $adminEmotion -> getUserEmotions();
			$this->set('userEmotions',$rs);		
			$this->set('album',$album);			   		
			
			/* User PlayList */
				$userPlayList = AdminPlayList::getAllUserPlayList($this->session->userID);				
				if($userPlayList != null) $this->set('user_PlayLists',$userPlayList);				
				//echo "PlayList:".print_r	($userPlayList);
						
		   	$this->screenLiterals();	   		
		}
		else $this->set('message',"No hay canciones en este lbum.");
		
		/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/
    	//$this->set('3_User_Info_colum','si');
		
		$this->tplFile="albumDetails.tpl";			
      }
      
      public function screenLiterals() {
      	
      	/* LITERALES DE LA PANTALLA */
		$this->set("lit_songs",$this->getLiteral(FR_Util_Literals::LIT_SONG));
		$this->set("lit_plays",$this->getLiteral(FR_Util_Literals::LIT_PLAYS));
		$this->set("lit_total",$this->getLiteral(FR_Util_Literals::LIT_TOTAL));				
		$this->set("lit_user",$this->user->name);		
		$this->set("lit_punctuation",$this->getLiteral(FR_Util_Literals::LIT_PUNCTUATION));
	    $this->set("lit_emotions",$this->getLiteral(FR_Util_Literals::LIT_EMOTIONS));
		$this->set("lit_observations",$this->getLiteral(FR_Util_Literals::LIT_OBSERVATIONS));
		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));
		$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));		
		$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
		$this->set("lit_choose_playlist",$this->getLiteral(FR_Util_Literals::LIT_CHOOSE_PLAYLIST));		
		$this->set("js_file","mod_browse.js");      	
      }
      
      /*funcion para incluir canciones en playlist */
      public function includePlayList(){
      	
      	if(AdminPlayList::addSongsToPlayList($this->session->userID)) $this->set("info_message","Se han aadido correctamente las canciones al PlayList.");
      	else $this->set("info_message","NO!! se han aadido correctamene las canciones al PlayList.");
      	
      	$this->getSongs();      
      }
      
      /*Actualiza en base de datos la puntuacion sobre un album*/
public function setPunctuation(){

   try{	
     	$c = new Criteria();	    		
		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$_POST['idMusicElement']); /* Usuario ficticio de la aplicacion 1 */
	    $rs = UserUsePlayPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe actualizamos*/
	    	
	    	$userPlay = $rs[0];	    
	    	
	    }
	    else { /* Creas uno de nuevo */
	    	
	       	$userPlay =  new UserUsePlay();
	    	$userPlay->setUserid($this->session->userID);
	    	$userPlay->setIdmusicelementtype(FR_Util_Const::CONST_SONG);
	    	$userPlay->setIdmusicelement($_POST['idMusicElement']);
	    }  
     	
     	if($userPlay->getElempunctuation() == 0)	/* Votacion usuario para el contador generico de la aplicacion */
     		FR_UserActions::setPunctuationApplication(FR_Util_Const::CONST_SONG,$_POST['idMusicElement'],$_POST['punctuation']);
     	
     	$userPlay->setElempunctuation($_POST['punctuation']); 
     	$userPlay->save();
     	$this->set("info_message","Puntuacin realizada con xito");     	
     	unset($userPlay);
 		$this->getSongs();     	
     }
     catch(PropelException $ex){
     	
     	//echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($userPlay);
      	return false;
     }
}



public function setEmotion() {
	
	 try{	
     	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$_POST['idMusicElement']); /* Usuario ficticio de la aplicacion 1 */
	    $rs = UserUsePlayPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe, hay que actualizar */
	    	
	    	$userPlay = $rs[0];	    
	    	
	    }
	    else { /* Creas uno de nuevo */
	    	
	       	$userPlay =  new UserUsePlay();
	    	$userPlay->setUserid($this->session->userID);
	    	$userPlay->setIdmusicelementtype(FR_Util_Const::CONST_SONG);
	    	$userPlay->setIdmusicelement($_POST['idMusicElement']);
	    }  
     	
     	$emotion = EmotionsPeer::retrieveByPK($_POST['idEmotion']);     	
     	$userPlay->setEmotions($emotion); 
     	$userPlay->save(); 
     	$this->set("info_message","Emocin associada con xito");    	
     	unset($userPlay);
 		$this->getSongs();     	
     }
     catch(PropelException $ex){
     	
     	//echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($userPlay);
      	return false;
     }
	
}

	/* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }

      
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>