<?php
/*
 *                        genere.php
 *                    ------------------
 * Creado            : 15-may-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 
require_once('propel/util/Criteria.php');
include_once('ElemMusicMatchUserInfo.php');
require_once('modules/emotions/AdminEmotion.php');


class browseGenere extends FR_Auth_No {
 	
const ELEMENT_CLASS = 'Genere'; 
const ELEMENT = 'genere';
 
 private $pagination; /* Objeto de tipo FR_Pagination_MusicElement que realiza la paginacion. */
 
 	public function __construct() {
 		
 		parent::__construct();
 		$this->pagination = new FR_Pagination_MusicElement(self::ELEMENT_CLASS,'browse',$this->me->getName(),$_GET['criteria']);	
	}
	
	public function __default() {
		
		$this->getPagination();				
	}	
	
public function getPagination() {
	
	/*Recojemos la URL desde donde se ha realizado la llamada.*/	
	$this->session->urlBack = $this->getUrlFrom();
	$this->session->typeElement = self::ELEMENT_CLASS;	
	
		/*Si no se produce ninugn error o la pagina esta vacia*/	
if($this->pagination->createPagination(self::ELEMENT,$_GET['criteria'])) 
{	
	$matchElemMusic = new ElemMusicMatchUserInfo(self::ELEMENT,FR_Util_Const::CONST_GENERE,$this->session->idioma);
	$screenGeneres = $matchElemMusic->getUserInformation($this->pagination->getObjects(),$this->session->userID);
	
	/* Enviar los resultado de la paginacion a la pantalla */
	
   /* USER EMOTIONS */
	
	$adminEmotion = new AdminEmotion();
	$rs = $adminEmotion -> getUserEmotions();
	$this->set('userEmotions',$rs);
	
	$this->set('screenGeneres',$screenGeneres); /* Informacion del usuario para mostrar.*/
	
	$this->set('offsets',$this->pagination->getOffsets());
	$this->set('prev',$this->pagination->getPrev());
	$this->set('next',$this->pagination->getNext());
	$this->set('playAll',$this->pagination->getPlayAll());
	$this->set('playRandom',$this->pagination->getPlayRandom());
	
	/*Necesitamos el offset para las emocionesn y puntuacion. A partir de la primera llamada.*/
	if(null != $_GET['offset']) $this->set('actual_offset',$_GET['offset']);
	
	
	 		
	$this->insertScreenLiteral();	
}
else {

$this->set("message",$this->getLiteral(FR_Util_Literals::LIT_NOT_GENERES));

}
/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	//$this->set('3_User_Info_colum','si');
}

/*Devuelve la URL de origen atraves de la cual se ha realizado la llamada*/
private function getUrlFrom() {
	
	$urlVuelta = "index.php?module=browse&class=browseGenere&offset=".$_GET['offset'];
	if (isset($_GET['criteria'])) $urlVuelta .="&criteria=".$_GET['criteria'];
	 	 
	return $urlVuelta;
	
	
}	

/* Actualiza en base de datos la puntuacion sobre un album */

public function setPunctuation(){

   try{	
     	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_GENERE);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$_POST['idMusicElement']); /* Usuario ficticio de la aplicacion 1 */
	    $rs = UserUsePlayPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe actualizamos*/
	    	
	    	$userPlay = $rs[0];	    
	    	
	    }
	    else { /* Creas uno de nuevo */
	    	
	       	$userPlay =  new UserUsePlay();
	    	$userPlay->setUserid($this->session->userID);
	    	$userPlay->setIdmusicelementtype(FR_Util_Const::CONST_GENERE);
	    	$userPlay->setIdmusicelement($_POST['idMusicElement']);
	    }  
     	
     	$userPlay->setElempunctuation($_POST['punctuation']); 
     	$userPlay->save();
     	$this->set("info_message","Puntuacin realizada con xito");     	
     	unset($userPlay);
 		$this->getPagination();     	
     }
     catch(PropelException $ex){
     	
     	//echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($userPlay);
      	return false;
     }
}

public function setEmotion() {
	
	 try{	
     	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_GENERE);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$_POST['idMusicElement']); /* Usuario ficticio de la aplicacion 1 */
	    $rs = UserUsePlayPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe, hay que actualizar */
	    	
	    	$userPlay = $rs[0];	    
	    	
	    }
	    else { /* Creas uno de nuevo */
	    	
	       	$userPlay =  new UserUsePlay();
	    	$userPlay->setUserid($this->session->userID);
	    	$userPlay->setIdmusicelementtype(FR_Util_Const::CONST_GENERE);
	    	$userPlay->setIdmusicelement($_POST['idMusicElement']);
	    }       	
     	$emotion = EmotionsPeer::retrieveByPK($_POST['idEmotion']);     	
     	$userPlay->setEmotions($emotion); 
     	$userPlay->save(); 
     	$this->set("info_message","Emocin associada con xito");
     	    	
     	unset($userPlay);
 		$this->getPagination();     	
     }
     catch(PropelException $ex){
     	
     	//echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($userPlay);
      	return false;
     }
	
}



	
private function insertScreenLiteral()
{
		$this->set('lit_genere',$this->getLiteral(FR_Util_Literals::LIT_GENERE));
		$this->set("lit_emotions",$this->getLiteral(FR_Util_Literals::LIT_EMOTIONS));
		$this->set("lit_observations",$this->getLiteral(FR_Util_Literals::LIT_OBSERVATIONS));
		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));
		
		//$this->set('lit_songs',$this->getLiteral(FR_Util_Literals::LIT_SONG));		
		//$this->set('lit_action',$this->getLiteral(FR_Util_Literals::LIT_ACTION));
			    
	    $this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
	    $this->set('lit_all',$this->getLiteral(FR_Util_Literals::LIT_ALL));
	    $this->set('lit_random',$this->getLiteral(FR_Util_Literals::LIT_RANDOM));
	    $this->set('lit_prev',$this->getLiteral(FR_Util_Literals::LIT_PREV));
	    $this->set('lit_next',$this->getLiteral(FR_Util_Literals::LIT_NEXT));
	    
	   /* Costumbres usuario */
		$this->set("lit_plays",$this->getLiteral(FR_Util_Literals::LIT_PLAYS));
		$this->set("lit_total",$this->getLiteral(FR_Util_Literals::LIT_TOTAL));
		$this->set("lit_user",$this->user->name);
		//$this->set("lit_users",$this->getLiteral(FR_Util_Literals::LIT_USERS));
		$this->set("lit_punctuation",$this->getLiteral(FR_Util_Literals::LIT_PUNCTUATION));    	
}
/* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }


public function __destruct()
{
     parent::__destruct();
     unset($this->pagination);
} 	
 	
 }
 
?>