<?php		
	
  /**
  * login
  *
  * @author Joe Stump <joe@joestump.net>
  * @copyright Joe Stump <joe@joestump.net>
  * @license http://www.opensource.org/licenses/gpl-license.php 
  * @package Modules
  * @filesource
  */


  require_once(PEAR_DIR.'Validate.php');
  require_once('propel/util/Criteria.php');
  include_once('UserConst.php');
  require_once('modules/emotions/EmotionConst.php');
  
  /**
  * login
  *
  * @author Joe Stump <joe@joestump.net>
  * @package Modules
  */
  class AdminUsers extends FR_Auth_No
  {
      public function __construct()
      {
          parent::__construct();
      }

      public function __default()
      {
                    
          if(isset($_REQUEST['language']))    	$this->session->idioma = $_REQUEST['language'];
          $this->dataForm();
          $this->set('language', $_REQUEST['language']);
          $this->set("button_action",'newUser');
          $this->set("lit_register",$this->getLiteral(UserConst::LIT_REGISTER));			/*!!!!!!!  AADIR LITERAL a BASE de datos */
          $this->pageTemplateFile = 'init.tpl';  
          $this->tplFile = 'admin_users.tpl';
                   
      }
      
      public function newUser() {
      	
      try{	
      	 
      	 if(isset($_REQUEST['language']))    	$this->session->idioma = $_REQUEST['language'];	
      	 $n_user =  new Users();  
      					       								/* INFO USER */      									
     // echo "IDIOMA".$this->session->idioma;
            							
      	$n_user->setIdusertype(UserConst::USER); /* Por defecto usuario con privilegios normales */     	
      	
      	$n_user->setUserlogin($_POST['login']);
      	$n_user->setPass($_POST['pass']);
      	
      	if(null != $_POST['user_name']) $n_user->setName($_POST['user_name']);
      	if(null != $_POST['first_name'])$n_user->setFirstname($_POST['first_name']);
      	if(null != $_POST['second_name'])$n_user->setLastname($_POST['second_name']);
      	if(null != $_POST['email'])$n_user->setEmail($_POST['email']);
      	
      	//$n_user->setBirthDate($_POST['birth_date']);      	
        
        
        $n_user->setPreflanguages($this->session->idioma);													/* APPLICATION INFO */
      																
      	$n_user->setCreatedate(date("y-m-d"));
      	$n_user->setActive(true);      	   	
        $n_user->save();    
        
        /* Crear el directorio donde se van a guardar las imagenes multimeida que va a subir */
        	$target_path = MULTIMEDIA_UPLOADS.$n_user->getUserid().'/';
        	
        	//echo "<br> PATH ".$target_path;
        	mkdir($target_path);
        
     		/* Definir las emociones basicas que tienen todos los usuarios inicialemte */
     		
			$this->InicializateEmotions($this->getLiteral(EmotionConst::LIT_JOY_EMOTION),$n_user->getUserid());
			$this->InicializateEmotions($this->getLiteral(EmotionConst::LIT_SADNESS_EMOTION),$n_user->getUserid());
	    	$this->InicializateEmotions($this->getLiteral(EmotionConst::LIT_ANGER_EMOTION),$n_user->getUserid());
			$this->InicializateEmotions($this->getLiteral(EmotionConst::LIT_FRIGHT_EMOTION),$n_user->getUserid());
        
          	      	  
      	unset($n_user);   
      	 	
        //$this->dataForm();
        $errors[] = $this->set("lit_register_successful",$this->getLiteral(UserConst::LIT_REGISTER_SUCCESSFUL));
        $this->set('errors',$errors);
        
        $this->set('language',$this->idioma);         
        $this->set("lit_pass",$this->getLiteral(UserConst::LIT_PASS));
		$this->set("lit_logon",$this->getLiteral(UserConst::LIT_LOGIN));
		$this->set("lit_register",$this->getLiteral(UserConst::LIT_REGISTER));
        $this->pageTemplateFile = 'init.tpl';  
        $this->tplFile = 'login.tpl';
        
      }
      catch (PropelException $ex){
      		
      		echo "<br/>Class:".__CLASS__."METODOE:new User ERROR:".$ex->getCause();
      		//$this->tplFile='error.tpl';
      		//$this->set("message",'Impossible dar de alta usuario');  	  	
      		return false;	
      }     	
      	
      }
     
           /*
       * La aplicacio inicialment dispone de unas emociones que el usuario podra utilizar para
       * definir sus gustos musicales.
       * */
      private function InicializateEmotions($emotion_name,$userID) {
      	
      	
      	try {
      		
      		$emotion = new Emotions();
      		$emotion_search = new EmotionSearch();
      		
      		$emotion->setUserid($userID);
      		$emotion->setEmotionname($emotion_name);
      		$emotion->setUrlicon("web/img/Smiley.png");
      		
      		
      		$emotion_search->setMaxsongs(10); /* CANCIONES MAXIMAS POR DEFECTO 10 */
      		$emotion_search->setUserId($userID);
      		$emotion_search->setFindin("1,3"); /*Busqueda en Canciones y albumes.*/
      		
      		
      		$emotion->addEmotionSearch($emotion_search);	
			$emotion->save();	
			
			unset($emotion_search);  
			unset($emotion);
      	      		
      	}
      	catch(Exception $ex) {
      		
      		echo "<br/> newUserSession class LOGIN.php ".$ex->getCause();
      		return false;
      		
      	}
      	
      }
     
     
      public function getUserDatas()
      {
      	
       try{	
      	
      	$n_user = UsersPeer::retrieveByPK($this->session->userID); /* Cojer de la session!!!! */     
      	
      	$this->set("login_data",$n_user->getUserlogin());
      	$this->set("pass_data",$n_user->getPass());
      	$this->set("user_name_data",$n_user->getName());
      	$this->set("f_name_data",$n_user->getFirstname());
      	$this->set("s_name_data",$n_user->getLastname());
      	$this->set("email_data",$n_user->getEmail());
      	$this->set("language",$n_user->getPreflanguages());
      	//$this->set("birth_data",$n_user->getBirthDate());
      	
      	
      	$this->set("button_action",'modificar');
      	$this->set("lit_register",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));
      	$this->dataForm();
      	$this->tplFile = 'admin_users.tpl';
      	
        /* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	$this->getTodayEvents();
      	
      	}
      	catch (PropelException $ex){
      		
      		echo "<br/>Class:".__CLASS__."METODOE:new User ERROR:".$ex->getCause();
      		//$this->tplFile='error.tpl';
      		//$this->set("message",'Impossible dar de alta usuario');  	  	
      		return false;	
      }    
      	   
      } 
      
      public function modificar() {
      	
      	
      	try {	
	      	
	        $n_user = UsersPeer::retrieveByPK($this->user->userID);      	
	      	$n_user->setUserlogin($_POST['login']);
	      	$n_user->setPass($_POST['pass']);
	      
	    	if(null != $_POST['user_name']) $n_user->setName($_POST['user_name']);
      		if(null != $_POST['first_name'])$n_user->setFirstname($_POST['first_name']);
      		if(null != $_POST['second_name'])$n_user->setLastname($_POST['second_name']);
      		if(null != $_POST['email'])$n_user->setEmail($_POST['email']);
      		
      		$n_user->setPreflanguages($_POST['language']);
      		$this->session->idioma = $_POST['language'];	      	
	      	$n_user->save();	      	      	
	      	  											/* Cargar los datos del objeto a pantalla */
	      	  
		    $this->set("login_data",$n_user->getUserlogin());
	      	$this->set("pass_data",$n_user->getPass());
	      	$this->set("user_name_data",$n_user->getName());
	      	$this->set("f_name_data",$n_user->getFirstname());
	      	$this->set("s_name_data",$n_user->getLastname());
	      	$this->set("email_data",$n_user->getEmail());
	      	$this->set("language",$n_user->getPreflanguages());
      	//$this->set("birth_data",$n_user->getBirthDate());
      	
      		
	      	//$this->set("birth_data",$n_user->getBirthDate());   	
	      	
	      													/* Datos construccion de pantalla */
	      	$this->set("button_action",'modificar');
      		$this->set("lit_register",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));
      		
      		$this->set("message",$this->getLiteral(UserConst::LIT_ALTERED_SUCCESSFULLY));     		
      		$this->dataForm();
      		$this->tplFile = 'admin_users.tpl';	      	  
	      	unset($n_user);
	      	
	     /* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	$this->getTodayEvents();
     	}
      	catch (PropelException $ex){      		
      		echo "<br/>Class:".__CLASS__."METODOE:new User ERROR:".$ex->getCause();
      		//$this->tplFile='error.tpl';
      		//$this->set("message",'Problemas internos...');  	  	
      		return false;	
      	} 
      	
      	   
      } 
      
      /* Carga los datos de presentacion del formulario */
      private function dataForm()
  	  {
  	  	
  	  	$this->set("lit_login",$this->getLiteral(UserConst::LIT_LOGIN));
		$this->set("lit_pass",$this->getLiteral(UserConst::LIT_PASS));
		$this->set("lit_user_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));
		$this->set("lit_email",$this->getLiteral(UserConst::LIT_EMAIL));
		//$this->set("lit_birth_date",$this->getLiteral(UserConst::LIT_BIRTH_DATE));
		$this->set("lit_first_name",$this->getLiteral(UserConst::LIT_FIRST_NAME));
		$this->set("lit_second_name",$this->getLiteral(UserConst::LIT_SECOND_NAME));
		$this->set("lit_language",$this->getLiteral(UserConst::LIT_LANGUAGE));
  	  	
  	  }	
  	  
  	  
  	     /* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   	
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));	
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }

      public function __destruct()
      {
          parent::__destruct();
      }
  }


?>
