<?php
/*
 *                        playlist.php
 *                    ------------------
 * Creado            : 09-jul-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
include_once('modules/browse/ElemMusicMatchUserInfo.php');
require_once('propel/util/Criteria.php');
require_once('modules/emotions/AdminEmotion.php');
require_once('model/om/BasePlaylistHasSongPeer.php');

 class AdminPlayList extends FR_Auth_No {
	
	 const ELEMENT_CLASS = 'Playlist'; 
	 const ELEMENT = 'playlist';
	 
	  public function __construct()
      {
          parent::__construct();
          $this->pagination = new FR_Pagination_MusicElement(self::ELEMENT_CLASS,'playlist',$this->me->getName(),$_GET['criteria']);
      }
      
      public function __default()
      {
      	  $this->screenNew();
      	  $this->getUserPlayList();
      	  $this->tplFile="admin_playlist.tpl";
      }
      
      public function getUserPlayList() {
      	
      	
      if($this->pagination->createPagination(self::ELEMENT,$_GET['criteria'])) {

      	//echo "USERID".$this->session->userID;
      	$matchElemMusic = new ElemMusicMatchUserInfo(self::ELEMENT,FR_Util_Const::CONST_PLAYLIST,$this->session->idioma);
		$userPlaylist = $matchElemMusic->getUserInformation($this->pagination->getObjects(),$this->session->userID);	      	
	
		/* Enviar los resultado de la paginacion a la pantalla */
		
		//print_r($screenAlbums);
	
		/* USER EMOTIONS */
		
			$adminEmotion = new AdminEmotion();
			$rs = $adminEmotion -> getUserEmotions();
			$this->set('userEmotions',$rs);	
			$this->set('screenPlayList',$userPlaylist); /* Informacion del usuario para mostrar.*/
		
		/* Pagination Elements */
				
			$this->set('offsets',$this->pagination->getOffsets());
			$this->set('prev',$this->pagination->getPrev());
			$this->set('next',$this->pagination->getNext());
			$this->set('playAll',$this->pagination->getPlayAll());
		 	$this->set('lit_prev',$this->getLiteral(FR_Util_Literals::LIT_PREV));
	    	$this->set('lit_next',$this->getLiteral(FR_Util_Literals::LIT_NEXT));	
		
		/* LITERALES DE LA PANTALLA */
		
			$this->set("lit_playlists",$this->getLiteral(FR_Util_Literals::LIT_PLAYLISTS));
			$this->set("lit_plays",$this->getLiteral(FR_Util_Literals::LIT_PLAYS));
			$this->set("lit_play",$this->getLiteral(FR_Util_Literals::LIT_PLAY));
			$this->set("lit_last_play",$this->getLiteral(FR_Util_Literals::LIT_LAST_PLAY));	
			$this->set("lit_user",$this->user->name);		
			$this->set("lit_punctuation",$this->getLiteral(FR_Util_Literals::LIT_PUNCTUATION));
		    $this->set("lit_emotions",$this->getLiteral(FR_Util_Literals::LIT_EMOTIONS));
			$this->set("lit_observations",$this->getLiteral(FR_Util_Literals::LIT_OBSERVATIONS));
			$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));			
      }
      else $this->set("message","NO hay playlist!!!falta literal");      	
      
      /* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	//$this->set('3_User_Info_colum','no');
      	
      } 
      
      public function screenNew() {
      	
      	$this->set("lit_new",$this->getLiteral(FR_Util_Literals::LIT_NEW));		/* Literal new */
      	$this->set("lit_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));
      	
      	/* SPECIFIC JAVA SCRIPT FILE */
    	$this->set("js_file",'mod_playlist.js');
      	      	
      }
      
      public function newPlayList() {
      
      try{
      
      	$playList = new Playlist();
      	$playList->setIdmusicelementtype(FR_Util_Const::CONST_PLAYLIST); 
      	$playList->setPlaylistname($_POST['playlist_name']);
      	$playList->setUserid($this->session->userID);
      	$playList->setCreationdate(date("y-m-d"));
      	
      	$playList->save();      	
      	$this->__default();
      	
      }
  	  catch(PropelException $ex){
     	
        $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());   
      	return false;
     } 
      	
      }
      
      /* Editar PlayList */
      public function alterPlayListName() {
      	
      	try {
      		
      		$play_list = PlaylistPeer::retrieveByPK($_GET['idPlayList']);
      		$play_list->setPlaylistname($_POST['playlist_name']);
      		$play_list->save();
      		
      		/* Tornem on estavem */
      		$this->viewPlayList();	      		
      	}
      	catch(PropelException $ex){
     	
        	$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());   
      	return false;      	
       }
     }
     
     private function findElement($array,$elem) {
     	
     			
     		while((list($key,$value)=each($array))) {
     			
     			if($value == $elem) return true;
     			
     		}
     		return false;
     		
     }
     
     /*Borra un grupo de canciones de un playlist*/     
      public function deletePlayListSongs() { 
      	try
      		{
      	
      		$play_list = PlaylistPeer::retrieveByPK($_GET['idPlayList']);		
      		$collPlaylistHasSongs = $play_list->getPlaylistHasSongsJoinSong();    	
      		
      			foreach($collPlaylistHasSongs as $PlaylistHasSongs){							  
				  
				  if ($this->findElement($_POST['selected'],$PlaylistHasSongs->getIdsong())){					
						$PlaylistHasSongs->delete();							
					}				
				}
				$this->setPlayListTrack($_GET['idPlayList']);
				$this->viewPlayList();
      		}
      	   	catch(PropelException $ex){
      		$this->showError(FR_Util_Literals::ERROR_DB.($ex->getMessage()));     
      			return false;;
      		}
      }
      		/*Reassigna los tracks de un playlist */
      		private function setPlayListTrack($idPlaylist) {
      			
      		try{
				$play_list = PlaylistPeer::retrieveByPK($idPlaylist);
				//Recuperar otravez las canciones
				$collPlaylistHasSongs = $play_list->getPlaylistHasSongsJoinSong();				
				$track=0;
				if (is_array($collPlaylistHasSongs)) {
						
						/* Reasignamos el orden de los track.!! */					
						foreach($collPlaylistHasSongs as $PlaylistHasSongs){
							
							$track++;
							$PlaylistHasSongs->setTrack($track);
							$PlaylistHasSongs->save();												
						}
						
					$play_list->setTotalsongs($track);
				}
				else {
					$play_list->setTotalsongs(0);					
				}      		
      		$play_list->save();
      		return true;      		    		
      	}
      	catch(PropelException $ex){
      		$this->showError(FR_Util_Literals::ERROR_DB.($ex->getMessage()));   
      		return false;
      	}      	
      }
      
      /*Borra una unica cancion del playlist*/
      public function deleteSongPlaylist() {
      	
      	try{
      		
      		$play_list = PlaylistPeer::retrieveByPK($_GET['idPlayList']);		
      		$collPlaylistHasSongs = $play_list->getPlaylistHasSongsJoinSong();
      		$findDeleteElem = false; /*Para marcar el elemento a borrar luego tenemos que cambiar el numero de track*/
      		
      		while((list($key,$value)=each($collPlaylistHasSongs))) {
      			
      			if($findDeleteElem) { /*Si hem trobat el element a borrar */
      				
      				$value->setTrack(($value->getTrack()-1));
      				$value->save();
      			}
      			
      			if ($value->getIdsong() == $_GET['idSong']){ /*Si es el element a eliminar borramos */      				
      				$value->delete();
      				$findDeleteElem = true;
      			}    			      			
      		}
      		
      		$play_list->setTotalsongs(($play_list->getTotalsongs()-1));      		
      		$play_list->save();       		
      		$this->viewPlayList();
      		
      	}
      	catch(PropelException $ex){
      		$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());  
      		return false;
      	}
      	
      	
      }
      
      /*Actualiza en base de datos la puntuacion sobre un album*/

public function setPunctuation(){

   try{	
     	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_PLAYLIST);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$_POST['idMusicElement']); /* Usuario ficticio de la aplicacion 1 */
	    $rs = UserUsePlayPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe actualizamos*/
	    	
	    	$userPlay = $rs[0];	    
	    	
	    }
	    else { /* Creas uno de nuevo */
	    	
	       	$userPlay =  new UserUsePlay();
	    	$userPlay->setUserid($this->session->userID);
	    	$userPlay->setIdmusicelementtype(FR_Util_Const::CONST_PLAYLIST);
	    	$userPlay->setIdmusicelement($_POST['idMusicElement']);
	    }  
     	
     	$userPlay->setElempunctuation($_POST['punctuation']); 
     	$userPlay->save();     	
     	unset($userPlay);
 		$this->__default();    	
     }
     catch(PropelException $ex){
     	
     	//echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());
	    unset($userPlay);
      	return false;
     }
}



public function setEmotion() {
	
	 try{	
     	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_PLAYLIST);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		$c -> addAnd(UserUsePlayPeer::IDMUSICELEMENT,$_POST['idMusicElement']); /* Usuario ficticio de la aplicacion 1 */
	    $rs = UserUsePlayPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe, hay que actualizar */
	    	
	    	$userPlay = $rs[0];	    
	    	
	    }
	    else { /* Creas uno de nuevo */
	    	
	       	$userPlay =  new UserUsePlay();
	    	$userPlay->setUserid($this->session->userID);
	    	$userPlay->setIdmusicelementtype(FR_Util_Const::CONST_PLAYLIST);
	    	$userPlay->setIdmusicelement($_POST['idMusicElement']);
	    }  
     	
     	$emotion = EmotionsPeer::retrieveByPK($_POST['idEmotion']);     	
     	$userPlay->setEmotions($emotion); 
     	$userPlay->save();     	
     	unset($userPlay);
 		$this->__default();   	
     }
     catch(PropelException $ex){
     	
     	//echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());
	    unset($userPlay);
      	return false;
     }
	
}
      
      /* Reordenar la sequencia de un playlist segun las preferencias del usuario */
      public function sortPlayListSecuence() {
      	
      	$i=0;
      	foreach($_POST as $key => $idSong){
      	
      		
      		$result = split("_",$key);
      		if($result[0]=="SongTrack"){
      			//echo "<br>SONG.".$idSong;
      			//echo "<br>TRACK.".$_POST['tracks'][$i];
      			$this->setOrderPlayListTrack($_GET['idPlayList'],$idSong,$_POST['tracks'][$i]);
      			$i++;
      		}
      		
      	}
      	$this->viewPlayList();
      }
      
      private function setOrderPlayListTrack($idPlayList,$idSong,$track){
      	
      	try{
      	
      		$c = new Criteria();      			
      		$c -> add(BasePlaylistHasSongPeer::IDPLAYLIST,$idPlayList);//, 
			$c -> addAnd(BasePlaylistHasSongPeer::IDSONG,$idSong);  /* Usuario ficticio de la aplicacion 1 */		
	    	
	    	$rs = BasePlaylistHasSongPeer::doSelect($c);
        
        //print_r($_POST);  
        
	    if (count($rs) > 0 ) { /* Si existe, hay que actualizar */
	    	
	    	$rs[0]->setTrack($track);
	    	$rs[0]->save();	    
	    	
	    }
      		
      	}
       catch(PropelException $ex){
       	
       		return false;
       }
      	
      }
      
     /*VER PLAYLIST */
     
     /* 
      * Muestra un playlist por pantalla 
      * */
      public function viewPlayList() {
      	
      	try{
      		$play_list = PlaylistPeer::retrieveByPK($_GET['idPlayList']);
      		$c = new Criteria();
      		$c -> addAscendingOrderByColumn(BasePlaylistHasSongPeer::TRACK);
      		$collPlaylistHasSongs = $play_list->getPlaylistHasSongsJoinSong($c);
      		
      		/*VARIABLES PANATALLA*/      	
      		$this->set('collPlaylistHasSongs',$collPlaylistHasSongs);      		
      		$this->set('play_list',$play_list);
      		
      		/* LITERALS */
      		$this->set("lit_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));
      		$this->set("lit_back",$this->getLiteral(FR_Util_Literals::LIT_BACK));
      		$this->set("lit_play",$this->getLiteral(FR_Util_Literals::LIT_PLAY));
      		$this->set("lit_alter",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));
      		$this->set("lit_songs",$this->getLiteral(FR_Util_Literals::LIT_SONGS));
      		$this->set("lit_playlists",$this->getLiteral(FR_Util_Literals::LIT_PLAYLISTS));;     		
      		$this->set("lit_eliminar",$this->getLiteral(FR_Util_Literals::LIT_ELIMINAR));
      		$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));		
		    $this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));		    
		    $this->set("lit_seq",$this->getLiteral(FR_Util_Literals::LIT_SEQ));
			$this->set("lit_save",strtoupper($this->getLiteral(FR_Util_Literals::LIT_SAVE)));
			
			//$this->set("lit_view",);
			/* 3 C O L U M N A */
    		$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/
    		$this->set('3_User_Info_colum','si');
			$this->set("id_playlist",$_GET['idPlayList']);
      		
      		$this->set("js_file",'mod_playlist.js');
      		$this->tplFile="view_playlist.tpl";
      		
      	
      	}catch(PropelException $ex){
      		
      		return false;
      	}
      	
      	
      }     
      
      /* STATIC METODS!!! */
      
      public static function getAllUserPlayList($idUser) {
      	
      	try{
      	
      	  $c = new Criteria();
	  	  $c -> add(PlaylistPeer::USERID,$idUser);
	  	  $c -> addAscendingOrderByColumn(BasePlaylistPeer::PLAYLISTNAME);	
		 $rs = PlaylistPeer::doSelect($c);	
		 
		 	if($rs[0]!= null ) return $rs;
		 	else return false;      	
      	
      	}catch(PropelException $ex){
      		
      		return false;
      	}
      }      
      
      public static function addSongsToPlayList($idUser) {
      	
      	try{
      		   		
      		$play_list = PlaylistPeer::retrieveByPK($_POST['idPlayList']); 
      		
      		if($play_list != null ) {      			    		
	      		
	      		
	      		$track = $play_list->getTotalsongs();
	      		if($track == null) $track=1;
	      		else $track++;	      	 
	      	  
	
				foreach($_POST['selected'] as $idSong){					
					
					$playListSong = new PlaylistHasSong();
					$playListSong->setIdsong($idSong);
					$playListSong->setPlaylist($play_list);	
					$playListSong->setTrack($track);	
					$playListSong->save();			
					$track++;
				}
				    
				 $track--;				 
				 $play_list->setTotalsongs($track);
				 $play_list->save();   
	      	    //MINUTES      	    
	      	         	   
	      	   	return true;
      		}
      		else return false;
      		
      	   }catch(PropelException $ex){
      		
      		return false;
      	}
      	
      }
      /* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>