<?php
/*
 *                        play.php
 *                    ------------------
 * Creado            : 20-may-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : SERVIDOR ENCARCADO DE REALIZAR EL STREAMING!!!!
 * 
 */
 
require_once('../../config.php');
require_once('Propel/Propel.php');
require_once('Browser.php');

function __autoload($class)
{  	
  	$type = substr($class,0,2);
  	  
	//echo "<br/>Valor del class: ".$class;	    
	  if("FR" == $type) /* Si es una classe propia del framework hay que cortar*/
	  {
      		$file = str_replace('_','/',substr($class,2)).'.php';      		
	  }
	  else $file = 'model/model/'.$class.'.php'; //PARA los objetos del model
	  	  	  	  
	//echo "<br/> Valor del fichero: ".$file;	   
      require_once(FR_BASE_PATH.'/includes/'.$file);      	  
}


Propel::init(FR_BASE_PATH.'/includes/Object/config.php');


$song_id = FR_Util_Miscelanea::scrub_out($_REQUEST['song']);

if(null == $song_id) {
	
	FR_Util_Logs::streamLogs("The SONG id not is defined");
    exit();	
}
	
$uid = FR_Util_Miscelanea::scrub_out($_REQUEST['uid']); /* usuario que esta realizando el streaming */

if(null == $uid) {
	
	FR_Util_Logs::streamLogs("The USER id not is defined");
    exit();		
}

$sid =  FR_Util_Miscelanea::scrub_out($_REQUEST['sid']); /* Session del usuario que esta realizando el streaming. */

if(null == $sid) {
	
	FR_Util_Logs::streamLogs("The SESSION id not is defined");
    exit();		
}



/* 1. CONTROLAMOS LA EXISTENCIA DE UNA SESSION CORRECTA */

$session = SessionPeer::retrieveByPK($sid);

	if(!is_object($session)) {
		
		FR_Util_Logs::streamLogs("The Session ".$sid." isn't valid");
		exit();	
	}

/* 2. VALIDAR PERMISOS DEL USUARIO QUE HA REALIZADO LA PETICION DE STREAMING */

/* 2.1 Usuario correcto */
	
	$user = UsersPeer::retrieveByPK($uid);
   	
	if(!is_object($user)) {
	
		FR_Util_Logs::streamLogs("User with user id ". $uid ." not exist");
		exit();	
	}
	
/* 2.2 Comprovamos que el usuario tiene permisos esta activo, que no ha sido bloqueado el acceso al sistema. */
			
	if (!$user->getActive()) {
		
	    FR_Util_Logs::streamLogs("User with user id  ". $uid ." doesn't have permison to execute streaming");
		exit();	
	} 



/*
 * 3 CONTROL DE CANCION VALIDA   
 * 3.1 Control que existe la cancion en la base de datos.
 * 3.2 Control que se puede leer el fichero que contien la cancion
 * */
 

//2.1 ---

	$song = SongPeer::retrieveByPK($song_id);
	
	if(!is_object($song)) {
	
		FR_Util_Logs::streamLogs("Not exist SONG with id ". $song_id);
		exit();	
	}	

//2.2 ---
	
	/*Damos el formato necesario pare realizar el streaming*/
	$song->format_song();	
	$file_path =  $song->getUrlfile().'/'.$song->getFilename();


	if (!$file_path OR ( !is_readable($file_path)) ) { 
	
		FR_Util_Logs::streamLogs("Is impossible to read the file song. : ".$file_path); 
		exit(); 
	}
	
	/* Tamanyo de la cancion necesario para informar al programa cliente */		
	$size = $song->getFilesize();


/*Preparacion del fichero que se va enviar para empezar el STREAMING */

set_magic_quotes_runtime(0);

// don't abort the script if user skips this song because we need to update now_playing
ignore_user_abort(TRUE);

$song_name = $song->f_artist_full . " - " . $song->f_title . "." . $song->getFormat();


 
$fp = @fopen($file_path, 'r');

	if (!is_resource($fp)) { 		
		
		FR_Util_Logs::streamLogs("It is imposible to read the file ".$file_path);
		exit();	
	}
	
	/* comprovamos si ya se han enviado */
	
	$startArray = sscanf( $_SERVER[ "HTTP_RANGE" ], "bytes=%d-" );
	$start = $startArray[0];	


	// Generate browser class for sending headers
$browser = new Browser();	
header("Accept-Ranges: bytes");
header("Content-Length:".$size);


// Prevent the script from timing out
set_time_limit(0);			

/* TRATAMIENTO DE LAS CABECERAS */



if ($start) {
		$browser->downloadHeaders($song_name, $song->getMime(), false, $size);
		fseek( $fp, $start );
		$range = $start ."-". $size . "/" . $size;
		header("HTTP/1.1 206 Partial Content");
		header("Content-Range: bytes=".$range);		
}	
else {
		
		$browser->downloadHeaders($song_name, $song->getMime(), false, $size);
}	

/* ACTUALIZAR LA CANCION QUE SE ESTA REPRODUCIENDO */


FR_UserActions::nowPlayingUpdate($uid,$sid,$song_id);
	
       	$bytesStreamed  = 0;
        $minBytesStreamed = $size / 2;

        while (!feof($fp) && (connection_status() == 0)) {
                $buf = fread($fp, 8192);
                print($buf);                               
               $bytesStreamed += strlen($buf);
        }       
	
		/* Una vez acabada la reproduccion gravamos la reproduccion completa en la base de datos */
		if($bytesStreamed == $size )	FR_UserActions::addCountElementPlay($song->getIdmusicelementtype(),$song->getIdsong(),$uid);
		
		/*Borramos la cancion actual que esta reproduciendo usuario */
		FR_UserActions::deleteNowPlaying($uid,$sid);	

@fclose($fp); 
?>

