<?php
/*
 *                        sing.php
 *                    ------------------
 * Creado            : 20-may-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 
 /**
  * Clase que escoje que modelo de archivos va ha ser reproducido:
  * Album,Generos,Artistas, PlayList,
  * */
  
include_once('config.php');  
require_once('stream.php');
require_once('propel/propel.php');
require_once('propel/util/Criteria.php');
require_once('model/om/BasePlaylistHasSongPeer.php');
require_once('model/om/BaseSongPeer.php');
  
class sing extends FR_Auth_No {	  
  
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	      	
      }
      
      /*Reproduce simplemente una cancion */
      public function song() {
      	
      	$songs = array();
      	$song = FR_GetModelObjects::getObjectSong($_GET['id']);
      	if($song instanceof Song) {      		
      		$songs[]=$song;
      		$this->set('name',$song->getSongname());     			
      	}
        $this->initStream($songs);
      	
      }
      
       /* Reproduce un conjunto de albums */
      public function playSongs() {
      		
      	try{
      		$idSongs = $_POST['selected'];
      		$songs =  array();
      		
      		foreach($idSongs as $idSong){
      			
      		   $song = SongPeer::retrieveByPK($idSong);         
	           
	           if($song instanceof Song) {	        		
	        		FR_UserActions::addCountElementPlay($song->getIdmusicelementtype(),$song->getIdsong(),$this->session->userID);
	        		$songs[] = $song;      	
	           }      			
      		}     
      		$today = date(FR_Util_Miscelanea::getFormaDatePlayList($this->session->idioma));
      		$this->set('name','SongSearch_'.$today);  		
      		$this->initStream($songs);	
      		
      	}
      	catch(Exception $ex) {
      		
      		      		
      	}
      	
      }     
      
      /**
       * Reproduce las canciones de un album concreto
       * 
       * */
     public function album() {      	
      
	      try{
	      	
	        $album = AlbumPeer::retrieveByPK($_GET['id'],FR_Util_Const::CONST_ALBUM);
	        
	        if($album instanceof Album) {
	        	
	        	$this->set('name',$album->getAlbumname()); 
	        	/*Augmentem el contador del Album en questio */
	        	$c = new Criteria();
      			$c -> addAscendingOrderByColumn(BaseSongPeer::TRACK);        
	        	FR_UserActions::addCountElementPlay($album->getIdmusicelementtype(),$album->getIdalbum(),$this->session->userID);	        	
	        	$this->initStream($album->getSongs($c));
	        }
	        else{
	         
	         echo "<br/> NO INSTANCIO DE ALBUM";	         
	         return false;	         
	        }
	        
	        
	      }
	      catch(PropelException $ex) {
	      	
	      	echo "<br/> Class: ". $this->me->getName() ." FUNCTION:album ".$ex->getCause();
	      }                
      	
      }
      
      /* Reproduce un conjunto de albums */
      public function playAlbums() {
      		
      	try{
      		$idAlbums = $_POST;
      		$songs =  array();
      		
      		foreach($idAlbums as $idAlbum){
      			
      		   $album = AlbumPeer::retrieveByPK($idAlbum,FR_Util_Const::CONST_ALBUM);         
	           
	           if($album instanceof Album) {	        		
	        		FR_UserActions::addCountElementPlay($album->getIdmusicelementtype(),$album->getIdalbum(),$this->session->userID);
	        		$songs = array_merge($songs,$album->getSongs());        	
	           }      			
      		}     
      		$today = date(FR_Util_Miscelanea::getFormaDatePlayList($this->session->idioma));
      		$this->set('name','AlbumSearch_'.$today);  		
      		$this->initStream($songs);	
      		
      	}
      	catch(Exception $ex) {
      		
      		      		
      	}
      	
      }
      
       /**
       * Reproduce las canciones de un artista concreto
       * 
       * */
      public function artist() {
      	
      try{
	      	
	        //$artist = ArtistPeer::retrieveByPK($_GET['id'],FR_Util_Const::CONST_ALBUM);
	        $artist = ArtistPeer::retrieveByPK($_GET['id']);
	        if($artist instanceof Artist) {
	        	
	        	$this->set('name',$artist->getArtistname()); 
	        	/*Augmentem el contador del Artista en questio */      
	        	FR_UserActions::addCountElementPlay($artist->getIdmusicelementtype(),$artist->getIdartist(),$this->session->userID);
	            $c = new Criteria();
      			$c -> addAscendingOrderByColumn(BaseSongPeer::TRACK);  
	        	$this->initStream($artist->getSongs($c));
	        }
	        else{
	         
		         echo "<br/> NO INSTANCIO DE ALBUM";	         
		         return false;
	         
	        }
	        
	        
	      }
	      catch(PropelException $ex) {
	      	
	      	echo "<br/> Class: ". $this->me->getName() ." FUNCTION:artist ".$ex->getCause();
	      }  
                
      }
      
      public function playArtists() {
      		
      	try{
      		$idArtists = $_POST;
      		$songs =  array();
      		
      		foreach($idArtists as $idArtist){
      			
      		   $artist = ArtistPeer::retrieveByPK($idArtist);         
	           
	           if($artist instanceof Artist) {	        		
	        		FR_UserActions::addCountElementPlay($artist->getIdmusicelementtype(),$artist->getIdartist(),$this->session->userID);
	        		$songs = array_merge($songs,$artist->getSongs());        	
	           }      			
      		}     
      		$today = date(FR_Util_Miscelanea::getFormaDatePlayList($this->session->idioma));
      		$this->set('name','ArtistSearch_'.$today);  		
      		$this->initStream($songs);	
      		
      	}
      	catch(Exception $ex) {
      		
      		      		
      	}
      	
      }    
      
           
      
      /**
       * Reproduce las canciones de un genero especfico
       * 
       * */
      public function genere() {
      	
       try{
	      	
	        $genere = GenerePeer::retrieveByPK($_GET['id']);
	        
	        if($genere instanceof Genere) {
	        	
	        	$this->set('name',$genere->getGenerename()); 
	        	/*Augmentem el contador del album en questio */      
	        	FR_UserActions::addCountElementPlay($genere->getIdmusicelementtype(),$genere->getIdgenere(),$this->session->userID);
	            $c = new Criteria();
      			$c -> addAscendingOrderByColumn(BaseSongPeer::TRACK); 
	        	$this->initStream($genere->getSongs($c));
	        }
	        else{	         
	     	         
	         return false;
	         
	        }
	        
	        
	      }
	      catch(PropelException $ex) {
	      	
	      	echo "<br/> Class: ". $this->me->getName() ." FUNCTION: Genere".$ex->getCause();
	      }       	
	
}


		public function playGeneres() {
      		
      	try{
      		$idGeneres = $_POST;
      		$songs =  array();
      		
      		foreach($idGeneres as $idGenere){
      			
      		   $genere = GenerePeer::retrieveByPK($idGenere);         
	           
	           if($genere instanceof Genere) {	        		
	        		FR_UserActions::addCountElementPlay($genere->getIdmusicelementtype(),$genere->getIdgenere(),$this->session->userID);
	        		$songs = array_merge($songs,$genere->getSongs());        	
	           }      			
      		}     
      		$today = date(FR_Util_Miscelanea::getFormaDatePlayList($this->session->idioma));
      		$this->set('name','GenereSearch_'.$today);  		
      		$this->initStream($songs);	
      		
      	}
      	catch(Exception $ex) {
      		
      		      		
      	}
      	
      }
      
      /* Reproduce las canciones associadas a las emociones de los usuarios.*/
      public function emotions() {
      
      /* Hay que recuperar las canciones a reproducir*/      	
      	$songs = array();
      	$user_use_differentEmotion = array();      	
      try{			
      		$emotion = EmotionsPeer::retrieveByPK($_POST['idEmotion']);
      	    $e_searchs = $emotion->getEmotionSearchs();
   		    
   		    $emotion_search = $e_searchs[0];
   		    $maxSong = $emotion_search->getMaxsongs();
   		   
      		$emotionSongs = FR_GetModelObjects::getObjectUserUsePlayNotEmotion($_POST['idEmotion'],$this->session->userID);
      		
      		//echo "<br>ResultadoConsulta:".count($emotionSongs);
      		
      		$this->differentEmotionSongs($emotionSongs,$user_use_differentEmotion); /*Iniciamos el vector con emociones differentes.*/
      		$countSongs=0;
      		
      		$postLenght = count($_POST);
      		$final = false;	
      		
      		while((list($key,$value)=each($_POST)) && (!$final)){
      		    			
      			
      			$result = split("-",$value);      			  
      		
      			 			
      		if(($countSongs < $maxSong) || ($maxSong == 0)){	
      			
      			if("Song" == $result[0]) {
      				
      				$song = FR_GetModelObjects::getObjectSong($result[1]);
      				if($song instanceof Song) {
      					
      					if(!$this->differentEmotion($user_use_differentEmotion,$song->getIdsong())){
      						if(!array_key_exists($song->getIdsong(),$songs)){
      							$songs[$result->getIdsong()] = $result;
      							$countSongs=$countSongs+1;
      						}	
      					}      					
      				}     				
      			}
      			if("Artist" == $result[0]) {
      				
   	    			$artist = FR_GetModelObjects::getObjectArtist($result[1]);
			    	if($artist instanceof Artist) 
			    	{
			    		$aux_songs = $artist->getSongs();
			    		$this->insertSongs($songs,$aux_songs,$user_use_differentEmotion,$maxSong,$countSongs);
			    	}				
      				
      			}
      			if("Album" == $result[0]) {
      				
      				$album = FR_GetModelObjects::getObjectAlbum($result[1]);
			    	if($album instanceof Album) 
			    	{
			    		$aux_songs = $album->getSongs();
			    		$this->insertSongs($songs,$aux_songs,$user_use_differentEmotion,$maxSong,$countSongs);
			    	}     				
      			}
      			if("Genere" == $result[0]){
      				
      				$genere = FR_GetModelObjects::getObjectGenere($result[1]);
			    	if($genere instanceof Genere) 
			    	{
			    		$aux_songs = $genere->getSongs();
			    		$this->insertSongs($songs,$aux_songs,$user_use_differentEmotion,$maxSong,$countSongs);
			    	}	
      				
      			}
      			//if("PlayList" == $result[0])
      			
      			
      			 	
      		  }//if de control maximo de canciones
      		  else $final=true;//avortamos el bucle cuando hemos encontrado el nmero maximo de canciones
      		  
      	
      		}
      		
      		/*foreach($songs as $song){
      			
      			echo"<br/>ID:".$song->getIdsong();
      			echo"<br/>NAME:".$song->getSongname();  
      			echo "<br/>---";    			
      		} */   
      		 
      		
      		$this->set('name',$emotion->getEmotionname()); 
      	    $this->initStream($songs);	
      	}
        catch(PropelException $ex) {
	     		echo "<br/> Class: ". $this->me->getName() ." FUNCTION: emotions".$ex->getCause();
	     } 
      }
      
       /**
       * Play the songs from my favourite playlist  
       * */
      public function playlist() {     	
      	
      	try{
      	
      	   	$play_list = PlaylistPeer::retrieveByPK($_GET['id']); 
      	   	 $c = new Criteria();
      		$c -> addAscendingOrderByColumn(BasePlaylistHasSongPeer::TRACK);    		
      		$collPlaylistHasSongs = $play_list->getPlaylistHasSongsJoinSong($c);
      		$songs= $this->getSongsFromPlayListHasSongs($collPlaylistHasSongs);
      		
      		$this->set('name',$play_list->getPlaylistname()); 
	        /*Augmentem el contador del album en questio */      
	        FR_UserActions::addCountElementPlay($play_list->getIdmusicelementtype(),$play_list->getIdplaylist(),$this->session->userID);
	        $this->initStream($songs);      		
      	}
      	catch(PropelException $ex) {
	     		return false;
	    } 
      	
      }
      
      /*
       * Recupera las canciones de los elementos musicales que ha seleccionado el
       * usuario al visualizar el evento de la agenda.
       * TPL =  admin_agenda.tpl      
       * */
      public function observations(){
      	
      	try{
      		
      		$observation = ObservationsPeer::retrieveByPK($_GET['id']);
      		$songs = $this->SearchSongsFromSelectedElements();
      		
      		if($songs){
      			$this->set('name',$observation->getObservationtitle()); 
      	 		$this->initStream($songs);
      		}
      		return false;
      		
      	}
      	catch(PropelException $ex) {
      		
      		return false;
      	}
      	
      }
      
      public function searchElements() {
      	
      	try{
      	
      		$songs = $this->SearchSongsFromSelectedElements();
      		
      		if($songs){
      			$this->set('name',$_GET['str_search']); 
      	 		$this->initStream($songs);
      		}
      		return false;
      	
      	
      	}
      	catch(PropelException $ex) {
      		
      		return false;
      	}
      	
      }
      
      
      /**
       * Selecciona las canciones de los elementos musicales seleccionados por el usuario.
       * Cuando a realizado una busqueda de canciones por observaciones.       * 
       * */
      private function SearchSongsFromSelectedElements() {
      
      	try{      		
      		      		
      		$songs = array();
      		while((list($key,$value)=each($_POST))) {     			
      		
      			$result = split("-",$value); 
      			
      			
      		if("Song" == $result[0]) {
      				
   				$song = FR_GetModelObjects::getObjectSong($result[1]);
      			if($song instanceof Song) $songs[] = $result;     				     				
      		}
      		if("Artist" == $result[0]) {
      			$artist = FR_GetModelObjects::getObjectArtist($result[1]);
			    	if($artist instanceof Artist) 
			    	{
			    		$this->insertSimpleSongs($songs,$artist->getSongs());
			    		
			    	}  				
      		}
      		if("Album" == $result[0]) {
      				
      			$album = FR_GetModelObjects::getObjectAlbum($result[1]);
			    if($album instanceof Album) 
			    {
			    	$this->insertSimpleSongs($songs,$album->getSongs());	    		
			    }     				
      		}
      		if("Genere" == $result[0]){
      				
      				$genere = FR_GetModelObjects::getObjectGenere($result[1]);
			    	if($genere instanceof Genere) 
			    	{
			    		$this->insertSimpleSongs($songs,$genere->getSongs());
			    		
			    	}     			
      		}
      		if("PlayList" == $result[0]){      				
      				$playList = FR_GetModelObjects::getObjectPlayList($result[1]);
			    if($playList instanceof PlayList) 
			    {
			    		$this->insertSimpleSongs($songs,$playList->getSongs());
			    		
			    }   			
      		}     			
      	 }// fin de while 
      	  
      	 //$this->initStream($songs);	   
      	 return $songs;  		
      	}	
      	catch(PropelException $ex) {
	     		return false;
	    }
      	
      }
      
      /* Crear una llista de reproduccio aparti dalgunes de les cansons d'unplaylist'*/
      public function songsPlaylist() {
      	
      	try{		
      			$songs = array();
      			$play_list = PlaylistPeer::retrieveByPK($_GET['id']); 	
      			foreach($_POST['selected'] as $idSong){					
					
					$song = SongPeer::retrieveByPK($idSong);	        
	        		if($song instanceof Song) $songs[]=$song;
      			}
      			
      			$this->set('name',$play_list->getPlaylistname()); 
	        /*Augmentem el contador del album en questio */      
	        FR_UserActions::addCountElementPlay($play_list->getIdmusicelementtype(),$play_list->getIdplaylist(),$this->session->userID);
	        $this->initStream($songs);
      	}
      	catch(PropelException $ex) {
	     		return false;
	    } 
			
      	
      }
      
      /*Coje las canciones que estan en el objeto PlayListHasSongs */
      
      private function getSongsFromPlayListHasSongs($collPlaylistHasSongs) {
      	
      	$songs = array();
      	
      	foreach($collPlaylistHasSongs as $PlaylistHasSongs) {
      		
      		$songs[]=$PlaylistHasSongs->getSong();
      	}
      	return $songs;
      }
      
      /*Reproduce una lista de canciones seleccionadas por un usuario*/
      public function playListOfSongs() {
      
      try{	
	      	$songs = array();
	      	$album = AlbumPeer::retrieveByPK($_GET['id'],FR_Util_Const::CONST_ALBUM);
	      	
	      	foreach($_POST['selected'] as $idSong){					
					
				$song=FR_GetModelObjects::getObjectSong($idSong);
				if($song instanceof Song) $songs[] = $song;
	
			}		
				$this->set('name',$album->getAlbumname()); 
		        /*Augmentem el contador del Album en questio */      
		        FR_UserActions::addCountElementPlay($album->getIdmusicelementtype(),$album->getIdalbum(),$this->session->userID);
		        $this->initStream($songs);
		         
      	}catch(PropelException $ex) {
	     		return false;
	    }   	
      }
      
      /**
       * Play random songs.       *  
       * */
      public function random() {
      	
      }
      
      /**
       * It initialice the values to start the streaming.
       * @param Canco $cancons. It is the songs collection witch will be played. 
       * */
private function initStream(&$songs) {
      	
 $conf = include('stream_config.php');
         
      $stream_type = $conf['playlist_type'];      
          	     	
      	/*      	 
      	CUANDO TENGA LOS USUARIOS AADIR EL TIPO DE STREAMING QUE QUIEREN
      	 
		if ($user->prefs['play_type'] != "stream" AND $user->prefs['play_type'] != "downsample") { 
			$stream_type = $user->prefs['play_type'];
		}
		*/
		
    	$stream = new Stream($stream_type,$songs,$this->session->userID);
		$music_list = $stream->start();				
		
		//Cambiamos la vista de resultado, descargar un playlist.
		$this->presenter = 'playlist';			
      	$this->set('music_list',$music_list);    	
      	
}

/*
 * Inserta canciones sin que haya canciones duplicadas
 *  
 * */
private function insertSongs(&$songs,$aux_songs,$user_use_differentEmotion,$maxSong,&$countSongs){

foreach($aux_songs as $song) {
	
	if($countSongs<$maxSong || ($maxSong == 0)){			
		
		if(!$this->differentEmotion($user_use_differentEmotion,$song->getIdsong())){
			if(!array_key_exists($song->getIdsong(),$songs)){
				$songs[$song->getIdsong()] = $song;
				$countSongs=$countSongs+1;	
			}	
		}
		
	}
	else return false;
	//echo "<br/>".$song->getIdsong();
} 
}//fin de insertSongs
/*
 * Copia un vector de canciones al grande  
 * */
 
private function insertSimpleSongs(&$songs,$aux_songs) {
	
	foreach($aux_songs as $song){
		
		$songs[]=$song;
	}
}	

	



/*  
 *Inicializa el vector con las canciones que tienen emociones diferentes a la actual. *
 */
private function differentEmotionSongs($emotionSongs,&$user_use_differentEmotion) {
	
	foreach($emotionSongs as $emotSong) {		
		$user_use_differentEmotion[$emotSong->getIdMusicElement()] = $emotSong;		
	}

	//print_r($user_use_differentEmotion);

}

/*
 * Si la cancion se encuentra definida en el vector de emociones diferentes
 * entonces devuelve true, es una emocion diferente
 * */
private function differentEmotion(&$user_use_differentEmotion,$idSong) {
	
	
	if(is_object($user_use_differentEmotion[$idSong])){
	    
	    //echo "--IDEMOTION".$user_use_differentEmotion[$idSong]->getIdemotion();
		return true;	
	}
	else return false;
	
}


      
public function __destruct()
{
          parent::__destruct();
}
	
}
?>