<?php
/*
 *                        stream.php
 *                    ------------------
 * Creado            : 20-may-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 /*

 Copyright (c) 2001 - 2006 Ampache.org
 All rights reserved.  

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

*/

/*!
	@header Stream Class
*/

class Stream {

	/* Variables from DB */
	public $type;
	public $web_path;
	public $songs = array();
	public $sess;

	/*!
		@function stream 
		@discussion constructor for the stream class
	*/
	public function __construct($type='m3u', $songs, $user_ID) {

	
		$this->type = $type;
		$this->songs = $songs;
		$this->web_path = WEB_PATH;

		
	    $this->sess = session_id();
		$this->user_id = $user_ID;

	} //constructor

	/*!
		@function start
		@discussion runs this and depending on the type passed it will
			call the correct function
	*/
public function start() {

		$methods = get_class_methods('Stream');
		$create_function = "create_" . $this->type;	
                if (in_array($create_function,$methods)) {
	               return  $this->{$create_function}();
                }
		// Assume M3u incase they've pooched the type
		else { 
			return $this->create_m3u();
		}
} // start

	/*!
		@function create_simplem3u
		@discussion this creates a simple m3u
			without any of the extended information
	*/
public function create_simple_m3u() {

		foreach ($this->songs as $song_id) { 
			$song = new Song($song_id);
			if ($song->type == ".flac") { $song->type = ".ogg"; }
                        if($GLOBALS['user']->prefs['play_type'] == 'downsample') {
                                $ds = $GLOBALS['user']->prefs['sample_rate'];
                        }			
			echo "$this->web_path/play/index.php?song=$song_id&uid=$this->user_id&sid=$this->sess&ds=$ds&stupidwinamp=." . $song->type . "\n"; 
		} // end foreach

	} // simple_m3u

	/*!
		@function create_m3u
		@discussion creates an m3u file
	*/
	public function create_m3u() { 
	        // Send the client an m3u playlist	        
	        	        
	        $m3u =  "#EXTM3U \n";
	        foreach($this->songs as $song) {
	        	                 
	          $song->format_song(); /* Hay que darle a la cancion el formato correcto */
	          $song_id = $song->getIdSong();
			
			
	          $song_name = $song->f_artist_full . " - " . $song->f_title . "." . $song->getFormat();	          
	  
	          $m3u .= "#EXTINF:$song->f_time,$song_name\n";
	           //$sess = $_COOKIE[libglue_param('sess_name')];
	           /*
	          if($GLOBALS['user']->prefs['play_type'] == 'downsample') {
	                	$ds = $GLOBALS['user']->prefs['sample_rate'];
			   }*/		   
			   			   
            $ds="";                        
            //echo "$this->web_path/play/index.php?song=$song_id&uid=$this->user_id&sid=$this->sess&ds=$ds&name=/" . rawurlencode($song_name) . "\n";                        
            $m3u .= "$this->web_path/modules/streaming/play.php?song=$song_id&uid=$this->user_id&sid=$this->sess&ds=$ds&name=/" . rawurlencode($song_name) . "\n";
              
        }// end foreach
	
		return $m3u;

	} // create_m3u
	

 
 
}
?>